C -- STEM INTEGRATION WITH LSODES.F --
        PROGRAM STEM
       INCLUDE 'agg.h'

C --- PARAMETERS (FULL JACOBIAN)
        PARAMETER ( LRW=20+3*1500+16*NVAR )
        PARAMETER ( LIW=60 )

C --- DECLARATIONS
        REAL*8 RWORK(LRW),IWORK(LIW)
        EXTERNAL FUN,JAC
        REAL*8 VMIN(NVAR)
        DATA VMIN/5.9e+10,1.8e+09,2.8e+08,
     *  5.0e+09,6.1e+00,1.0e-04,
     *  1.0e-04,2.5e+09,4.3e+01,1.0e-04,1.5e+05,2.5e+10,
     *  1.0e-04,6.6e+07,1.0e-04,1.1e+04,3.2e+04,5.2e+07,
     *  1.7e+02,5.4e+04,2.8e+06,4.6e+05,4.5e+09,1.5e-01,
     *  1.0e-04,9.1e+07,5.0e+07,1.0e-04,6.3e+05,1.1e-02,
     *  1.0e-04,1.8e+08,4.9e+12,6.6e+03,4.1e+04,5.0e+06,
     *  2.5e+10,8.2e+05,1.0e-04,2.1e+10,1.0e-04,9.2e+08,
     *  9.6e+05,1.5e+06,7.7e+08,3.2e+07,1.0e-04,1.4e+10,
     *  2.5e+09,1.0e-04,2.1e+08,3.1e+02,5.6e+04,1.1e+12,
     *  4.3e+07,2.5e+09,1.0e+03,5.1e+08,1.0e-04,2.1e+03,
     *  8.8e+04,5.1e+05,5.7e+03,2.7e+01,4.9e+09/

        N=NVAR
        write(6,*) 'LSODES. Rtol='
        read(5,*) rtols

        dt = 3600.
        idir = 0
        iopt = 0
C        rwork(8) = seth  ! Threshold factor
C        iwork(5) = 5      ! Max order
C        iwork(6) = 200000
        itask = 1
        istate = 1
        MF = 121

C ==== initial values ====
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
        


C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- REQUIRED TOLERANCE, scalar ATOL (itol = 2), vector ATOL (itol = 2)
       do i=1,NVAR
         ATOL(i) = dmax1(1.0d-1, 0.01*rtols*vmin(i))
         RTOL(i) = rtols
       end do 
       ITOL=4
C ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
        iopt=0

C --- OUTPUT FILE ----
c2       OPEN(UNIT=10,FILE='Lsodes.m')


       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
c2        write(10,99) 0., (Var(i), i=1,nvar)

        DIV = 3600./DT

        DO WHILE (TIME.LT.TEND)

C --- Add emissions
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.05* CFACTOR /DIV

       
       if (idir.eq.0) istate=1

      CALL lsodes (FUN, NVAR, VAR, TIME, TIME+DT,  
     *            itol, rtol, atol, itask, istate, 
     *            iopt, rwork, lrw, iwork, liw, JAC, mf)
     
       if (istate.lt.0) then
         print *,'LSODES Error : istate = ',istate
         stop
       end if  
      
C --- PRINT  SOLUTION
        if (time.le.tend) then
c2        write(10,99) (TIME-Tstart)/3600.D0, (Var(i), i=1,nvar)
        end if
        percent=100.D0*(time-tstart)/(tend-tstart)
c2        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',F12.5)       
 99     FORMAT(100(X,E24.16))
         END DO



C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C


        SUBROUTINE FUN (N, T, V, FCT)
       INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JV, j, ian, jan)
       INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR)
        INTEGER j, ian(1), jan(1)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD

        DO ii=1,NVAR
          DO jj=1,NVAR
              JV(ii,jj) = 0.
          END DO 
        END DO 
        CALL JACVAR(V, Rad, JV)

        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 
