C**************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- STEM INTEGRATION WITH VODE.F --
        PROGRAM STEM
      INCLUDE 'agg.h'
C --- PARAMETERS (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LRW=6*ND*ND+9*ND+25,LIW=ND+35)
        PARAMETER (LRCONT=4*ND+4+10)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION RWORK(LRW),IWORK(LIW)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN, JAC
        DIMENSION VMIN(ND)
        DATA VMIN/ 5.9e+10,1.8e+09,2.8e+08,
     *  5.0e+09,6.1e+00,1.0e-04,
     *  1.0e-04,2.5e+09,4.3e+01,1.0e-04,1.5e+05,2.5e+10,
     *  1.0e-04,6.6e+07,1.0e-04,1.1e+04,3.2e+04,5.2e+07,
     *  1.7e+02,5.4e+04,2.8e+06,4.6e+05,4.5e+09,1.5e-01,
     *  1.0e-04,9.1e+07,5.0e+07,1.0e-04,6.3e+05,1.1e-02,
     *  1.0e-04,1.8e+08,4.9e+12,6.6e+03,4.1e+04,5.0e+06,
     *  2.5e+10,8.2e+05,1.0e-04,2.1e+10,1.0e-04,9.2e+08,
     *  9.6e+05,1.5e+06,7.7e+08,3.2e+07,1.0e-04,1.4e+10,
     *  2.5e+09,1.0e-04,2.1e+08,3.1e+02,5.6e+04,1.1e+12,
     *  4.3e+07,2.5e+09,1.0e+03,5.1e+08,1.0e-04,2.1e+03,
     *  8.8e+04,5.1e+05,5.7e+03,2.7e+01,4.9e+09/

        print *, 'RTOL=' 
        read(5,*) rtols
        
        DT = 3600.
        MF = 21
        N = NVAR
        idir = 0

        do i=1,n
          ATOL(i)=DMAX1(1.0D-1, 1.0D-2*rtols*VMIN(i) )
          RTOL(i)=rtols
        end do  
        ITOL=4
        
        
C ==== initial values ====
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
        
        
      
C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
        iopt=1
        IWORK(6) = 20000  
        RWORK(6) = 100000.   ! STEP MAX
        RWORK(7) = 0.0       ! STEP MIN
        RWORK(5) = 0.0       ! INITIAL STEP
        IWORK(5) = 5         ! MAX ORD

C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Vode.m')


       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS
        write(10,99) 0., (Var(i), i=1,nvar)

        DIV = 3600./DT

        DO WHILE (TIME.LE.TEND)

C --- Add emissions
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.05* CFACTOR /DIV



C --- CALL OF THE SUBROUTINE VODE
       
       if (idir.eq.0) istate=1
       
       CALL dvode (FUN, N, Var, TIME, TIME+DT, itol, rtol, atol,
     1             itask, istate, iopt, rwork, lrw, 
     2             iwork, liw, JAC, mf,rpar,ipar)

       IF (ISTATE.LT.0) THEN
          WRITE(6,*) 'VODE WARNING: ISTATE = ',ISTATE
       END IF   
C --- PRINT  SOLUTION
       if (time.le.tend) then
       HOURS = (TIME-tstart)/3600.D0
       IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
         write(10,99) (TIME-Tstart)/3600.D0, (Var(i), i=1,nvar)
       END IF
       end if
 95     format(F5.1,'hrs. O3=',E24.16)       
 99     FORMAT(100(X,E24.16))
 101    format(E24.16,E24.16,x,I4,x,E24.16)
         END DO
 
C
C --- PRINT STATISTICS
        WRITE (6,90) real(iwork(21))/iwork(11)*100.,
     *              real(iwork(22))/iwork(11)*100.
 90     FORMAT(F9.3,' % conv, ',F9.3,'% err failures')
        CLOSE(10)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT, rpar, ipar)
      INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR), rpar(*)
        integer ipar(*)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, ML, MU, JV, NROWPD, RPAR, IPAR)
      INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR), rpar(*)
        integer ipar(*)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        DO i=1,nvar
           DO j=1,nvar
              JV(i,j) = 0.
           END DO
        END DO      
        CALL JACVAR(V, Rad, JV) 
        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 
