      program STIFFACC
 
      INCLUDE 'sparse.h'
      external FUN, JAC_SP
      DIMENSION  ATOL(NVAR), RTOL(NVAR)
      DIMENSION VMIN(NVAR)
      INTEGER INFO(4)
      DATA VMIN/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/
    
      write(6,*) 'Rosenbrock 3(2). RTOL=, Urban='
      read(5,*) rtols, IS_URBAN

      DT = 3600.
        DO i=1,NVAR
          ATOL(i)=dmax1( 1.0D-2, 1.0D-2*rtols*vmin(i) )
          RTOL(i)=rtols
        END DO  
       
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF
      
      
           
C **********************************************
      open(10, file='Ros3.m')


C ---- TIME VARIABLES ------------------      
      TSTART = 3600*12
      TEND  = TSTART + 3600*24*5
      Hmin  = 1.0
      Hmax  = DT



C ********** TIME LOOP *************************
      T = TSTART
      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(T.lt.TEND)      
        HT=T/3600
        
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR   /DIV
      END IF
      
      call ANDREEA(nvar,t,t+DT,0.1D0,Hmin,Hmax,
     +                   Var, atol, rtol,
     +                   Info,FUN,JAC_SP)


       
C ---- PRINT VALUES NT TIMES HOURLY ----
      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar) 
      write(6,886) (T-tstart)/3600.D0,Var(I_O3)/CFACTOR,
     *        DT/(info(3)+info(4))
      end do
C *********** END TIME LOOP ********
      close(10)
      STOP
886   FORMAT(F5.1,' hrs. O3 = ',F9.4,' ppb.    Mean step = ',F7.1)      
991   FORMAT(100(X,E24.16))
      END

        SUBROUTINE FUN(N, T, Y, P)
        INCLUDE 'sparse.h'
        REAL*8 T, Told
        REAL*8 Y(NVAR), P(NVAR)

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL F_VAR( Y, RAD, P )
        TIME = Told
        RETURN
        END

        SUBROUTINE JAC_SP(N, T, Y, J)
        INCLUDE 'sparse.h'
        REAL*8 Told, T
        REAL*8 Y(NVAR), J(LU_NONZERO_V)

        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        CALL JACVAR_SP( Y, RAD, J )
        TIME = Told
        RETURN
        END
    



      subroutine ANDREEA(N,T,Tnext,H,Hmin,Hmax,
     +                   y,atol,rtol,
     +                   Info,FUN,JAC_SP)
      include 'sparse_s.h'

      real*8     K1(NVAR), K2(NVAR), K3(NVAR), K4(NVAR)
      real*8     F1(NVAR), JAC(lu_nonzero_v)
      real*8     atol(nvar), rtol(nvar) 
      real*8     Hmin,Hmax,ghinv,uround
      real*8     y(nvar),ynew(nvar)
      real*8     T, Tnext, H, Hold, Tplus
      real*8     ERR, ERRold, factor, facmax
      integer    n,nfcn,njac,Naccept,Nreject,i,j
      integer    Info(4)
      logical    IsReject,Autonom
      external   FUN, JAC_SP


c     Initialization of counters, etc.
      Autonom = .TRUE.
      uround = 1.d-15
      c43 = - 8.d0/3.d0 
      H = DMAX1(1.d-8, Hmin)
      Tplus = T
      IsReject = .false.
      Naccept  = 0
      Nreject  = 0
      Nfcn     = 0
      Njac     = 0


      do while ( T .lt. Tnext )   
   
 101   Tplus = T + H
       if ( Tplus .gt. Tnext ) then
          H = Tnext - T
          Tplus = Tnext
       end if

       call JAC_SP(NVAR, T, y, JAC)
       Njac = Njac+1
       gHinv = -2.0d0/H
       do j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) + gHinv
       end do
       call DECOMP (nvar, JAC, ier)

       if (ier.ne.0) then
         if ( H.gt.Hmin) then
            H = 0.5*H
            go to 101
         else
            print *,'IER <> 0, H=',H
            stop
         end if      
       end if  
       
       call FUN(NVAR, T, y, F1)

C ====== NONAUTONOMOUS CASE ===============
       IF (.not. Autonom) THEN
         tau = dsqrt( uround*dmax1( 1.0d-5, dabs(T) ) )
         call FUN(NVAR, T+tau, y, K2)
         nfcn=nfcn+1
         do j = 1,NVAR
           K3(j) = ( K2(j)-F1(j) )/tau
         end do
C ----- STAGE 1 (NONAUTONOMOUS) -----
         x1 = 0.5*H
         do j = 1,NVAR
           K1(j) =  F1(j) + x1*K3(j) 
         end do
         call SOLVE (JAC, K1)
C ----- STAGE 2 (NONAUTONOMOUS) -----
         x1 = 4.d0/H
         x2 = 1.5d0*H
         do j = 1,NVAR
           K2(j) = F1(j) - x1*K1(j) + x2*K3(j)
         end do
         call SOLVE (JAC, K2)

C ====== AUTONOMOUS CASE ===============
       ELSE
C ----- STAGE 1 (AUTONOMOUS) -----
         do j = 1,NVAR
           K1(j) =  F1(j) 
         end do
         call SOLVE (JAC, K1)
      
C ----- STAGE 2 (AUTONOMOUS) -----
         x1 = 4.d0/H
         do j = 1,NVAR
           K2(j) = F1(j) - x1*K1(j) 
         end do
         call SOLVE (JAC, K2)
       END IF
       
C ----- STAGE 3 -----
       do j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) 
       end do
       call FUN(NVAR, T+H, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K3(j) = F1(j) + ( -K1(j) + K2(j) )/H
       end do
       call SOLVE (JAC, K3)

C ----- STAGE 4 -----
       do j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) - K3(j)
       end do
       call FUN(NVAR, T+H, ynew, F1)
       nfcn=nfcn+1
       do j = 1,NVAR
         K4(j) = F1(j) + ( -K1(j) + K2(j) - C43*K3(j)  )/H
       end do
       call SOLVE (JAC, K4)

C ---- The Solution ---

       do j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) - K3(j) - K4(j) 
       end do


C ====== Error estimation ========

        ERRold=ERR
        ERR=0.
        do i=1,NVAR
           ytol = ATOL(i) + RTOL(i)*dabs(ynew(i))
           ERR = ERR + ( K4(i)/ytol )**2
        end do       
        ERR = DMAX1( uround, DSQRT( ERR/NVAR ) )

C ====== Choose the stepsize ==============================

        factor = 0.9/ERR**(1.d0/3.d0)
        if (IsReject) then
            facmax=1.0
        else
            facmax=10.0
        end if 
        factor = DMAX1( 1.0D-1, DMIN1(factor,facmax) )
        Hold = H
        H = DMIN1( Hmax, DMAX1(Hmin,factor*H) )    

C ======= Rejected/Accepted Step ============================

        if ( (ERR.gt.1).and.(Hold.gt.Hmin) ) then
          IsReject=.true.
          Nreject = Nreject+1
        else
          IsReject=.false.
          do i=1,NVAR
             y(i) = ynew(i)
          end do  
          T = Tplus     
          Naccept = Naccept+1
        end if
      end do
      
C ======= Output Information =================================
      Info(1) = Nfcn
      Info(2) = Njac
      Info(3) = Naccept
      Info(4) = Nreject
      
      RETURN 
      END        
C End of INTEGRATE function                                        
C **************************************************************** 

