% Twostep Seidel, stepmin=0.1 sec, noise=1
rts = [0.86  1.52  0.75
       1.12  1.80  0.97
       1.84  2.53  1.80
       2.17  2.86  2.41
       2.97  3.66  4.71
       3.36  4.05  6.34
       4.37  5.02  12.8];
      
% Twostep Jacobi, stepmin=1.d-2, noise=1 
rtj = [0.52  1.15  0.85
       0.71  1.37  1.06
       1.30  1.98  1.97
       1.57  2.26  2.63
       2.23  2.80  5.37
       2.46  2.95  7.01
       2.46  3.05  13.8];
      

      
% ATMVODE, noise=1, stepmin=1.e-3, adjusted tolerances
rat = [0.45  1.60  0.94
       0.83  1.79  1.03
       1.65  2.57  1.29
       2.05  2.84  1.36
       2.62  3.55  1.86
       2.77  3.73  2.05
       3.10  4.14  3.42
       4.35  5.28  4.60];
      
% SDIRK, stepmin = 1.0, noise=1
rsd = [0.16  1.20  1.14
       2.14  3.19  1.73
       2.50  3.50  1.86
       3.36  4.25  2.50
       3.77  4.61  2.81
       4.40  5.17  3.78];
            
% RODAS, norm 2, stepmin=0.1, noise=1
rro = [0.00  0.43  0.97
       2.37  3.49  1.34
       2.67  3.80  1.50
       3.88  4.75  1.80
       4.82  5.69  2.74];
      
       
%  LSODES
lso = [0.83  1.44  1.42
       0.97  1.57  1.55
       1.50  2.40  1.92
       1.85  2.80  2.15
       2.60  3.40  2.61
       2.85  3.70  3.59
       3.78  4.55  6.25];
       
% Rosenbrock, complex, 1-stage, order 2, stepmin 0.1 sec
rc2 = [0.60  1.40  1.78
       0.75  1.59  2.07
       1.09  1.96  2.78
       1.17  2.08  3.63
       1.62  2.59  6.20
       1.71  2.73  8.15
       2.25  3.27  16.0];
       
% Rosenbrock-W, real, two-stage, order 2, stepmin 0.1 sec
rwr22=[0.41  1.44  0.93
       0.91  2.04  1.45
       1.00  2.16  1.59
       1.47  2.65  2.74
       1.63  2.81  4.27
       2.00  3.22  7.81
       2.78  3.98  23.0];       

% Rosenbrock-W, real, two-stage, order 3, stepmin 0.1 sec
rwr23=[0.60  1.47  0.80
       1.30  2.09  1.19
       1.52  2.31  1.62
       1.81  2.64  2.70
       2.11  2.87  3.55
       2.40  3.22  11.80
       3.16  3.93  27.0];       

% stifa
stifa=[1.11  1.11  0.66
       3.16  3.16  0.99
       3.40  3.40  1.08
       4.00  4.00  1.65];       

close
k=1;
semilogx(rts(:,3), rts(:,k), '--', ...      
         rtj(:,3), rtj(:,k), '--', rtj(:,3), rtj(:,k), 'o', ...
         rc2(:,3), rc2(:,k),':', ...
         rwr22(:,3), rwr22(:,k),':',rwr22(:,3), rwr22(:,k),'o', ...
         rwr23(:,3), rwr23(:,k),':',rwr23(:,3), rwr23(:,k),'*', ...
         rat(:,3), rat(:,k), ...      
         rsd(:,3), rsd(:,k), rsd(:,3), rsd(:,k), '*', ...
         rro(:,3), rro(:,k), rro(:,3), rro(:,k), 'x', ... 
         lso(:,3), lso(:,k), lso(:,3), lso(:,k), 'o');
axis([0.8 10 0.5 4]);
xlabel('CPU time [seconds]');
ylabel('Number of Accurate Digits'); 
title('PROBLEM  C  (CBM-IV  RURAL).  SDA_inf.'); 
print -deps cbm4_rural_min.eps;    
pause;

close
k=2;
semilogx(rts(:,3), rts(:,k), '--', ...      
         rtj(:,3), rtj(:,k), '--', rtj(:,3), rtj(:,k), 'o', ...
         stifa(:,3), stifa(:,k),':', ...
         rat(:,3), rat(:,k), ...      
         rsd(:,3), rsd(:,k), rsd(:,3), rsd(:,k), '*', ...
         rro(:,3), rro(:,k), rro(:,3), rro(:,k), 'x', ... 
         lso(:,3), lso(:,k), lso(:,3), lso(:,k), 'o');
axis([0.8 10 0.5 4]);
xlabel('CPU time [seconds]');
ylabel('Number of Accurate Digits');
title('PROBLEM  C  (CBM-IV  RURAL).  SDA_1.'); 
print -deps cbm4_rural_av.eps;    

