% Twostep Seidel, stepmin=1.d-1, noise=1 
uts = [0.28  1.20  0.91
       0.74  1.53  1.20
       1.65  2.30  2.38
       2.04  2.64  3.57
       3.00  3.49  7.08
       3.43  3.87  9.18
       4.15  4.70  17.7];
      
      
% Twostep Jacobi, stepmin=1.d-2, noise=1 
utj = [0.00  0.81  1.60
       0.97  1.64  2.78
       1.30  1.84  3.75
       2.25  2.75  7.60
       2.61  3.08  10.4
       3.14  3.51  21.8];
      

% QSSA, stepmin=1.E-2, noise=1 
uqs = [0.00  0.23  2.37
       0.00  0.68  3.74
       0.78  1.34  12.1
       1.06  1.60  20.0
       1.65  2.25  58.0];
      
% Extrap_QSSA, stepmin=1.E-2, noise=1 
ueq = [0.00  0.51  4.61
       0.07  0.80  4.13
       0.62  1.28  4.21
       0.89  1.53  7.01
       1.55  2.12  18.3
       1.86  2.48  26.2
       2.55  3.13  75.0];
      
% ATMVODE, noise=1, stepmin=1.e-3
uat =[0.67  1.35  1.42
      0.90  1.60  1.88
      1.60  2.20  2.10
      1.89  2.54  2.31
      2.49  3.23  4.00
      2.88  3.56  4.50
      3.49  4.30  5.47
      4.38  5.12  7.13];
      
% SDIRK, stepmin = 1.0, noise=1
usd = [0.00  0.55  1.77
       2.10  3.07  2.10
       2.52  3.45  2.40
       3.27  4.16  3.12
       3.31  4.41  3.68
       4.55  5.24  5.22];
            
% RODAS, norm 2, stepmin=0.1, noise=1
uro = [0.00  0.73  1.57
       1.80  2.98  1.63
       2.38  3.31  1.71
       2.66  3.51  2.28
       3.78  4.42  2.46
       4.96  5.53  4.10];
      
% BORIS, stepmin=1.d-4
ubo = [0.14  0.86  5.40
       0.84  1.43  11.4
       1.30  1.86  18.5
       1.57  2.20  31.7
       1.77  2.48  66.8];

% LSODES
lso = [0.58  1.33  2.32
       1.43  2.02  2.84
       1.86  2.37  3.20
       2.58  3.06  5.00
       2.86  3.47  5.47
       3.72  4.30  9.87];
       
% Rosenbrock, complex, 1-stage, order 2
rc2 = [0.60  1.30  2.34
       0.75  1.46  2.81
       0.95  1.73  3.66
       1.08  1.90  3.67
       1.66  2.48  8.68
       1.84  2.73  11.2
       2.44  3.38  23.7];

% Rosenbrock-w, real, 2-stage, order 2
rwr22=[0.48  1.38  1.35
       0.93  1.87  1.92
       1.13  2.09  2.41
       1.64  2.63  4.15
       1.81  2.83  6.23
       2.14  3.27  11.8
       2.82  4.00  32.0];

% Rosenbrock-w, real, 2-stage, order 3
rwr23=[0.90  1.60  1.04
       1.29  2.02  1.52
       1.50  2.20  1.92
       2.00  2.67  3.68
       2.16  2.85  5.00
       2.67  3.34  15.1
       3.25  3.96  38.0];
       
% Stiffly accurate rosenbrock, order 3, embedded stifa       
stifa = [1.17  1.17  0.55
         1.20  1.20  0.79
         2.44  2.46  0.87
         2.97  2.97  1.18
         3.88  3.91  2.19];

close
k=1;
semilogx(uts(:,3), uts(:,k), '--', ...      
         utj(:,3), utj(:,k), '--', utj(:,3), utj(:,k), 'o', ...
         rc2(:,3), rc2(:,k), ':', ...
         rwr22(:,3), rwr22(:,k), ':',rwr22(:,3), rwr22(:,k), 'o',...
         rwr23(:,3), rwr23(:,k), ':',rwr23(:,3), rwr23(:,k), '*',...
         uat(:,3), uat(:,k), ...      
         usd(:,3), usd(:,k), usd(:,3), usd(:,k), '*', ...
         uro(:,3), uro(:,k), uro(:,3), uro(:,k), 'x', ...
         lso(:,3), lso(:,k), lso(:,3), lso(:,k), 'o');
axis([1 20 0.5 4]);
xlabel('CPU time [seconds]');
ylabel('Number of Accurate Digits');
title('Problem  B  (CBM-IV  URBAN).  SDA_inf.')
%print -deps cbm4_urban_min.eps;
pause;

close
k=2;
semilogx(uts(:,3), uts(:,k), '--', ...      
         utj(:,3), utj(:,k), '--', utj(:,3), utj(:,k), 'o', ...
         stifa(:,3), stifa(:,k), ':', ...
         uat(:,3), uat(:,k), ...      
         usd(:,3), usd(:,k), usd(:,3), usd(:,k), '*', ...
         uro(:,3), uro(:,k), uro(:,3), uro(:,k), 'x', ... 
         lso(:,3), lso(:,k), lso(:,3), lso(:,k), 'o');
axis([0.5 20 0.5 4]);
xlabel('CPU time [seconds]');
ylabel('Number of Accurate Digits');
title('Problem  B  (CBM-IV  URBAN).  SDA_1.')
print -deps cbm4_urban_av.eps;
