C -- STEM INTEGRATION WITH ATMVODE.F --
        PROGRAM STEM
        INCLUDE 'sparse_s.h'

C --- PARAMETERS (FULL JACOBIAN)
        PARAMETER (ND=84,LRW=2*ND*ND+9*ND+25,LIW=ND+35)
        PARAMETER (LRCONT=4*ND+4+10)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION RWORK(LRW),IWORK(LIW)
        DIMENSION ATOL(NVAR), RTOL(NVAR)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        COMMON /VERWER/ IVERWER, IBEGIN, STEPCUT
        EXTERNAL VODE_FSPLIT_VAR, VODE_JACVAR_SP
        Dimension VMIN(NVAR)
        data vmin/0, 5.1e+10,1.00e+02,1.24e-06, 7.84e-02,
     * 2.29e+01,  5.00e-11, 1.00e+02, 1.00e+02, 1.00e+02,
     * 1.96e-10,  1.00e+02, 9.73e-05, 4.37e-03, 1.00e+02,
     * 2.55e+12,  1.00e+02, 1.00e+02, 3.62e-03, 1.00e+02,
     * 1.00e+02,  2.55e+07, 5.95e-03, 1.00e+02, 1.68e+11,
     * 3.58e+07,  1.00e+02, 1.00e+02, 0.00e+00, 1.00e+02,
     * 1.04e+02,  1.00e+02/

    
        write(6,*) 'ATMVODE for CBM4. rtol=. urban=, stepmin='
        read(5,*) rtols, is_urban, stepmin 
        
        DT = 3600.

        idir = 0.
        stepcut = 0.
C        stepmin = 1.0D-1 

        STEPMAX = 10000.
        maxord = 5
        ibegin = 1
        
        
C --- DIMENSION OF THE SYSTEM
        N=ND
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
       IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100.0*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300.0*CFACTOR
        Var(I_HCHO) = 10.0*CFACTOR
        Var(I_ALD2) = 10.0*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_PAR)  = 50.0*CFACTOR 
        Var(I_OLE)  = 10.0*CFACTOR 
        Var(I_ETH)  = 10.0*CFACTOR
        Var(I_TOL)  = 2.0*CFACTOR 
        Var(I_XYL)  = 2.0*CFACTOR 
        Var(I_ISOP) = 10.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*CFACTOR
       END IF
       

C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- REQUIRED TOLERANCE, scalar ATOL (itol = 1), vector ATOL (itol = 2)
       do i=1,NVAR
c         IF (IS_URBAN.EQ.0) THEN
c           ATOL(i) = DMAX1( 1.D-4 , 1.D-4*rtols*vmin(i) )
c         ELSE
c           ATOL(i) = DMAX1( 1.D-2 , 1.D-2*rtols*vmin(i) )         
c         END IF  
         ATOL(I) = 1.d-2
         RTOL(i) = rtols
       end do 
        ITOL=4
C ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
C ---- USE OPTIONAL INPUT ---
        iopt=1
        IWORK(6) = 20000  
        IWORK(7) = 0  
        RWORK(6) = STEPMAX   ! STEP MAX
        RWORK(7) = STEPMIN   ! STEP MIN
        RWORK(5) = STEPMIN   ! INITIAL STEP
        IWORK(5) = MAXORD    ! MAX ORD
        
        
        
C ----- SIGNAL FOR STIFF CASE, FULL JACOBIAN, INTERN (22) or SUPPLIED (21)
       MF = 21



C --- OUTPUT FILE ----
c2       OPEN(UNIT=10,FILE='Atmvode.m')


       TIME=TSTART

C --- PRINT  INITIAL CONDITIONS
c2       WRITE (10,99) (TIME-tstart)/3600.D0,(Var(I),i=1,nvar)


        DIV = 3600.0/DT
    
        DO WHILE (TIME.LT.TEND)
        
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_PAR)  = Var(I_PAR)  + 2.0*CFACTOR  /DIV  
        Var(I_OLE)  = Var(I_OLE)  + 1.0*CFACTOR  /DIV 
        Var(I_ETH)  = Var(I_ETH)  + 0.2*CFACTOR  /DIV 
        Var(I_TOL)  = Var(I_TOL)  + 0.2*CFACTOR  /DIV 
        Var(I_XYL)  = Var(I_XYL)  + 0.2*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF



C --- CALL OF THE SUBROUTINE VODE
c       if ( idir.eq.0 ) then
            ISTATE = 1
            IBEGIN = 1
c       end if     
        Told = TIME
        TIME = TIME + DT/2.d0
        CALL UPDATE_SUN()
        CALL UPDATE_RCONST()
        TIME = Told
                    
       CALL dvode (VODE_FSPLIT_VAR, NVAR, Var, TIME, 
     *             TIME+DT, itol, rtol, atol,
     *             itask, istate, iopt, rwork, lrw, 
     *             iwork, liw, VODE_JACVAR_SP, mf,rpar,ipar)

       IF (ISTATE.LT.0) THEN
          WRITE(6,*) 'VODE WARNING: ISTATE = ',ISTATE
          STOP
       END IF   

C --- PRINT  SOLUTION
       if (time.le.tend) then
         HOURS = (TIME-tstart)/3600.D0
         IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
c2           WRITE (10,99) HOURS,(Var(I),i=1,nvar)
         END IF  
c        percent=100.D0*(time-tstart)/(tend-tstart)
c        write(6,95) percent,Var(I_O3)*CM
        end if
 95     format(F7.2,' % DONE, O3=',F10.4)       
 99     FORMAT(100(X,E24.16))
 101    format(E24.16,E24.16,x,I4,x,E24.16)
         END DO
        write(6,*) 'O3 = ',Var(I_O3)*CM 

C --- PRINT STATISTICS
        WRITE (6,90) real(iwork(21))/iwork(11)*100.,
     *              real(iwork(22))/iwork(11)*100.
 90     FORMAT(F9.3,' % conv, ',F9.3,'% err failures')
        CLOSE(10)
        STOP
        END


C End of MAIN function                                             

        SUBROUTINE VODE_FSPLIT_VAR(N, T, Y, PR)
        INCLUDE 'sparse.h'
        REAL*8 T
        REAL*8 Y(NVAR), PR(NVAR)

        CALL F_VAR( Y, RAD, PR )
        RETURN
        END

        SUBROUTINE VODE_JACVAR_SP(N, T, Y, J)
        INCLUDE 'sparse.h'
        REAL*8 T
        REAL*8 Y(NVAR), J(LU_NONZERO_V)

        CALL JACVAR_SP( Y, RAD, J )
        RETURN
        END


