C -- STEM INTEGRATION WITH LSODES.F --
        PROGRAM STEM
       INCLUDE 'agg.h'

C --- PARAMETERS (FULL JACOBIAN)
        PARAMETER ( LRW=20+3*1500+16*NVAR )
        PARAMETER ( LIW=60 )

C --- DECLARATIONS
        REAL*8 RWORK(LRW),IWORK(LIW)
        EXTERNAL FUN,JAC
        REAL*8 VMIN(NVAR)
        DATA VMIN/1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  2.7e-27, 6.8e-17, 2.5e-10, 3.4e-100, 1.7e-100,
     *  1.0e+02, 1.0e+02, 1.0e-05, 6.3e+01, 1.1e+01,
     *  1.0e+02, 1.0e+02, 2.4e+10, 5.3e-11, 3.6e-05,
     *  1.0e+02, 1.0e+02, 4.5e+00, 1.0e+02, 1.4e-01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.4e-11, 1.3e-05,
     *  3.8e-12, 1.0e+02, 2.6e-03, 8.2e-14, 8.0e-06,
     *  2.1e+12, 3.1e-01, 1.0e+02, 4.6e-13, 1.0e+02,
     *  1.6e-03, 2.4e-08, 2.1e-27, 1.0e+02, 1.0e+02,
     *  2.0e-03, 2.3e-30, 1.0e+02, 5.3e-07, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 8.7e-05,
     *  5.6e+01, 5.3e-03, 3.1e-26, 5.0e+07, 1.0e+02,
     *  1.0e+02, 1.3e-31, 1.0e+02, 6.3e+01, 9.4e+01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 5.5e+11, 1.0e+02,
     *  0.0e+00, 1.0e+02, 1.0e+02, 1.0e+02, 1.6e+08,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02 /

        N=NVAR
        write(6,*) 'LSODES. Rtol=, Urban='
        read(5,*) rtols, IS_URBAN

        dt = 3600.
        idir = 0
        iopt = 0
C        rwork(8) = seth  ! Threshold factor
        itask = 1
        istate = 1
        MF = 121

C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
      IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300*CFACTOR
        Var(I_HCHO) = 10*CFACTOR
        Var(I_ALD2) = 10*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_ALKA) = 50.0*CFACTOR  
        Var(I_ALKE) = 10.0*CFACTOR  
        Var(I_ETHE) = 10*CFACTOR
        Var(I_AROM) = 4*CFACTOR 
        Var(I_ISOP) = 10*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor ! rh = 80%
      ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor ! rh = 80%
      END IF
      
      CALL UPDATE_THERMAL()
        


C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- REQUIRED TOLERANCE, scalar ATOL (itol = 2), vector ATOL (itol = 2)
       do i=1,NVAR
         if (is_urban.eq.1) then
           ATOL(i) = dmax1(1.0d-2, 0.01*rtols*vmin(i))
         else
           ATOL(i) = dmin1(1.0d0, 1.D-2*rtols*vmin(i))
         end if
         RTOL(i) = rtols
       end do 
       ITOL=4
C ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
        iopt=0

C --- OUTPUT FILE ----
c2       OPEN(UNIT=10,FILE='Lsodes.m')
c2       write(10,99) 0., (Var(i), i=1,nvar)


       TIME=TSTART

        DIV = 3600./DT

        DO WHILE (TIME.LT.TEND)

C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_ALKA) = Var(I_ALKA) + 2.0*CFACTOR  /DIV   
        Var(I_ALKE) = Var(I_ALKE) + 1.0*CFACTOR  /DIV   
        Var(I_ETHE) = Var(I_ETHE) + 0.2*CFACTOR  /DIV 
        Var(I_AROM) = Var(I_AROM) + 0.4*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF

       
       if (idir.eq.0) istate=1

      CALL lsodes (FUN, NVAR, VAR, TIME, TIME+DT,  
     *            itol, rtol, atol, itask, istate, 
     *            iopt, rwork, lrw, iwork, liw, JAC, mf)
     
       if (istate.lt.0) then
         print *,'LSODES Error : istate = ',istate
         stop
       end if  
      
C --- PRINT  SOLUTION
        if (time.le.tend) then
c2          write(10,99) (TIME-Tstart)/3600.D0, (Var(i), i=1,nvar)
        end if
        percent=100.D0*(time-tstart)/(tend-tstart)
c        write(6,95) percent,Var(I_O3)*CM
 95     format(F7.2,' % DONE. O3 = ',F12.5)       
 99     FORMAT(100(X,E24.16))
         END DO



C --- PRINT STATISTICS
        WRITE (6,91) NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
 91     FORMAT(' fcn=',I5,' jac=',I4,' step=',I4,
     &        ' accpt=',I4,' rejct=',I3,' dec=',I4,
     &        ' sol=',I5)
        STOP
        END
C
C


        SUBROUTINE FUN (N, T, V, FCT)
       INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_photo()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, JV, j, ian, jan)
       INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR)
        INTEGER j, ian(1), jan(1)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_photo()
        TIME = TOLD

        DO ii=1,NVAR
          DO jj=1,NVAR
              JV(ii,jj) = 0.
          END DO 
        END DO 
        CALL JACVAR(V, Rad, JV)

        RETURN
        END
        
C End of MAIN function                                             
C **************************************************************** 
