      program ROD3
 
      INCLUDE 'sparse.h'
      external FUN, JAC_SP
      DIMENSION  ATOL(NVAR), RTOL(NVAR)
      DIMENSION VMIN(NVAR)
      INTEGER INFO(5)
      DATA VMIN/1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02,
     *  2.7e-27, 6.8e-17, 2.5e-10, 3.4e-100, 1.7e-100,
     *  1.0e+02, 1.0e+02, 1.0e-05, 6.3e+01, 1.1e+01,
     *  1.0e+02, 1.0e+02, 2.4e+10, 5.3e-11, 3.6e-05,
     *  1.0e+02, 1.0e+02, 4.5e+00, 1.0e+02, 1.4e-01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.4e-11, 1.3e-05,
     *  3.8e-12, 1.0e+02, 2.6e-03, 8.2e-14, 8.0e-06,
     *  2.1e+12, 3.1e-01, 1.0e+02, 4.6e-13, 1.0e+02,
     *  1.6e-03, 2.4e-08, 2.1e-27, 1.0e+02, 1.0e+02,
     *  2.0e-03, 2.3e-30, 1.0e+02, 5.3e-07, 1.0e+02,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02, 8.7e-05,
     *  5.6e+01, 5.3e-03, 3.1e-26, 5.0e+07, 1.0e+02,
     *  1.0e+02, 1.3e-31, 1.0e+02, 6.3e+01, 9.4e+01,
     *  1.0e+02, 1.0e+02, 1.0e+02, 5.5e+11, 1.0e+02,
     *  0.0e+00, 1.0e+02, 1.0e+02, 1.0e+02, 1.6e+08,
     *  1.0e+02, 1.0e+02, 1.0e+02, 1.0e+02 /
      
    
      write(6,*) 'Rodas 3. RTOL=, Urban='
      read(5,*) rtols, IS_URBAN

      DT = 3600.
        DO i=1,NVAR
          ATOL(i)=dmax1( 1.0D-2, 1.0D-2*rtols*vmin(i) )
          RTOL(i)=rtols
        END DO  
       
C ==== initial values ====
      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
      IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300*CFACTOR
        Var(I_HCHO) = 10*CFACTOR
        Var(I_ALD2) = 10*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_ALKA) = 50.0*CFACTOR  
        Var(I_ALKE) = 10.0*CFACTOR  
        Var(I_ETHE) = 10*CFACTOR
        Var(I_AROM) = 4*CFACTOR 
        Var(I_ISOP) = 10*CFACTOR
        Fix(I_H2O)  = 1.35E+7*cfactor ! rh = 80%
      ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7*cfactor ! rh = 80%
      END IF
      
      CALL UPDATE_THERMAL()
      
      
           
C **********************************************
c2      open(10, file='Rodas3.m')


C ---- TIME VARIABLES ------------------      
      TSTART = 3600*12
      TEND  = TSTART + 3600*24*5
      Hmin  = 1.d0
      Hmax  = DT
      Info(1) = 0


C ********** TIME LOOP *************************
      T = TSTART
c2      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(T.lt.TEND)      
        HT=T/3600

C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_ALKA) = Var(I_ALKA) + 2.0*CFACTOR  /DIV   
        Var(I_ALKE) = Var(I_ALKE) + 1.0*CFACTOR  /DIV   
        Var(I_ETHE) = Var(I_ETHE) + 0.2*CFACTOR  /DIV 
        Var(I_AROM) = Var(I_AROM) + 0.4*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF
        
      
      call RODAS3(nvar,t,t+DT,Hmin,Hmax,
     +                   Var, atol, rtol,
     +                   Info,FUN,JAC_SP)


       
C ---- PRINT VALUES NT TIMES HOURLY ----
c2      WRITE (10,991) (T-tstart)/3600.D0,(Var(i), i=1,nvar) 
C      write(6,886) (T-tstart)/3600.D0,Var(I_O3)/CFACTOR,
C     *        DT/(info(4)+info(5))
      end do
C *********** END TIME LOOP ********
      close(10)
      STOP
886   FORMAT(F5.1,' hrs. O3 = ',F9.4,' ppb.    Mean step = ',F7.1)      
991   FORMAT(100(X,E24.16))
      END


      SUBROUTINE RODAS3(N,T,Tnext,Hmin,Hmax,
     +                   y,AbsTol,RelTol,
     +                   Info,FUN,JAC_SP)
      include 'sparse_s.h'

C       This code is part of the paper ...
C  
C       Stiffly accurate Rosenbrock 3(2), with 
C     stiffly accurate embedded formula for error control.  
C
C     All the arguments aggree with the KPP syntax.
C
C  INPUT ARGUMENTS:
C     y = Vector of (NVAR) concentrations, contains the
C         initial values on input
C     [T, Tnext] = the integration interval
C     Hmin, Hmax = lower and upper bounds for the selected step-size.
C          Note that for Step = Hmin the current computed
C          solution is unconditionally accepted by the error
C          control mechanism.
C     AbsTol, RelTol = (NVAR) dimensional vectors of 
C          componentwise absolute and relative tolerances.
C     FUN = name of routine of derivatives. KPP syntax.
C          See the header below.
C     JAC_SP = name of routine that computes the Jacobian, in
C          sparse format. KPP syntax. See the header below.
C     Info(1) = 1  for  autonomous   system
C             = 0  for nonautonomous system 
C
C  OUTPUT ARGUMENTS:
C     y = the values of concentrations at Tend.
C     T = equals Tend on output.
C     Info(2) = # of FUN calls.
C     Info(3) = # of JAC_SP calls.
C     Info(4) = # of accepted steps.
C     Info(5) = # of rejected steps.
C    
C     Adrian Sandu, March 1996
C     The Center for Global and Regional Environmental Research

      REAL*8     K1(NVAR), K2(NVAR), K3(NVAR), K4(NVAR)
      REAL*8     F1(NVAR), JAC(LU_NONZERO_V)
      REAL*8     Hmin,Hmax,ghinv,uround
      REAL*8     y(NVAR), ynew(NVAR)
      REAL*8     AbsTol(NVAR), RelTol(NVAR)
      REAL*8     T, Tnext, H, Hold, Tplus
      REAL*8     ERR, factor, facmax
      INTEGER    n,nfcn,njac,Naccept,Nreject,i,j
      INTEGER    Info(5)
      LOGICAL    IsReject,Autonom
      EXTERNAL   FUN, JAC_SP

c     Initialization of counters, etc.
      Autonom = Info(1) .EQ. 1
      uround = 1.d-15
      dround = dsqrt(uround)
      c43 = - 8.d0/3.d0 
      H = DMAX1(1.d-8, Hmin)
      Tplus = T
      IsReject = .false.
      Naccept  = 0
      Nreject  = 0
      Nfcn     = 0
      Njac     = 0


C === Starting the time loop ===      
 10    continue  
       Tplus = T + H
       if ( Tplus .gt. Tnext ) then
          H = Tnext - T
          Tplus = Tnext
       end if

       call JAC_SP(NVAR, T, y, JAC)
       Njac = Njac+1
       gHinv = -2.0d0/H
       do 20 j=1,NVAR
         JAC(lu_diag_v(j)) = JAC(lu_diag_v(j)) + gHinv
 20    continue
       call DECOMP (NVAR, JAC, ier)

       if (ier.ne.0) then
         if ( H.gt.Hmin) then
            H = 5.0d-1*H
            go to 10
         else
            print *,'IER <> 0, H=',H
            stop
         end if      
       end if  
       
       call FUN(NVAR, T, y, F1)

C ====== NONAUTONOMOUS CASE ===============
       IF (.not. Autonom) THEN
         tau = dsign(dround*dmax1( 1.0d-6, dabs(T) ), T)
         call FUN(NVAR, T+tau, y, K2)
         nfcn=nfcn+1
         do 30 j = 1,NVAR
           K3(j) = ( K2(j)-F1(j) )/tau
 30      continue
 
C ----- STAGE 1 (NONAUTONOMOUS) -----
         x1 = 0.5*H
         do 40 j = 1,NVAR
           K1(j) =  F1(j) + x1*K3(j) 
 40      continue
         call SOLVE (JAC, K1)

C ----- STAGE 2 (NONAUTONOMOUS) -----
         x1 = 4.d0/H
         x2 = 1.5d0*H
         do 50 j = 1,NVAR
           K2(j) = F1(j) - x1*K1(j) + x2*K3(j)
 50      continue
         call SOLVE (JAC, K2)

C ====== AUTONOMOUS CASE ===============
       ELSE
C ----- STAGE 1 (AUTONOMOUS) -----
         do 60 j = 1,NVAR
           K1(j) =  F1(j) 
 60      continue
         call SOLVE (JAC, K1)
      
C ----- STAGE 2 (AUTONOMOUS) -----
         x1 = 4.d0/H
         do 70 j = 1,NVAR
           K2(j) = F1(j) - x1*K1(j) 
 70      continue
         call SOLVE (JAC, K2)
       END IF
       
C ----- STAGE 3 -----
       do 80 j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) 
 80    continue
       call FUN(NVAR, T+H, ynew, F1)
       nfcn=nfcn+1
       do 90 j = 1,NVAR
         K3(j) = F1(j) + ( -K1(j) + K2(j) )/H
 90    continue
       call SOLVE (JAC, K3)

C ----- STAGE 4 -----
       do 100 j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) - K3(j)
 100   continue
       call FUN(NVAR, T+H, ynew, F1)
       nfcn=nfcn+1
       do 110 j = 1,NVAR
         K4(j) = F1(j) + ( -K1(j) + K2(j) - C43*K3(j)  )/H
 110   continue
       call SOLVE (JAC, K4)

C ---- The Solution ---

       do 120 j = 1,NVAR
         ynew(j) = y(j) - 2*K1(j) - K3(j) - K4(j) 
 120   continue


C ====== Error estimation ========

        ERR=0.d0
        do 130 i=1,NVAR
           ytol = AbsTol(i) + RelTol(i)*dabs(ynew(i))
           ERR = ERR + ( K4(i)/ytol )**2
 130    continue      
        ERR = DMAX1( uround, DSQRT( ERR/NVAR ) )

C ======= Choose the stepsize ===============================

        factor = 0.9/ERR**(1.d0/3.d0)
        if (IsReject) then
            facmax=1.0
        else
            facmax=10.0
        end if 
        factor = DMAX1( 1.0D-1, DMIN1(factor,facmax) )
        Hold = H
        H = DMIN1( Hmax, DMAX1(Hmin,factor*H) )    

C ======= Rejected/Accepted Step ============================

        if ( (ERR.gt.1).and.(Hold.gt.Hmin) ) then
          IsReject = .true.
          Nreject  = Nreject+1
        else
          IsReject = .false.
          do 140 i=1,NVAR
             y(i)  = ynew(i)
 140      continue 
          T = Tplus     
          Naccept = Naccept+1
        end if

C ======= End of the time loop ===============================
      if ( T .lt. Tnext ) go to 10
 
     
      
C ======= Output Information =================================
      Info(2) = Nfcn
      Info(3) = Njac
      Info(4) = Naccept
      Info(5) = Nreject
      
      RETURN 
      END        

  
  
        SUBROUTINE FUN(N, T, Y, P)
        INCLUDE 'sparse.h'
        REAL*8   T, Told
        REAL*8   Y(NVAR), P(NVAR)
        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_PHOTO()
        CALL F_VAR( Y, RAD, P )
        TIME = Told
        RETURN
        END

        SUBROUTINE JAC_SP(N, T, Y, J)
        INCLUDE 'sparse.h'
        REAL*8   Told, T
        REAL*8   Y(NVAR), J(LU_NONZERO_V)
        Told = TIME
        TIME = T
        CALL UPDATE_SUN()
        CALL UPDATE_PHOTO()
        CALL JACVAR_SP( Y, RAD, J )
        TIME = Told
        RETURN
        END
