C Original twostep

      program VERWER
 
      INCLUDE 'split.h'
      external ITER
      DIMENSION VOLD(NVAR), VNEW(NVAR)
      DIMENSION sum(nvar), p_var(nvar), d_var(nvar), work(nvar)

      write(6,*) 'TwostepS for tropo. rtol=, Urban='
      read(5,*) rtols,IS_URBAN
      numit = 2

      CFACTOR = 2.55E+10
      CM = 1./CFACTOR
      TEMP = 288.15
      CALL INITVAL()
C --- Adjust initial conditions      
      IF (IS_URBAN.EQ.1) THEN
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 50*CFACTOR 
        Var(I_NO2)  = 20*CFACTOR
        Var(I_HONO) = 1.0*CFACTOR
        Var(I_O3)   = 100*CFACTOR
        Var(I_H2O2) = 1.0*CFACTOR
        Var(I_CO)   = 300*CFACTOR
        Var(I_HCHO) = 10*CFACTOR
        Var(I_ALD2) = 10*CFACTOR
        Var(I_PAN)  = 1.0*CFACTOR
        Var(I_ALKA) = 50.0*CFACTOR  
        Var(I_ALKE) = 10.0*CFACTOR  
        Var(I_ETHE) = 10*CFACTOR
        Var(I_AROM) = 4*CFACTOR 
        Var(I_ISOP) = 10*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor ! rh = 80%
      ELSE
        do i=1,nvar
           Var(i) = 100.0
        end do   
        Var(I_NO)   = 0.1*CFACTOR 
        Var(I_NO2)  = 0.1*CFACTOR
        Var(I_O3)   = 30.0*CFACTOR
        Var(I_CO)   = 100.0*CFACTOR
        Var(I_H2O2) = 2.0*CFACTOR
        Var(I_ISOP) = 1.0*CFACTOR
        Fix(I_H2O)  = 1.35E+7 *cfactor ! rh = 80%
      END IF
           
C **********************************************
c2      open(10, file='Vseidel.m')

      do i=1,nvar
         atol(i)=1.d-2
         rtol(i)=rtols
      end do

C ---- TIME VARIABLES ------------------      
      TSTART = 3600.*12.d0
      TEND = TSTART + 3600.*24.*5.d0
      DT = 900.d0
      hmin    = 1.0d-1
      hstart  = 60.d0
      startdt = 60.d0
      hmax    = DT



C ********** TIME LOOP *************************
      TIME = TSTART
c2      WRITE (10,991) (Time-tstart)/3600.D0, (Var(i), i=1,nvar)

      DIV = 3600./DT

      do while(Time.lt.TEND)      
        Hours=(Time-Tstart)/3600.
        
C --- Add emissions
      IF (IS_URBAN.EQ.1) THEN
        Var(I_NO)   = Var(I_NO)   + 1.0*CFACTOR  /DIV
        Var(I_NO2)  = Var(I_NO2)  + 0.2*CFACTOR  /DIV  
        Var(I_CO)   = Var(I_CO)   + 2.0*CFACTOR  /DIV
        Var(I_HCHO) = Var(I_HCHO) + 0.2*CFACTOR  /DIV
        Var(I_ALD2) = Var(I_ALD2) + 0.2*CFACTOR  /DIV
        Var(I_ALKA) = Var(I_ALKA) + 2.0*CFACTOR  /DIV   
        Var(I_ALKE) = Var(I_ALKE) + 1.0*CFACTOR  /DIV   
        Var(I_ETHE) = Var(I_ETHE) + 0.2*CFACTOR  /DIV 
        Var(I_AROM) = Var(I_AROM) + 0.4*CFACTOR  /DIV 
        Var(I_ISOP) = Var(I_ISOP) + 1.0*CFACTOR  /DIV
      ELSE
        VAR(I_NO)   = VAR(I_NO)   + 0.01*CFACTOR /DIV
        VAR(I_NO2)  = VAR(I_NO2)  + 0.01*CFACTOR /DIV
        VAR(I_ISOP) = VAR(I_ISOP) + 0.1*CFACTOR  /DIV
      END IF
      
      TOLD = TIME
      TIME = TIME + DT/2.d0
      call update_sun()
      call update_rconst()
      TIME = TOLD
      
      call TWOSTEP(NVAR,Time,Time+DT,hstart,hmin,hmax,
     +                   VOLD,Var,VNEW,p_var,d_var,work,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart,startdt)

       
C ---- PRINT VALUES HOURLY ----
       if (Time.le.Tend) then
        HOURS = (Time-tstart)/3600.D0
        IF ( DABS(HOURS-INT(HOURS*10)/10) .LT. 0.01 ) THEN
c2          WRITE (10,991) HOURS,(Var(I),i=1,nvar)
        END IF  
       END IF  
      end do
C *********** END TIME LOOP ********

      close(10)
      STOP
991   FORMAT(100(X,E24.16))
      END




C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : split.f                                   
C Time                 : Thu Sep 14 16:55:04 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/SMOG/SPLIT
C Equation file        : split.k                                   
C Output root filename : split                                     
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'split.h'

      data CFACTOR / 2.55E+10 / 

      END


      subroutine ITER(t,method,n,V,sum,gdt,P_VAR,D_VAR,work)
      INCLUDE 'split.h'
      integer method,n
      real*8  t,sum(nvar),gdt,work(nvar)

C V - Concentration of variable species                            
      REAL*8 V(NVAR)
C P_VAR - Production term                                          
      REAL*8 P_VAR(NVAR)
C D_VAR - Destruction term                                         
      REAL*8 D_VAR(NVAR)



      P_VAR(78) = 2*RCONST(10)*V(74)*F(1)+RCONST(12)*V(27)
     *           +RCONST(14)*V(57)+RCONST(19)*V(76)*V(77)
     *           +RCONST(22)*V(74)*V(77)+2*RCONST(24)*V(23)
     *           -0.9*4.25e-11*V(36)*V(78)
     *           +RCONST(173)*V(71)+0.5*1e-11*V(71)*V(78)
     *           +0.6*RCONST(178)*V(77)*V(84)
      D_VAR(78) = 7.35e-12*V(76)+1.2794e-11*V(80)+1.629e-13*V(57)
     *           +2.22e-13*V(41)+RCONST(18)*V(74)+1.57e-12*V(23)
     *           +RCONST(28)*V(31)+1e-20*V(82)+1e-11*V(81)+3.2e-13
     *           *V(33)+RCONST(39)*V(83)+6.35e-15*V(29)+RCONST(48)
     *           *V(19)+RCONST(50)*V(20)+RCONST(52)*V(30)+2e-12*V(28)
     *           +RCONST(65)*V(61)+RCONST(70)*V(40)+RCONST(72)*V(63)
     *           +1.52e-11*V(24)+1.15e-11*V(35)+1.73e-11*V(42)
     *           +4.25e-11*V(36)+2.8e-11*V(34)+8.505e-11*V(64)
     *           +RCONST(117)*V(75)+1.02e-11*V(73)+RCONST(125)*V(73)
     *           +1.5e-11*V(45)+1.7e-11*V(58)+RCONST(165)*V(16)+5e-14
     *           *V(17)+RCONST(172)*V(77)+1e-11*V(71)+8.3e-12*V(18)
     *           +RCONST(177)*V(32)
          V( 78 )=(sum( 78 )+gdt*P_VAR( 78 ))/(1.0+gdt*D_VAR( 78 ))
 
      P_VAR(79) = 0.4*RCONST(74)*V(40)*V(74)
     *           +0.2*RCONST(75)*V(63)*V(74)
     *           +0.2*RCONST(133)*V(64)*V(74)
     *           +0.2*RCONST(134)*V(74)*V(75)
     *           +0.2*RCONST(135)*V(73)*V(74)

      D_VAR(79) = 7e-12*V(76)+7e-13*V(80)+4e-18*F(1)+7e-14*V(82)
     *           +1.36e-14*V(81)+1.36e-14*V(83)
          V( 79 )=(sum( 79 )+gdt*P_VAR( 79 ))/(1.0+gdt*D_VAR( 79 ))

      P_VAR(67) = 0.2*RCONST(75)*V(63)*V(74)
      D_VAR(67) = 7e-12*V(76)+7e-13*V(80)+4e-18*F(1)+7e-14*V(82)
     *           +1.36e-14*V(81)+1.36e-14*V(83)
          V( 67 )=(sum( 67 )+gdt*P_VAR( 67 ))/(1.0+gdt*D_VAR(67  ))

      P_VAR(68) = 0.2*RCONST(134)*V(74)*V(75)
     *           +0.2*RCONST(135)*V(73)*V(74)
      D_VAR(68) = RCONST(142)*V(76)+RCONST(143)*V(80)+3.4e-18*F(1)
     *           +7e-14*V(82)
          V( 68 )=(sum( 68 )+gdt*P_VAR( 68 ))/(1.0+gdt*D_VAR( 68 ))

      P_VAR(69) = 0.2*RCONST(133)*V(64)*V(74)
      D_VAR(69) = RCONST(136)*V(76)+RCONST(137)*V(80)+3.4e-18*F(1)
     *           +3e-12*V(77)+7e-14*V(82)
          V( 69 )=(sum( 69 )+gdt*P_VAR( 69 ))/(1.0+gdt*D_VAR( 69 ))

      P_VAR(70) = 0.3*RCONST(133)*V(64)*V(74)
      D_VAR(70) = RCONST(139)*V(76)+RCONST(140)*V(80)+3.4e-18*F(1)
     *           +3e-12*V(77)+7e-14*V(82)
          V( 70 )=(sum( 70 )+gdt*P_VAR( 70 ))/(1.0+gdt*D_VAR( 70 ))

      P_VAR(52) = 1.26e-13*V(63)*V(84)
      D_VAR(52) = 6.8e-12*V(80)+3e-12*V(77)+RCONST(91)*V(76)
          V( 52 )=(sum( 52 )+gdt*P_VAR( 52 ))/(1.0+gdt*D_VAR( 52 ))

      P_VAR(53) = 8.505e-11*V(64)*V(78)
      D_VAR(53) = RCONST(115)*V(76)+3e-12*V(77)
          V( 53 )=(sum( 53 )+gdt*P_VAR( 53 ))/(1.0+gdt*D_VAR( 53 ))

      P_VAR(54) = 0.9*4.25e-11*V(36)*V(78)+2.8e-11*V(34)*V(78)
     *          +RCONST(106)*V(25)+RCONST(109)*V(34)
      D_VAR(54) = 4.7e-12*V(80)+RCONST(107)*V(76)+4e-12*V(77)
          V( 54 )=(sum( 54 )+gdt*P_VAR( 54 ))/(1.0+gdt*D_VAR( 54 ))

      P_VAR(72) = RCONST(39)*V(78)*V(83)+2.7e-15*V(83)*V(84)
     *           +RCONST(44)*V(32)+0.94*RCONST(66)*V(62)*V(76)
     *           +RCONST(67)*V(61)+RCONST(100)*V(42)
     *           +1.73e-11*V(42)*V(78)
     *           +0.05*RCONST(107)*V(54)*V(76)+0.02*RCONST(109)*V(34)
     *           +0.6*RCONST(118)*V(59)*V(76)
     *           +0.15*RCONST(134)*V(74)*V(75)
     *           +RCONST(146)*V(58)+1.7e-11*V(58)*V(78)
     *           +0.5*RCONST(153)*V(50)*V(76)
      D_VAR(72) = 4.7e-12*V(80)+RCONST(45)*V(76)+3e-12*V(77)
          V( 72 )=(sum( 72 )+gdt*P_VAR( 72 ))/(1.0+gdt*D_VAR( 72 ))

      P_VAR(65) = RCONST(41)*V(83)+RCONST(45)*V(72)*V(76)
     *           +6.35e-15*V(29)*V(78)+0.1116*RCONST(53)*V(60)*V(76)
     *           +3e-12*V(62)*V(77)+0.215*RCONST(75)*V(63)*V(74)
     *           +0.5*1e-11*V(71)*V(78)
      D_VAR(65) = RCONST(46)*V(76)+RCONST(57)*2*V(65)+3e-12*V(77)
          V( 65 )=(sum( 65 )+gdt*P_VAR( 65 ))/(1.0+gdt*D_VAR( 65 ))

      P_VAR(66) = 1.02e-11*V(73)*V(78)+RCONST(122)*V(21)
     *           +3.3e-15*V(73)*V(84)
      D_VAR(66) = 4.7e-12*V(80)+RCONST(123)*V(76)+3e-12*V(77)
          V( 66 )=(sum( 66 )+gdt*P_VAR( 66 ))/(1.0+gdt*D_VAR( 66 ))

      P_VAR(55) = RCONST(148)*V(64)*V(84)
      D_VAR(55) = RCONST(149)*V(76)+RCONST(150)*V(80)+3e-12*V(77)
          V( 55 )=(sum( 55 )+gdt*P_VAR( 55 ))/(1.0+gdt*D_VAR( 55 ))

      D_VAR(56) = 4.7e-12*V(80)+RCONST(131)*V(76)+3e-12*V(77)
      P_VAR(56) = 1.5e-11*V(45)*V(78)+RCONST(130)*V(22)
     *          +5.2e-16*V(45)*V(84)
          V( 56 )=(sum( 56 )+gdt*P_VAR( 56 ))/(1.0+gdt*D_VAR( 56 ))

      P_VAR(84) = RCONST(3)*V(74)*V(80)+0.02013*V(26)
     *           +1.629e-13*V(57)*V(78)+7e-13*V(79)*V(80)
     *           +7e-13*V(67)*V(80)+3*RCONST(123)*V(66)*V(76)
     *           +RCONST(137)*V(69)*V(80)
     *           +RCONST(140)*V(70)*V(80)
     *           +RCONST(143)*V(68)*V(80)
      D_VAR(84) = RCONST(4)*V(76)+1.327e-12*V(80)+RCONST(7)*V(80)
     *           +RCONST(8)+6e-16*V(81)+2.7e-15*V(83)+4e-17*V(30)
     *           +7e-16*V(61)+1.26e-13*V(63)+1e-11*V(36)+RCONST(148)
     *           *V(64)+6e-14*V(75)+3.3e-15*V(73)+6.7e-15*V(73)
     *           +5.2e-16*V(45)+RCONST(176)*2*V(84)+RCONST(178)*V(77)
          V( 84 )=(sum( 84 )+gdt*P_VAR( 84 ))/(1.0+gdt*D_VAR(84  ))

      P_VAR(77) = 2.22e-13*V(41)*V(78)+RCONST(18)*V(74)*V(78)
     *           +0.02313*V(31)+1.57e-12*V(23)*V(78)
     *           +RCONST(27)*V(31)+1e-20*V(78)*V(82)
     *           +2*RCONST(30)*V(81)+1e-11*V(78)*V(81)
     *           +RCONST(34)*V(37)*V(76)+2*1e-13*V(37)*V(37)
      P_VAR(77) = P_VAR(77) +3.2e-13*V(33)*V(78)+6e-16*V(81)*V(84)
     *           +RCONST(41)*V(83)+RCONST(46)*V(65)*V(76)
     *           +RCONST(49)*V(51)*V(76)+0.97
     *           *RCONST(51)*V(46)*V(76)+0.28*RCONST(53)*V(60)*V(76)
      P_VAR(77) = P_VAR(77) +0.8*RCONST(57)*V(65)*V(65)
     *           +1.2*5e-14*V(51)*V(51)
      P_VAR(77) = P_VAR(77)+0.37*5e-14*V(46)*V(46)
      P_VAR(77) = P_VAR(77)+RCONST(71)*V(47)*V(76)
     *           +RCONST(73)*V(48)*V(76)
      P_VAR(77) = P_VAR(77) +0.12*RCONST(74)*V(40)*V(74)
     *           +0.23*RCONST(75)*V(63)*V(74)
     *           +1.2*5e-14*V(47)*V(47)+1.2
     *           *5e-14*V(48)*V(48)+0.16*1.52e-11*V(24)*V(78)
     *           +RCONST(97)*V(44)*V(76)+1.15e-11*V(35)*V(78)
     *           +RCONST(100)*V(42)
     *           +0.83*4.25e-11*V(36)*V(78)+0.92
     *           *RCONST(107)*V(54)*V(76)+0.98*RCONST(109)*V(34)
     *           +0+0.9*RCONST(115)*V(53)*V(76)
     *           +0.3*RCONST(118)*V(59)*V(76)
     *           +RCONST(123)*V(66)*V(76)+0.9*RCONST(126)*V(49)*V(76)
     *           +RCONST(131)*V(56)*V(76)+0.06*RCONST(133)*V(64)*V(74)
     *           +0.21*RCONST(134)*V(74)*V(75)
     *           +0.36*RCONST(135)*V(73)*V(74)
     *           +2*RCONST(145)*V(45)+RCONST(146)*V(58)
     *           +0.5*RCONST(153)*V(50)*V(76)+RCONST(173)*V(71)
      D_VAR(77) = RCONST(19)*V(76)+1.333e-12*V(80)+RCONST(22)*V(74)
     *           +5.816e-12*2*V(77)+1e-14*V(81)+2e-12*V(37)+3e-12
     *           *V(65)+3e-12*V(51)+3e-12*V(46)+3e-12*V(60)+3e-12
     *           *V(72)+3e-12*V(62)+3e-12*V(47)+3e-12*V(48)+3e-12
     *           *V(52)+4e-12*V(44)+4e-12*V(54)+1e-12*V(39)+3e-12
     *           *V(53)+3e-12*V(59)+3e-12*V(66)+3e-12*V(49)+3e-12
     *           *V(56)+3e-12*V(55)+3e-12*V(50)+3e-12*V(43)+3e-12
     *           *V(70)+3e-12*V(69)+RCONST(172)*V(78)+RCONST(178)
     *           *V(84)
          V( 77 )=(sum( 77 )+gdt*P_VAR( 77 ))/(1.0+gdt*D_VAR( 77 ))

      P_VAR(44) = 0.84*1.52e-11*V(24)*V(78)
      D_VAR(44) = RCONST(97)*V(76)+4e-12*V(77)
          V( 44 )=(sum( 44 )+gdt*P_VAR( 44 ))/(1.0+gdt*D_VAR( 44 ))

      P_VAR(45) = 0.6*RCONST(118)*V(59)*V(76)
      D_VAR(45) = 1.5e-11*V(78)+RCONST(145)+5.2e-16*V(84)
          V( 45 )=(sum( 45 )+gdt*P_VAR(  45))/(1.0+gdt*D_VAR( 45 ))

      P_VAR(46) = RCONST(50)*V(20)*V(78)+0.1057*RCONST(53)*V(60)*V(76)
      D_VAR(46) = RCONST(51)*V(76)+5e-14*2*V(46)+3e-12*V(77)
          V( 46 )=(sum( 46 )+gdt*P_VAR( 46 ))/(1.0+gdt*D_VAR( 46 ))

      P_VAR(47) = RCONST(70)*V(40)*V(78)
      D_VAR(47) = RCONST(71)*V(76)+5e-14*2*V(47)+3e-12*V(77)
          V( 47 )=(sum( 47 )+gdt*P_VAR( 47 ))/(1.0+gdt*D_VAR( 47 ))

      P_VAR(48) = RCONST(72)*V(63)*V(78)
      D_VAR(48) = RCONST(73)*V(76)+5e-14*2*V(48)+3e-12*V(77)
          V( 48 )=(sum( 48 )+gdt*P_VAR( 48 ))/(1.0+gdt*D_VAR( 48 ))

      P_VAR(51) = RCONST(48)*V(19)*V(78)+0.1879*RCONST(53)*V(60)*V(76)
     *           +RCONST(67)*V(61)
      D_VAR(51) = RCONST(49)*V(76)+5e-14*2*V(51)+3e-12*V(77)
          V( 51 )=(sum( 51 )+gdt*P_VAR( 51 ))/(1.0+gdt*D_VAR( 51 ))

      P_VAR(59) = RCONST(117)*V(75)*V(78)
      D_VAR(59) = RCONST(118)*V(76)+3e-12*V(77)
          V( 59 )=(sum( 59 )+gdt*P_VAR( 59 ))/(1.0+gdt*D_VAR( 59 ))

      P_VAR(60) = RCONST(52)*V(30)*V(78)+0.06*RCONST(53)*V(60)*V(76)
     *           +4e-17*V(30)*V(84)
      D_VAR(60) = RCONST(53)*V(76)+3e-12*V(77)
          V( 60 )=(sum( 60 )+gdt*P_VAR( 60 ))/(1.0+gdt*D_VAR( 60 ))

      P_VAR(61) = 0.49*RCONST(51)*V(46)*V(76)
     *          +0.3*RCONST(53)*V(60)*V(76)+0.28*5e-14*V(46)*V(46)
      D_VAR(61) = RCONST(65)*V(78)+RCONST(67)+7e-16*V(84)
          V( 61 )=(sum( 61 )+gdt*P_VAR( 61 ))/(1.0+gdt*D_VAR( 61 ))

      P_VAR(62) = RCONST(65)*V(61)*V(78)+7e-16*V(61)*V(84)
      D_VAR(62) = RCONST(66)*V(76)+3e-12*V(77)
          V( 62 )=(sum( 62 )+gdt*P_VAR( 62 ))/(1.0+gdt*D_VAR( 62 ))

      P_VAR(43) = 6.7e-15*V(73)*V(84)
      D_VAR(43) = RCONST(157)*V(76)+3e-12*V(77)
          V( 43 )=(sum( 43 )+gdt*P_VAR( 43 ))/(1.0+gdt*D_VAR( 43 ))

      P_VAR(37) = 1e-14*V(77)*V(81)
      D_VAR(37) = RCONST(34)*V(76)+2e-12*V(77)+1e-13*2*V(37)
          V( 37 )=(sum( 37 )+gdt*P_VAR( 37 ))/(1.0+gdt*D_VAR( 37 ))

      P_VAR(38) = 2e-12*V(28)*V(78)
      D_VAR(38) = RCONST(56)*V(76)
          V( 38 )=(sum( 38 )+gdt*P_VAR(38  ))/(1.0+gdt*D_VAR( 38 ))

      P_VAR(39) = 0.9*4.25e-11*V(36)*V(78)
      D_VAR(39) = RCONST(108)*V(76)+1e-12*V(77)
          V( 39 )=(sum( 39 )+gdt*P_VAR( 39 ))/(1.0+gdt*D_VAR( 39 ))

      P_VAR(76) = RCONST(1)*V(80)+RCONST(7)*V(80)*V(84)
     *           +0.15*RCONST(8)*V(84)+RCONST(12)*V(27)
     *           -0.1892*RCONST(53)*V(60)*V(76)
     *           -0.5*RCONST(56)*V(38)*V(76)-2
     *           *RCONST(123)*V(66)*V(76)-0.15*RCONST(135)*V(73)*V(74)
      D_VAR(76) = RCONST(2)*V(74)+RCONST(4)*V(84)+7.35e-12*V(78)
     *           +RCONST(19)*V(77)+RCONST(34)*V(37)+RCONST(45)*V(72)
     *           +RCONST(46)*V(65)+RCONST(49)*V(51)+RCONST(51)*V(46)
     *           +RCONST(53)*V(60)+RCONST(56)*V(38)+RCONST(66)*V(62)
     *           +RCONST(71)*V(47)+RCONST(73)*V(48)+7e-12*V(79)+7e-12
     *           *V(67)+RCONST(91)*V(52)+RCONST(97)*V(44)+RCONST(107)
     *           *V(54)+RCONST(108)*V(39)+RCONST(115)*V(53)
     *           +RCONST(118)*V(59)+RCONST(123)*V(66)+RCONST(126)
     *           *V(49)+RCONST(131)*V(56)+RCONST(136)*V(69)
     *           +RCONST(139)*V(70)+RCONST(142)*V(68)+RCONST(149)
     *           *V(55)+RCONST(153)*V(50)+RCONST(157)*V(43)
          V( 76 )=(sum( 76 )+gdt*P_VAR(76  ))/(1.0+gdt*D_VAR(76  ))

      P_VAR(31) = 1.333e-12*V(77)*V(80)
      D_VAR(31) = 0.02313+RCONST(27)+RCONST(28)*V(78)
          V( 31 )=(sum( 31 )+gdt*P_VAR( 31 ))/(1.0+gdt*D_VAR( 31 ))

      P_VAR(26) = 1.327e-12*V(80)*V(84)
      D_VAR(26) = 0.02013
          V( 26 )=(sum( 26 )+gdt*P_VAR( 26 ))/(1.0+gdt*D_VAR( 26 ))

      P_VAR(80) = RCONST(2)*V(74)*V(76)+2*RCONST(4)*V(76)*V(84)
     *           +0.02013*V(26)+RCONST(7)*V(80)*V(84)
     *           +0.85*RCONST(8)*V(84)+RCONST(14)*V(57)
     *           +RCONST(19)*V(76)*V(77)+0.02313*V(31)
     *           -4e-24*V(80)*F(1)+RCONST(27)*V(31)
     *           +RCONST(28)*V(31)*V(78)+RCONST(34)*V(37)*V(76)
     *           +RCONST(44)*V(32)+RCONST(45)*V(72)*V(76)
     *           +RCONST(46)*V(65)*V(76)+RCONST(49)*V(51)*V(76)+0.97
     *           *RCONST(51)*V(46)*V(76)+0.9261*RCONST(53)*V(60)*V(76)
     *           +2.5*RCONST(56)*V(38)*V(76)
     *           +0.95*RCONST(66)*V(62)*V(76)
     *           +RCONST(71)*V(47)*V(76)+RCONST(73)*V(48)*V(76)
     *           +7e-12*V(76)*V(79)+7e-12*V(67)*V(76)
      P_VAR(80) = P_VAR(80)+2*RCONST(91)*V(52)*V(76)
     *           +RCONST(97)*V(44)*V(76)-0.0315*4.25e-11*V(36)*V(78)
     *           +RCONST(106)*V(25)
     *           +RCONST(107)*V(54)*V(76)+RCONST(108)*V(39)*V(76)
     *           +0.9*RCONST(115)*V(53)*V(76)
     *           +0.9*RCONST(118)*V(59)*V(76)
     *           +RCONST(122)*V(21)+0.9
     *           *RCONST(126)*V(49)*V(76)+RCONST(130)*V(22)
     *           +RCONST(131)*V(56)*V(76)+0.15*RCONST(135)*V(73)*V(74)
     *           +RCONST(136)*V(69)*V(76)+RCONST(139)*V(70)*V(76)
     *           +RCONST(142)*V(68)*V(76)+2*RCONST(149)*V(55)*V(76)
     *           +2*RCONST(153)*V(50)*V(76)+2*RCONST(157)*V(43)*V(76)
     *           +2*RCONST(176)*V(84)*V(84)+0.6*RCONST(178)*V(77)*V(84)
      D_VAR(80) = RCONST(1)+RCONST(3)*V(74)+1.327e-12*V(84)+RCONST(7)
     *           *V(84)+1.2794e-11*V(78)+1.333e-12*V(77)+4e-24*F(1)
     *           +4.7e-12*V(72)+7e-13*V(79)+7e-13*V(67)+6.8e-12*V(52)
     *           +4.7e-12*V(54)+4.7e-12*V(66)+4.7e-12*V(56)
     *           +RCONST(137)*V(69)+RCONST(140)*V(70)+RCONST(143)
     *           *V(68)+RCONST(150)*V(55)
          V( 80 )=(sum( 80 )+gdt*P_VAR( 80 ))/(1.0+gdt*D_VAR( 80 ))

      P_VAR(81) = RCONST(46)*V(65)*V(76)+0.8*RCONST(56)*V(38)*V(76)
     *           +1.4*RCONST(57)*V(65)*V(65)+2*RCONST(71)*V(47)*V(76)
     *           +RCONST(73)*V(48)*V(76)+RCONST(74)*V(40)*V(74)+0.525
     *           *RCONST(75)*V(63)*V(74)+7e-12*V(76)*V(79)
     *           +7e-13*V(79)*V(80)+2.4*5e-14*V(47)*V(47)
     *           +7e-14*V(79)*V(82)+RCONST(91)*V(52)*V(76)+0+0.9
     *           *RCONST(115)*V(53)*V(76)+0.3*RCONST(118)*V(59)*V(76)
     *           +0.9*RCONST(126)*V(49)*V(76)+RCONST(131)*V(56)*V(76)
     *           +0.5*RCONST(133)*V(64)*V(74)+0.5
     *           *RCONST(134)*V(74)*V(75)+0.65*RCONST(135)*V(73)*V(74)
     *           +RCONST(145)*V(45)+RCONST(149)*V(55)*V(76)
     *           +RCONST(153)*V(50)*V(76)+RCONST(157)*V(43)*V(76)
     *           +RCONST(173)*V(71)+0.5*1e-11*V(71)*V(78)
      D_VAR(81) = RCONST(30)+RCONST(31)+1e-11*V(78)+1e-14*V(77)+6e-16
     *           *V(84)+1.36e-14*V(79)+1.36e-14*V(67)
          V( 81 )=(sum( 81 )+gdt*P_VAR( 81 ))/(1.0+gdt*D_VAR( 81 ))

      P_VAR(82) = 8.3e-12*V(18)*V(78)
      D_VAR(82) = 1e-20*V(78)+7e-14*V(79)+7e-14*V(67)+7e-14*V(69)
     *           +7e-14*V(70)+7e-14*V(68)
          V( 82 )=(sum( 82 )+gdt*P_VAR( 82 ))/(1.0+gdt*D_VAR( 82 ))

      P_VAR(83) = RCONST(49)*V(51)*V(76)+0.46*RCONST(51)*V(46)*V(76)
     *           +1.0482*RCONST(53)*V(60)*V(76)
     *           +2.1*RCONST(56)*V(38)*V(76)+1.6*5e-14*V(51)*V(51)
     *           +1.9*5e-14*V(46)*V(46)
     *           +0.94*RCONST(66)*V(62)*V(76)+RCONST(73)*V(48)*V(76)
     *           +0.5*RCONST(75)*V(63)*V(74)+7e-12*V(67)*V(76)
     *           +7e-13*V(67)*V(80)+0.4
     *           *5e-14*V(47)*V(47)+2.2*5e-14*V(48)*V(48)
     *           +7e-14*V(67)*V(82)+RCONST(91)*V(52)*V(76)
     *           +0.15*RCONST(134)*V(74)*V(75)
      D_VAR(83) = RCONST(39)*V(78)+2.7e-15*V(84)+RCONST(41)+RCONST(42)
     *           +1.36e-14*V(79)+1.36e-14*V(67)
          V( 83 )=(sum( 83 )+gdt*P_VAR( 83 ))/(1.0+gdt*D_VAR(83  ))

      P_VAR(14) = 0
      D_VAR(14) = 1.03e-15*V(74)
          V( 14 )=(sum( 14 )+gdt*P_VAR( 14 ))/(1.0+gdt*D_VAR( 14 ))

      P_VAR(15) = 0
      D_VAR(15) = 2.16e-16*V(74)
          V( 15 )=(sum( 15 )+gdt*P_VAR( 15 ))/(1.0+gdt*D_VAR( 15 ))

      P_VAR(16) = 3.4e-18*V(70)*F(1)
      D_VAR(16) = RCONST(165)*V(78)
          V( 16 )=(sum( 16 )+gdt*P_VAR( 16 ))/(1.0+gdt*D_VAR( 16 ))

      P_VAR(63) = 0
      D_VAR(63) = RCONST(72)*V(78)+RCONST(75)*V(74)+1.26e-13*V(84)
          V( 63 )=(sum( 63 )+gdt*P_VAR( 63 ))/(1.0+gdt*D_VAR( 63 ))

      P_VAR(64) = 0
      D_VAR(64) = 8.505e-11*V(78)+RCONST(133)*V(74)+RCONST(148)*V(84)
          V( 64 )=(sum( 64 )+gdt*P_VAR( 64 ))/(1.0+gdt*D_VAR( 64 ))

      P_VAR(27) = 7.35e-12*V(76)*V(78)+4e-24*V(80)*F(1)
      D_VAR(27) = RCONST(12)
          V( 27 )=(sum( 27 )+gdt*P_VAR( 27 ))/(1.0+gdt*D_VAR( 27 ))

      P_VAR(58) = 0.3*RCONST(118)*V(59)*V(76)+RCONST(123)*V(66)*V(76)
     *           +0.9*RCONST(126)*V(49)*V(76)
     *           +0.5*RCONST(134)*V(74)*V(75)
     *           +0.5*RCONST(135)*V(73)*V(74)
     *           +RCONST(142)*V(68)*V(76)+RCONST(143)*V(68)*V(80)
     *           +0.5*RCONST(153)*V(50)*V(76)+RCONST(157)*V(43)*V(76)
      D_VAR(58) = RCONST(146)+1.7e-11*V(78)
          V( 58 )=(sum( 58 )+gdt*P_VAR( 58 ))/(1.0+gdt*D_VAR( 58 ))

      P_VAR(36) = 0.16*1.52e-11*V(24)*V(78)
      D_VAR(36) = 4.25e-11*V(78)+1e-11*V(84)
          V( 36 )=(sum( 36 )+gdt*P_VAR( 36 ))/(1.0+gdt*D_VAR( 36 ))

      P_VAR(74) = RCONST(1)*V(80)+0.85*RCONST(8)*V(84)
      D_VAR(74) = RCONST(2)*V(76)+RCONST(3)*V(80)+RCONST(10)*F(1)
     *           +RCONST(18)*V(78)+RCONST(22)*V(77)+RCONST(74)*V(40)
     *           +RCONST(75)*V(63)+RCONST(133)*V(64)+RCONST(134)*V(75)
     *           +RCONST(135)*V(73)+5.44e-17*V(11)+3.46e-17*V(12)
     *           +2.21e-17*V(13)+1.03e-15*V(14)+2.16e-16*V(15)
          V( 74 )=(sum( 74 )+gdt*P_VAR( 74 ))/(1.0+gdt*D_VAR(74  ))

      P_VAR(73) = 0.45*RCONST(115)*V(53)*V(76)
     *           +0.3*RCONST(133)*V(64)*V(74)+RCONST(139)*V(70)*V(76)
     *           +RCONST(140)*V(70)*V(80)+0.5*RCONST(149)*V(55)*V(76)
     *           +7e-14*V(70)*V(82)
      D_VAR(73) = 1.02e-11*V(78)+RCONST(125)*V(78)+RCONST(135)*V(74)
     *           +3.3e-15*V(84)+6.7e-15*V(84)
          V( 73 )=(sum( 73 )+gdt*P_VAR( 73 ))/(1.0+gdt*D_VAR( 73 ))

      P_VAR(75) = 0.45*RCONST(115)*V(53)*V(76)
     *           +0.2*RCONST(133)*V(64)*V(74)
     *           +RCONST(136)*V(69)*V(76)
     *           +RCONST(137)*V(69)*V(80)+0.5*RCONST(149)*V(55)*V(76)
     *           +7e-14*V(69)*V(82)+7e-14*V(68)*V(82)
      D_VAR(75) = RCONST(117)*V(78)+RCONST(134)*V(74)+6e-14*V(84)
          V( 75 )=(sum( 75 )+gdt*P_VAR( 75 ))/(1.0+gdt*D_VAR(75  ))

      P_VAR(11) = 0
      D_VAR(11) = 5.44e-17*V(74)
          V( 11 )=(sum( 11 )+gdt*P_VAR( 11 ))/(1.0+gdt*D_VAR( 11 ))

      P_VAR(12) = 0
      D_VAR(12) = 3.46e-17*V(74)
          V( 12 )=(sum( 12 )+gdt*P_VAR( 12 ))/(1.0+gdt*D_VAR( 12 ))

      P_VAR(13) = 0
      D_VAR(13) = 2.21e-17*V(74)
          V( 13 )=(sum( 13 )+gdt*P_VAR( 13 ))/(1.0+gdt*D_VAR( 13 ))

      P_VAR(17) = 3.4e-18*V(68)*F(1)
      D_VAR(17) = 5e-14*V(78)
          V( 17 )=(sum( 17 )+gdt*P_VAR( 17 ))/(1.0+gdt*D_VAR( 17 ))

      P_VAR(18) = 0
      D_VAR(18) = 8.3e-12*V(78)
          V( 18 )=(sum( 18 )+gdt*P_VAR( 18 ))/(1.0+gdt*D_VAR( 18 ))

      P_VAR(19) = 0
      D_VAR(19) = RCONST(48)*V(78)
          V( 19 )=(sum( 19 )+gdt*P_VAR( 19 ))/(1.0+gdt*D_VAR( 19 ))

      P_VAR(20) = 0
      D_VAR(20) = RCONST(50)*V(78)
          V( 20 )=(sum( 20 )+gdt*P_VAR( 20 ))/(1.0+gdt*D_VAR( 20 ))

      P_VAR(21) = 4.7e-12*V(66)*V(80)
      D_VAR(21) = RCONST(122)
          V( 21 )=(sum( 21 )+gdt*P_VAR( 21 ))/(1.0+gdt*D_VAR(  21))

      P_VAR(22) = 4.7e-12*V(56)*V(80)
      D_VAR(22) = RCONST(130)
          V( 22 )=(sum( 22 )+gdt*P_VAR( 22 ))/(1.0+gdt*D_VAR( 22 ))

      P_VAR(23) = 5.816e-12*V(77)*V(77)
      D_VAR(23) = RCONST(24)+1.57e-12*V(78)
          V( 23 )=(sum( 23 )+gdt*P_VAR( 23 ))/(1.0+gdt*D_VAR(23  ))

      P_VAR(24) = 0
      D_VAR(24) = 1.52e-11*V(78)
          V( 24 )=(sum( 24 )+gdt*P_VAR( 24 ))/(1.0+gdt*D_VAR( 24 ))

      P_VAR(25) = 4.7e-12*V(54)*V(80)
      D_VAR(25) = RCONST(106)
          V( 25 )=(sum( 25 )+gdt*P_VAR( 25 ))/(1.0+gdt*D_VAR( 25 ))

      P_VAR(28) = 0.263*RCONST(53)*V(60)*V(76)
     *          +0.05*RCONST(66)*V(62)*V(76)
      D_VAR(28) = 2e-12*V(78)
          V( 28 )=(sum( 28 )+gdt*P_VAR( 28 ))/(1.0+gdt*D_VAR( 28 ))

      P_VAR(29) = RCONST(42)*V(83)+0.06*RCONST(74)*V(40)*V(74)
      D_VAR(29) = 6.35e-15*V(78)
          V( 29 )=(sum( 29 )+gdt*P_VAR( 29 ))/(1.0+gdt*D_VAR( 29 ))

      P_VAR(30) = 0
      D_VAR(30) = RCONST(52)*V(78)+4e-17*V(84)
          V( 30 )=(sum( 30 )+gdt*P_VAR( 30 ))/(1.0+gdt*D_VAR( 30 ))

      P_VAR(32) = 4.7e-12*V(72)*V(80)
      D_VAR(32) = RCONST(44)+RCONST(177)*V(78)
          V( 32 )=(sum( 32 )+gdt*P_VAR( 32 ))/(1.0+gdt*D_VAR( 32 ))

      P_VAR(33) = RCONST(34)*V(37)*V(76)+2e-12*V(37)*V(77)
     *            +1e-13*V(37)*V(37)+4e-18*V(79)*F(1)
      D_VAR(33) = 3.2e-13*V(78)
          V( 33 )=(sum( 33 )+gdt*P_VAR( 33 ))/(1.0+gdt*D_VAR( 33 ))

      P_VAR(34) = RCONST(97)*V(44)*V(76)
      D_VAR(34) = 2.8e-11*V(78)+RCONST(109)
          V( 34 )=(sum( 34 )+gdt*P_VAR( 34 ))/(1.0+gdt*D_VAR( 34 ))

      P_VAR(35) = 0.18*RCONST(97)*V(44)*V(76)
     *           +0.89*RCONST(107)*V(54)*V(76)
      D_VAR(35) = RCONST(98)+1.15e-11*V(78)
          V( 35 )=(sum( 35 )+gdt*P_VAR( 35 ))/(1.0+gdt*D_VAR( 35 ))

      P_VAR(40) = 0
      D_VAR(40) = RCONST(70)*V(78)+RCONST(74)*V(74)
           V( 40 )=(sum( 40 )+gdt*P_VAR( 40 ))/(1.0+gdt*D_VAR( 40 ))
 
      P_VAR(41) = RCONST(30)*V(81)+RCONST(31)*V(81)
     *           +1e-11*V(78)*V(81)+6e-16*V(81)*V(84)
     *           +RCONST(41)*V(83)+RCONST(42)*V(83)
     *           +0.42*RCONST(74)*V(40)*V(74)+2
     *           *1.15e-11*V(35)*V(78)+RCONST(100)*V(42)
     *           +1.73e-11*V(42)*V(78)
      D_VAR(41) = 2.22e-13*V(78)
           V( 41 )=(sum( 41 )+gdt*P_VAR( 41 ))/(1.0+gdt*D_VAR( 41 ))

      P_VAR(42) = 3e-12*V(62)*V(77)+0.72*RCONST(97)*V(44)*V(76)
     *          +0.11*RCONST(107)*V(54)*V(76)
      D_VAR(42) = RCONST(100)+1.73e-11*V(78)
          V( 42 )=(sum( 42 )+gdt*P_VAR( 42 ))/(1.0+gdt*D_VAR( 42 ))
 
      P_VAR(49) = RCONST(125)*V(73)*V(78)
      D_VAR(49) = RCONST(126)*V(76)+3e-12*V(77)
         V( 49 )=(sum( 49 )+gdt*P_VAR( 49 ))/(1.0+gdt*D_VAR( 49 ))

      P_VAR(50) = 6e-14*V(75)*V(84)
      D_VAR(50) = RCONST(153)*V(76)+3e-12*V(77)
         V( 50 )=(sum( 50 )+gdt*P_VAR( 50 ))/(1.0+gdt*D_VAR( 50 ))

      P_VAR(57) = 0+1.2794e-11*V(78)*V(80)+2*0+4e-24*V(80)*F(1)
     *           +6e-16*V(81)*V(84)+2.7e-15*V(83)*V(84)
     *           +4e-17*V(30)*V(84)+7e-16*V(61)*V(84)
     *           +1e-11*V(36)*V(84)+3.3e-15*V(73)*V(84)
     *           +5.2e-16*V(45)*V(84)+0.4*RCONST(178)*V(77)*V(84)
      D_VAR(57) = RCONST(14)+1.629e-13*V(78)
         V( 57 )=(sum( 57 )+gdt*P_VAR( 57 ))/(1.0+gdt*D_VAR( 57 ))
 
      P_VAR(71) = 3e-12*V(65)*V(77)+3e-12*V(51)*V(77)
     *           +3e-12*V(46)*V(77)+3e-12*V(60)*V(77)
     *           +3e-12*V(72)*V(77)+3e-12*V(47)*V(77)
     *           +3e-12*V(48)*V(77)+4e-12*V(44)*V(77)
     *           +4e-12*V(54)*V(77)+1e-12*V(39)*V(77)
     *           +3e-12*V(53)*V(77)
     *           +3e-12*V(59)*V(77)+3e-12*V(66)*V(77)
     *           +3e-12*V(49)*V(77)+3e-12*V(56)*V(77)
     *           +3e-12*V(70)*V(77)+3e-12*V(69)*V(77)
      D_VAR(71) = RCONST(173)+1e-11*V(78)
        V( 71 )=(sum( 71 )+gdt*P_VAR( 71 ))/(1.0+gdt*D_VAR( 71 ))


      P_VAR(1) = 1e-20*V(78)*V(82)+7e-14*V(79)*V(82)
     *          +7e-14*V(67)*V(82)+7e-14*V(69)*V(82)
     *          +7e-14*V(70)*V(82)+7e-14*V(68)*V(82)
      D_VAR(1) = 0
        V( 1 )=(sum( 1 )+gdt*P_VAR( 1 ))/(1.0+gdt*D_VAR( 1 ))

      P_VAR(2) = 4e-18*V(67)*F(1)
      D_VAR(2) = 0
        V( 2 )=(sum( 2 )+gdt*P_VAR( 2 ))/(1.0+gdt*D_VAR( 2 ))

      P_VAR(3) = 0.03*RCONST(51)*V(46)*V(76)
      D_VAR(3) = 0
        V( 3 )=(sum( 3 )+gdt*P_VAR( 3 ))/(1.0+gdt*D_VAR( 3 ))

      P_VAR(4) = 0.11*5.44e-17*V(11)*V(74)
      D_VAR(4) = 0
        V( 4 )=(sum( 4 )+gdt*P_VAR( 4 ))/(1.0+gdt*D_VAR( 4 ))

      P_VAR(5) = 0.19*3.46e-17*V(12)*V(74)+0.39*1.03e-15*V(14)*V(74)
      D_VAR(5) = 0
        V( 5 )=(sum( 5 )+gdt*P_VAR( 5 ))/(1.0+gdt*D_VAR( 5 ))

      P_VAR(6) = 0.15*2.21e-17*V(13)*V(74)+0.15*2.16e-16*V(15)*V(74)
      D_VAR(6) = 0
        V( 6 )=(sum( 6 )+gdt*P_VAR(6  ))/(1.0+gdt*D_VAR( 6 ))

      P_VAR(7) = 6.8e-12*V(52)*V(80)
      D_VAR(7) = 0
        V( 7 )=(sum( 7 )+gdt*P_VAR( 7 ))/(1.0+gdt*D_VAR( 7 ))

      P_VAR(8) = 3e-12*V(52)*V(77)
      D_VAR(8) = 0
        V( 8 )=(sum( 8 )+gdt*P_VAR( 8 ))/(1.0+gdt*D_VAR( 8 ))

      P_VAR(9) = 1.36e-14*V(79)*V(81)+1.36e-14*V(79)*V(83)
     *           +1.36e-14*V(67)*V(81)+1.36e-14*V(67)*V(83)
      D_VAR(9) = 0
        V( 9 )=(sum( 9 )+gdt*P_VAR( 9 ))/(1.0+gdt*D_VAR( 9 ))

      P_VAR(10) = 8.3e-12*V(18)*V(78)
      D_VAR(10) = 0
          V( 10 )=(sum( 10 )+gdt*P_VAR( 10 ))/(1.0+gdt*D_VAR( 10 ))

      RETURN
      END

C End of FSPLIT_VAR function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'split.h'


      INTEGER i
      REAL*8 x

      x = (1.0E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.0E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.0E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do

      VAR(24) = (20.0)*CFACTOR
      VAR(27) = (1.0)*CFACTOR
      VAR(30) = (50.0)*CFACTOR
      VAR(32) = (1.0)*CFACTOR
      VAR(40) = (10.0)*CFACTOR
      VAR(41) = (300.0)*CFACTOR
      VAR(63) = (10.0)*CFACTOR
      VAR(64) = (10.0)*CFACTOR
      VAR(74) = (100.0)*CFACTOR
      VAR(76) = (50.0)*CFACTOR
      VAR(80) = (20.0)*CFACTOR
      VAR(81) = (10.0)*CFACTOR
      VAR(83) = (10)*CFACTOR
      FIX(1) = (2.0e+8)*CFACTOR
      FIX(2) = (5.1E+9)*CFACTOR
      FIX(3) = (5.E+7)*CFACTOR
      FIX(4) = (500)*CFACTOR

      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do

C User defined initialisations                                     

C End user defined initialisations                                 

      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'split.h'

      REAL*8 SunRise, SunSet
      REAL*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'split.h'


      REAL*8 ARR, A, B
      ARR(A,B) = A * EXP(B/TEMP)

      RCONST(1) = (9.236E-3*SUN)
      RCONST(2) = (ARR(2.2E-12,-1430))
      RCONST(3) = (ARR(1.2E-13,-2450))
      RCONST(4) = (ARR(1.7E-11,150))
      RCONST(7) = (ARR(2.5E-14,-1230))
      RCONST(8) = (3.039E-2*SUN)
      IF (IS_URBAN.EQ.1) THEN
        RCONST(10) = (1.1E-20*RCONST(1))
      ELSE IF  (IS_URBAN.EQ.0) THEN 
        RCONST(10) = (2.1E-21*RCONST(1))
      END IF  
      RCONST(12) = (1.893E-3*SUN)
      RCONST(14) = (6.684E-7*SUN)
      RCONST(18) = (ARR(1.6E-12,-1000))
      RCONST(19) = (ARR(3.7E-12,240))
      RCONST(22) = (ARR(1.4E-14,-600))
      RCONST(24) = (7.829E-6*SUN)
      RCONST(27) = (1.11E-5*SUN)
      RCONST(28) = (ARR(1.3E-12,380))
      RCONST(30) = (1.569E-5*SUN)
      RCONST(31) = (6.063E-5*SUN)
      RCONST(34) = (ARR(4.2E-12,180))
      RCONST(39) = (ARR(6.9E-12,250))
      RCONST(41) = (2.383E-6*SUN)
      RCONST(42) = (6.063E-5*SUN)
      RCONST(44) = (ARR(2.2E+16,-13435))
      RCONST(45) = (ARR(4.2E-12,180))
      RCONST(46) = (ARR(4.2E-12,180))
      RCONST(48) = (ARR(1.7E-11,-1232))
      RCONST(49) = (ARR(4.2E-12,180))
      RCONST(50) = (ARR(1.18E-11,-679))
      RCONST(51) = (ARR(4.2E-12,180))
      RCONST(52) = (ARR(2E-11,-500))
      RCONST(53) = (ARR(4.2E-12,180))
      RCONST(56) = (ARR(4.2E-12,180))
      RCONST(57) = (ARR(1.5E-13,220))
      RCONST(65) = (ARR(1.2E-11,-890))
      RCONST(66) = (ARR(4.2E-12,180))
      RCONST(67) = (2.401E-6*SUN)
      RCONST(70) = (ARR(1.66E-12,474))
      RCONST(71) = (ARR(4.2E-12,180))
      RCONST(72) = (ARR(4.1E-12,537))
      RCONST(73) = (ARR(4.2E-12,180))
      RCONST(74) = (ARR(1.2E-14,-2633))
      RCONST(75) = (ARR(7.8E-14,-2105))
      RCONST(91) = (ARR(4.2E-12,180))
      RCONST(97) = (ARR(4.2E-12,180))
      RCONST(98) = (7.389E-5*SUN)
      RCONST(100) = (1.755E-4*SUN)
      RCONST(106) = (ARR(2.2E+16,-13435))
      RCONST(107) = (ARR(4.2E-12,180))
      RCONST(108) = (ARR(4.2E-12,180))
      RCONST(109) = (9.236E-5*SUN)
      RCONST(115) = (ARR(4.2E-12,180))
      RCONST(117) = (ARR(3.0E-12,500))
      RCONST(118) = (ARR(4.2E-12,180))
      RCONST(122) = (ARR(2.2E+16,-13435))
      RCONST(123) = (ARR(4.2E-12,180))
      RCONST(125) = (ARR(3.86E-12,500))
      RCONST(126) = (ARR(4.2E-12,180))
      RCONST(130) = (ARR(2.2E+16,-13435))
      RCONST(131) = (ARR(4.2E-12,180))
      RCONST(133) = (ARR(7.0E-15,-1900))
      RCONST(134) = (ARR(4.0E-15,-2000))
      RCONST(135) = (ARR(4.4E-15,-2500))
      RCONST(136) = (ARR(4.2E-12,180))
      RCONST(137) = (ARR(4.2E-13,180))
      RCONST(139) = (ARR(4.2E-12,180))
      RCONST(140) = (ARR(4.2E-13,180))
      RCONST(142) = (ARR(4.2E-12,180))
      RCONST(143) = (ARR(4.2E-13,180))
      RCONST(145) = (4.618E-6*SUN)
      RCONST(146) = (1.385E-3*SUN)
      RCONST(148) = (ARR(3.00E-12,-450))
      RCONST(149) = (ARR(4.2E-12,180))
      RCONST(150) = (ARR(4.2E-13,180))
      RCONST(153) = (ARR(4.2E-12,180))
      RCONST(157) = (ARR(4.2E-12,180))
      RCONST(165) = (ARR(1.2E-11,500))
      RCONST(172) = (ARR(4.6E-11,230))
      RCONST(173) = (4.618E-6*SUN)
      RCONST(176) = (ARR(8.5E-13,-2450))
      RCONST(177) = (ARR(1.23E-12,-651))
      RCONST(178) = (ARR(2.3E-12,170))
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 



      subroutine TWOSTEP(n,t,te,dt,dtmin,dtmax,
     +                   yold,y,ynew,yp,yl,work,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart,startdt)
      implicit real*8(a-h,o-z)
      integer	 n,method,numit,nfcn,naccpt,nrejec,nstart,i,j
      real*8	 t,te,dt,dtmin,dtmax,startdt,ytol,
     +           ratio,dtold,a1,a2,c,cp1,dtg,errlte,dy
      real*8       yold(n),y(n),ynew(n),yp(n),yl(n),
     +           work(n),sum(n),atol(n),rtol(n)
      logical 	 accept,failer,restart

c======================================================================
c
c     AUTHOR: Jan Verwer, Centre for Mathematics and Computer Science 
c(CWI), Kruislaan 413, 1098 SJ Amsterdam, The Netherlands
c
c     EMAIL ADDRESS: janv@cwi.nl
c
c----------------------------------------------------------------------
c
c     VERSION: November 1994 / 2
c
c----------------------------------------------------------------------
c
c     PURPOSE: TWOSTEP is designed for the numerical solution of
c     stiff ODE systems
c
c	dy(t)/dt = yp(t,y) - yl(y,t)*y(t)
c
c     originating from atmospheric chemistry. Its underlying integration
c     method is the implicit, 2-nd order, 2-step BDF formula. A simple 
c     explicit Gauss-Seidel technique is used for approximating the 
c     implicitly defined BDF solutions, rather than the usual modified 
c     Newton method [1,2]. By this approach TWOSTEP is explicit, whereas
c     the excellent stability of the BDF method is maintained. Also the
c     Jacobi technique may be appropriate. In general, however, its use
c     generally decreases the stability of TWOSTEP and hence also the
c     efficiency.
c
c     While in the prototype solver discussed in [1] the number of 
c     iterations is determined by a convergence criterion, TWOSTEP 
c     works with a fixed, a priori given number of iterations. This
c     leads to a somewhat simpler code and in various experiments
c     this more simple strategy has turned out to be as efficient as 
c     the iteration strategy [2]. In fact, TWOSTEP may work well with
c     only a few iterations per integration step. In this situation
c     TWOSTEP has a workload comparable to explicit solvers based
c     on the quasi-steady-state-approach(QSSA) [3]. Note that when
c     a few Gauss-Seidel iterations are used, the order of the components
c     generally will influence the accuracy. To our experience this
c     influence is minor.
c 
c     [1] J.G. Verwer, Gauss-Seidel iteration for stiff ODEs from
c     chemical kinetics, SIAM Journal on Scientific Computing 15,
c     1243 - 1250, 1994.
c
c     [2] J.G. Verwer & D. Simpson, A comparison between two explicit
c     methods for stiff ODEs from atmospheric chemistry. Report
c     NM-R9414, CWI, Amsterdam, 1994(to appear in Appl. Numer. Math.).
c
c     [3] J.G. Verwer & M. van Loon,  An evaluation of explicit pseudo-
c     steady-state approximation schemes for stiff ODE systems from
c     chemical kinetics, J. Comput. Phys. 113, 347 - 352, 1994.
c
c----------------------------------------------------------------------
c
c     MEANING OF PARAMETERS:
c
c     n       - Integer. Number of components.
c     t	      - Real. The independent variable time.
c     te      - Real. The endpoint of time.
c     dt      - Real. The stepsize.
c     dtmin   - Real. A minimum for dt.
c     dtmax   - Real. A maximum for dt.
c     yold    - Real array(n). Solution at previous time point.
c     y       - Real array(n). Solution at current time point.
c     ynew    - Real array(n). Solution at forward time point.
c     yp      - Real array(n). Storage for the production term.
c     yl      - Real array(n). Storage for the loss term.
c     work    - Real array(n). Workarray. Only used by ITER.
c     sum     - Real array(n). Workarray for the BDF2 method.
c     atol    - Real array(n). Absolute tolerances.
c     rtol    - Real array(n). Relative tolerances.
c     method  - Integer. Determines whether Gauss-Seidel or Jacobi
c               iteration is used; method only occurs as parameter
c               of subroutine ITER.
c     numit   - Integer. Number of Gauss-Seidel or Jacobi iterations.
c     nfcn    - Integer. The total number of(function) calls of ITER.
c     naccpt  - Integer. The number of accepted integration steps.
c     nrejec  - Integer. The number of rejected integration steps.
c     nstart  - Integer. The number of restarts + 1.
c     startdt - Real. The last computed starting stepsize.
c
c----------------------------------------------------------------------
c
c     STORAGE: 9 real*8 arrays of dimension n.
c
c----------------------------------------------------------------------
c
c     INPUT:      
c
c     n	      - Number of components.
c     t       - Initial time; t is changed.
c     te      - The endpoint of time.
c     dtmin   - The minimal stepsize that TWOSTEP is allowed to use. 
c     dtmax   - The maximal stepsize that TWOSTEP is allowed to use. 
c
c               If on input dtmin = dtmax, then dt:=dtmin and dt is kept
c               fixed throughout the integration, possibly except for
c               the final step where dt may be adjusted to precisely hit
c               the end point te. So, the length of the interval need not be
c               an integer multiple of the selected stepsize.
c
c               If dtmin = dtmax, the stepsize control is switched off.
c               The user thus should ascertain that the integration
c               process remains stable for the selected stepsize. 
c
c               If dtmax > dtmin, then stepsize control is carried out
c               and TWOSTEP determines an initial stepsize itself. However,
c               the control and the initial stepsize selection can be
c               overruled to satisfy the constraint dtmin <= dt <= dtmax.
c
c     y       - Initial solution vector; y is changed.
c     atol    - Absolute tolerances.
c     rtol    - Relative tolerances.
c     method  - method = 0 for the Gauss-Seidel technique.
c               method = 1 for the Jacobi technique.
c
c               The Gauss-Seidel technique is recommended. The user 
c               must program the selected technique in his own
c               subroutine ITER which defines also the ODE system
c           (see below for an example).
c
c     numit   - The number of Gauss-Seidel(or Jacobi iterations) used
c               per time step. This number thus is a priori described
c               for the whole integration. A low number is recommended
c               for Gauss-Seidel iteration [1,2].
c
c               Note that for the Gauss-Seidel technique the order of 
c               the components within ITER will play a role. It is
c               recommended to order the components in decreasing
c               of the loss rates for the very short living species
c               like the radicals. 
c
c----------------------------------------------------------------------
c
c     OUTPUT:      
c
c     t       - t = te.
c     dtold   - The last stepsize value used when working with
c		variable stepsizes.
c     dt      - The last stepsize used to hit the endpoint te
c               when working with constant stepsizes.
c     y       - The computed solution at t = te.
c     nfcn, naccpt, nrejec, nstart, startdt - See MEANING of parameters.
c
c----------------------------------------------------------------------
c
c     SUBROUTINES:
c
c     TWOSTEP calls three subroutines, viz. NEWDT, FIT and ITER. Only
c     subroutine ITER is to be defined by the user.
c
c     NEWDT  - Computes the new stepsize. NEWDT itself calls FIT.
c     FIT    - May adjust dt to guarantee that the remainder
c              of the integration interval is an integer multiple of
c              the current stepsize. The adjustment is carried as soon 
c              as(te-t)/dt <= 10.0. Hence the adjustment may lead to
c              a stepsize smaller than dtmin for approximately
c              ten integration steps.
c     ITER   - A user defined routine for the ODE system. Within ITER
c              also the Gauss-Seidel or Jacobi technique is to be 
c              implemented by the user, as exemplified below:
c
c              subroutine ITER(t,method,n,y,sum,gdt,yp,yl,work)
c              integer    method,n,i,
c              real*8       t,y(n),sum(n),gdt,yp(n),yl(n),work(n)
c
c              if(method.eq.0) then
c              --------------------------------------------------
c              The following statements show how to program the
c              Gauss-Seidel technique. Note that array y is
c              changed. The ispec integers define the order
c              in which the components are processed.       
c              -------------------------------------------------
c              i=ispec1
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              i=ispe 
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              etcetera
c           
c              else if(method.eq.1) then
c              ------------------------------------------------
c              This shows how to implement the Jacobi technique.
c              Now the order of the components is irrelevant.
c              Note that again y is changed, but only in the
c              second do-loop.
c              ------------------------------------------------
c              for i=1,n
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              enddo
c
c              for i=1,n
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c              enddo
c              endif
c              end of ITER
c
c----------------------------------------------------------------------
c
c     EXAMPLE PROGRAM:
c
c     Example program for a 4-species problem based on the three 
c     basic reactions
c
c     	NO2 + hv  ->(k1)  NO + O,  
c       O   + O2  ->(k2)  O3,
c       O3  + NO  ->(k3)  O2 + NO2.
c
c     Here, O = O(3P). Because the first reaction is photochemical
c     k1 depends on the time of the day. Sunrise is at 04.00 hours
c     and sunset at 20.00 hours. NO is emitted. Unit is mol./cm3.
c     Time is in sec. The reaction constants are defined in ITER,
c     like the components yp(i) of the production term and the
c     components yl(i) of the loss term. The integration interval
c     is [14400,417600]. Time=14400 sec. coincides with sunrise at day
c     one and time=417600 sec. coincides with sunset at day five.
c     Below, y(1)=O, y(2)=NO, y(3)=NO2 and y(4)=O3. Output is given
c     in hours at every 2 hours of the last 24 hours. 
c    
c      program    small chemistry
c      integer	  n,numit,nfcn,naccpt,nrejec,nstart,method,
c     +           i,itimeh,i24hrs,inhr
c      real*8  	  time,te,dt,dtmin,dtmax,startdt,timeh,timeod
c      parameter(n=4)
c      real*8       yold(n),y(n),ynew(n),yp(n),yl(n),atol(n),rtol(n),
c     +  	  work(n),sum(n)
c      external   ITER
c      time=14400.0
c      method=0
c      y(1)=0.0
c      y(2)=1.3e+08
c      y(3)=5.0e+11
c      y(4)=8.0e+11
c      numit=2
c      dtmin=1.0
c      dtmax=900.0
c      do 10 i=1,4
c       atol(i)=1.0
c       rtol(i)=1.0e-3
c   10 continue
c
cc     begin two hourly calculations 
c      do 40 inhr = 1,56
c       te = time + 7200.
c       call TWOSTEP(n,time,te,dt,dtmin,dtmax,
c    +              yold,y,ynew,yp,yl,work,sum,
c     +              atol,rtol,method,numit,
c     +              nfcn,naccpt,nrejec,nstart,startdt)
c       if(inhr.gt.43) then
c        timeh=time/3600
c        itimeh=timeh
c        i24hrs=itimeh/24+1
c        timeod=timeh-(i24hrs-1)*24
c        write(6,30) timeod,y(1),y(2),y(3),y(4)
c   30   format('      Hour = 'f5.2,'   Solution = '4(e9.4,'  '))
c       endif
c   40 continue
c      end
c
c      subroutine ITER(time,method,n,y,sum,gdt,yp,yl,v)
c      integer    method,n
c      real*8	  time,gdt,y(n),sum(n),yp(n),yl(n),v(n)
c      integer    i,itimeh,i24hrs
c      real*8       timeh,timeod,pi,k1,k2,k3,a,b,source,sec
c      logical    night
c
c      timeh=time/3600.0    
c      itimeh=timeh   
c      i24hrs=itimeh/24+1   
c      timeod=timeh-(i24hrs-1)*24.0  
c      pi=4.0*atan(1.0)   
c      sec=(sin((pi/16.0)*(timeod-4.0)))**0.2
c      a=.00001
c      b=-7.0
c      k2=1.0e+05
c      k3=1.0e-16
c      source=1.0e+06
c      night=(timeod.le.4.0.or.timeod.gt.20.0)
c      if(night) then
c       k1=1.0e-40
c      else
c       k1=a*exp(-b*sec)
c      endif
c
c      yp(1)=k1*y(3)
c      yl(1)=k2
c      i=1
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(2)=k1*y(3)+source
c      yl(2)=k3*y(4)
c      i=2
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(3)=k3*y(2)*y(4)
c      yl(3)=k1
c      i=3
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(4)=k2*y(1)
c      yl(4)=k3*y(2)
c      i=4
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      end
c
c      The output of this example program reads:
c
c      Hour = 20.00   Solution = .1503E+02  .6666E+12  .1503E+12  .1150E+13  
c      Hour = 22.00   Solution = .4837E-33  .3404E+12  .4837E+12  .8162E+12  
c      Hour =  0.00   Solution = .6255E-33  .2058E+12  .6255E+12  .6744E+12  
c      Hour =  2.00   Solution = .7022E-33  .1363E+12  .7022E+12  .5977E+12  
c      Hour =  4.00   Solution = .7495E-33  .9618E+11  .7495E+12  .5504E+12  
c      Hour =  6.00   Solution = .1090E+04  .8191E+12  .3378E+11  .1266E+13  
c      Hour =  8.00   Solution = .1095E+04  .8442E+12  .1596E+11  .1284E+13  
c      Hour = 10.00   Solution = .1106E+04  .8561E+12  .1126E+11  .1289E+13  
c      Hour = 12.00   Solution = .1115E+04  .8644E+12  .1016E+11  .1290E+13  
c      Hour = 14.00   Solution = .1118E+04  .8703E+12  .1138E+11  .1288E+13  
c      Hour = 16.00   Solution = .1109E+04  .8728E+12  .1616E+11  .1284E+13  
c      Hour = 18.00   Solution = .1051E+04  .8636E+12  .3256E+11  .1267E+13  
c      Hour = 20.00   Solution = .1650E+02  .7383E+12  .1650E+12  .1135E+13  
c
c--------------------------------------------------------------------------
c
c     Initialization of counters, etc.

      naccpt=0
      nrejec=0
      nfcn=0
      nstart=0
      failer=.false.
      restart=.false.
      accept=.true.

c     Initial stepsize computation. 
    
   10 if(dtmin.eq.dtmax) then
       nstart=1
       dt=min(dtmin,(te-t)/2)
       goto 28
      endif
c start
      goto 25
c start
      call ITER(t,method,n,y,y,0.0D0,yp,yl,work)
      nfcn=nfcn+1
      dt=te-t
      do 20 i=1,n
       ytol=atol(i)+rtol(i)*abs(y(i))
       dy=yp(i)-y(i)*yl(i)
       if(dy.ne.0.0) dt=min(dt,ytol/abs(dy))
   20 continue
   25 nstart=nstart+1
c start: dtstart given in calling sequence
      if (.not.restart) dt = startdt
c start
      if(restart) dt=dt/10.0
      restart=.true.
      dt=max(dtmin,min(dt,dtmax))
      call FIT(t,te,dt)
      dt=min(dt,(te-t)/2)
c start
c      startdt=dt
c start


c     The starting step is carried out, using the implicit Euler method.

   28 do 30 i=1,n
       ynew(i)=y(i)
       yold(i)=y(i)
       sum(i)=y(i)
   30 continue
      do 40 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dt,yp,yl,work)
       nfcn=nfcn+1
   40 continue
      naccpt=naccpt+1
      t=t+dt
      do 50 j=1,n
       y(j)=ynew(j)
   50 continue

c     Subsequent steps are carried out with the two-step BDF method.

      dtold=dt
      ratio=1.0
   60 continue
      c=1.0/ratio
      cp1=c+1.0
      a1=((c+1.0)**2)/(c*c+2.0*c)
      a2=-1.0/(c*c+2.0*c)
      dtg=dt*(1.0+c)/(2.0+c)
      do 70 j=1,n
       sum(j)=a1*y(j)+a2*yold(j)
       ynew(j)=max(0.0,y(j)+ratio*(y(j)-yold(j)))
   70 continue
      do 80 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dtg,yp,yl,work)
       nfcn=nfcn+1
   80 continue

c     If stepsizes should remain equal, stepsize control is omitted.

      if(dtmin.eq.dtmax) then
       t=t+dtold
       naccpt=naccpt+1
       do 85 j=1,n
        yold(j)=y(j)
        y(j)=ynew(j)
   85  continue
       if(dt.ne.dtold) then
	t=t-dtold+dt
	goto 120
       endif
       dt=min(dtold,te-t)
       ratio=dt/dtold
       if(t.ge.te) goto 120
       goto 60
      endif

c     Otherwise stepsize control is carried out.

      errlte=0.0
      do 90 i=1,n
       ytol=atol(i)+rtol(i)*abs(y(i))
       errlte=max(errlte,abs(c*ynew(i)-cp1*y(i)+yold(i))/ytol)
   90 continue
      errlte=2.0*errlte/(c+c*c)
      call NEWDT(t,te,dt,dtold,ratio,errlte,accept,
     +           dtmin,dtmax)

c     Here the step has been accepted. 

      if(accept) then
       failer=.false.
       restart=.false.
       t=t+dtold
       naccpt=naccpt+1
       do 100 j=1,n
	yold(j)=y(j)
	y(j)=ynew(j)
  100  continue
       if(t.ge.te) goto 120
       goto 60
      endif

c     A restart check is carried out.
      
      if(failer) then
       nrejec=nrejec+1
       failer=.false.
       naccpt=naccpt-1
       t=t-dtold
       do 110 j=1,n
        y(j)=yold(j)
  110  continue
       goto 25
      endif

c     Here the step has been rejected.

      nrejec=nrejec+1
      failer=.true.
      goto 60
      
c     End of TWOSTEP.
  120 end
c=====================================================================

      subroutine NEWDT(t,te,dt,dtold,ratio,errlte,
     +                 accept,dtmin,dtmax)
      implicit real*8(a-h,o-z)
      real*8    t,te,dt,dtold,ratio,errlte,ts,dtmin,dtmax
      logical accept
      if(errlte.gt.1.0.and.dt.gt.dtmin) then
       accept=.false.
       ts=t
      else
       accept=.true.
       dtold=dt
       ts=t+dtold
      endif
      dt=max(0.5,min(2.0,0.8/sqrt(errlte)))*dt
      dt=max(dtmin,min(dt,dtmax))
      call FIT(ts,te,dt)
      ratio=dt/dtold
      end

      subroutine FIT(t,te,dt)
      implicit real*8(a-h,o-z)
      real*8 	t,te,dt,rns
      integer 	ns
      rns=(te-t)/dt
      if(rns.gt.10.0) goto 10
      ns=int(rns)+1
      dt=(te-t)/ns
      dt=(dt+t)-t
   10 return
      end


