C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : sparse.h                                  
C Time                 : Thu Dec 28 17:56:42 1995                  
C Working directory    : /local/vol01/users/sandu/AMSTERDAM/TROPO/VODE
C Equation file        : sparse.k                                  
C Output root filename : sparse                                    
C                                                                  
C **************************************************************** 


      IMPLICIT REAL*8 ( A-H, K, O-Z )

C NSPEC - The number of species involved                           
      INTEGER NSPEC
      PARAMETER ( NSPEC = 88 )
C NVAR - The number of Variable species                            
      INTEGER NVAR
      PARAMETER ( NVAR = 84 )
C NVARACT - The number of Active species                           
      INTEGER NVARACT
      PARAMETER ( NVARACT = 74 )
C NRAD - The number of Radical species                             
      INTEGER NRAD
      PARAMETER ( NRAD = 1 )
C NFIX - The number of Fixed species                               
      INTEGER NFIX
      PARAMETER ( NFIX = 4 )
C NREACT - The number of reactions                                 
      INTEGER NREACT
      PARAMETER ( NREACT = 178 )
C NVARST - Starting of variables in conc. vect.                    
      INTEGER NVARST
      PARAMETER ( NVARST = 0 )
C NRADST - Starting of radicals in conc. vect.                     
      INTEGER NRADST
      PARAMETER ( NRADST = 84 )
C NFIXST - Starting of fixed in conc. vect.                        
      INTEGER NFIXST
      PARAMETER ( NFIXST = 84 )
C NONZERO_V - Number of nonzero variable elements                  
      INTEGER NONZERO_V
      PARAMETER ( NONZERO_V = 674 )
C LU_NONZERO_V - Number of nonzero variable LU elements            
      INTEGER LU_NONZERO_V
      PARAMETER ( LU_NONZERO_V = 767 )
C NONZERO_R - Number of nonzero radical elements                   
      INTEGER NONZERO_R
      PARAMETER ( NONZERO_R = 0 )
C CNVAR - (NVAR+1) The number of elements in compressed row format 
      INTEGER CNVAR
      PARAMETER ( CNVAR = NVAR + 1 )
C CNRAD - (NRAD+1) The number of elements in compressed row format 
      INTEGER CNRAD
      PARAMETER ( CNRAD = NRAD + 1 )
C NLOOKAT - number of species to look at                           
      INTEGER NLOOKAT
      PARAMETER ( NLOOKAT = 88 )
C NMONITOR - number of species to monitor                          
      INTEGER NMONITOR
      PARAMETER ( NMONITOR = 0 )
C NMASS - number of atoms to check mass balance                    
      INTEGER NMASS
      PARAMETER ( NMASS = 0 )
C NX - X grid dimension                                            
      INTEGER NX
      PARAMETER ( NX = 0 )
C NY - Y grid dimension                                            
      INTEGER NY
      PARAMETER ( NY = 0 )
C NZ - Z grid dimension                                            
      INTEGER NZ
      PARAMETER ( NZ = 0 )
C MAX_XYZ - maximum grid dimension                                 
      INTEGER MAX_XYZ
      PARAMETER ( MAX_XYZ = 0 )
C NS - number of species to transport                              
      INTEGER NS
      PARAMETER ( NS = 0 )
C PI - Value of pi                                                 
      REAL*8 PI
      PARAMETER ( PI = 3.1415926535 )

C Declaration for global variables                                 
      INTEGER IS_URBAN
      COMMON /GDATA/ IS_URBAN      
C C_DEFAULT - Default concentration for all species                
      REAL*8 C_DEFAULT(1+NSPEC)
      COMMON /GDATA/ C_DEFAULT
C C - Concentration for all species                                
      REAL*8 C(1+NSPEC)
      COMMON /GDATA/ C
C VAR - Concentration of variable species (global)                 
      REAL*8 VAR(1+NVAR)
C RAD - Concentration of radicals (global)                         
      REAL*8 RAD(1+NRAD)
C FIX - Concentration of fix species (global)                      
      REAL*8 FIX(1+NFIX)
C F - Concentration of fix species (global)                        
      REAL*8 F(1+NFIX)
      EQUIVALENCE( C(1+NVARST),VAR(1) )
      EQUIVALENCE( C(1+NRADST),RAD(1) )
      EQUIVALENCE( C(1+NFIXST),FIX(1) )
      EQUIVALENCE( C(1+NFIXST),F(1) )
C RCONST - Rate constants                                          
      REAL*8 RCONST(1+NREACT)
      COMMON /GDATA/ RCONST
C TIME - current integration time                                  
      REAL*8 TIME
      COMMON /GDATA/ TIME
C SUN - light intensity                                            
      REAL*8 SUN
      COMMON /GDATA/ SUN
C TEMP - temperature                                               
      REAL*8 TEMP
      COMMON /GDATA/ TEMP
C RTOLS - (scalar) relative tolerance                              
      REAL*8 RTOLS
      COMMON /GDATA/ RTOLS
C TSTART - integration start time                                  
      REAL*8 TSTART
      COMMON /GDATA/ TSTART
C TEND - integration end time                                      
      REAL*8 TEND
      COMMON /GDATA/ TEND
C DT - integration step                                            
      REAL*8 DT
      COMMON /GDATA/ DT
C ATOL - Absolute tolerance                                        
      REAL*8 ATOL(1+NSPEC)
      COMMON /GDATA/ ATOL
C RTOL - Relative tolerance                                        
      REAL*8 RTOL(1+NSPEC)
      COMMON /GDATA/ RTOL
C STEPMIN - minimum allowed intergation step                       
      REAL*8 STEPMIN
      COMMON /GDATA/ STEPMIN
C STEPMAX - maximum allowed integration step                       
      REAL*8 STEPMAX
      COMMON /GDATA/ STEPMAX
C CFACTOR - Conversion factor                                      
      REAL*8 CFACTOR
      COMMON /GDATA/ CFACTOR
C LOOKAT - indexes of species to look at                           
      INTEGER LOOKAT(1+88)
      COMMON /GDATA/ LOOKAT
C SLOOKAT - names of species to look at                            
      CHARACTER*8 SLOOKAT(1+88)
      COMMON /GDATA/ SLOOKAT
C MONITOR - indexes of species to monitor                          
      INTEGER MONITOR(1+1)
      COMMON /GDATA/ MONITOR
C SMONITOR - names of species to monitor                           
      CHARACTER*8 SMONITOR(1+1)
      COMMON /GDATA/ SMONITOR
C TRANS - indexes of species to transport                          
      INTEGER TRANS(1+1)
      COMMON /GDATA/ TRANS
C STRANS - names of species to transport                           
      CHARACTER*8 STRANS(1+1)
      COMMON /GDATA/ STRANS
C SMASS - names of atoms for mass balance                          
      CHARACTER*8 SMASS(1+1)
      COMMON /GDATA/ SMASS

C Indexes declaration for variable species                         

      INTEGER I_SO4
      PARAMETER ( I_SO4 = 1 )
      INTEGER I_ACTA
      PARAMETER ( I_ACTA = 2 )
      INTEGER I_R3N2
      PARAMETER ( I_R3N2 = 3 )
      INTEGER I_SUCA
      PARAMETER ( I_SUCA = 4 )
      INTEGER I_GLUA
      PARAMETER ( I_GLUA = 5 )
      INTEGER I_ADIA
      PARAMETER ( I_ADIA = 6 )
      INTEGER I_PRN2
      PARAMETER ( I_PRN2 = 7 )
      INTEGER I_PRPN
      PARAMETER ( I_PRPN = 8 )
      INTEGER I_OZID
      PARAMETER ( I_OZID = 9 )
      INTEGER I_MSA
      PARAMETER ( I_MSA = 10 )
      INTEGER I_DOL6
      PARAMETER ( I_DOL6 = 11 )
      INTEGER I_DOL7
      PARAMETER ( I_DOL7 = 12 )
      INTEGER I_DOL8
      PARAMETER ( I_DOL8 = 13 )
      INTEGER I_CPET
      PARAMETER ( I_CPET = 14 )
      INTEGER I_CHEX
      PARAMETER ( I_CHEX = 15 )
      INTEGER I_MACA
      PARAMETER ( I_MACA = 16 )
      INTEGER I_PYVA
      PARAMETER ( I_PYVA = 17 )
      INTEGER I_DMS
      PARAMETER ( I_DMS = 18 )
      INTEGER I_C2H6
      PARAMETER ( I_C2H6 = 19 )
      INTEGER I_C3H8
      PARAMETER ( I_C3H8 = 20 )
      INTEGER I_MPAN
      PARAMETER ( I_MPAN = 21 )
      INTEGER I_IPAN
      PARAMETER ( I_IPAN = 22 )
      INTEGER I_H2O2
      PARAMETER ( I_H2O2 = 23 )
      INTEGER I_AROM
      PARAMETER ( I_AROM = 24 )
      INTEGER I_TPAN
      PARAMETER ( I_TPAN = 25 )
      INTEGER I_N2O5
      PARAMETER ( I_N2O5 = 26 )
      INTEGER I_HONO
      PARAMETER ( I_HONO = 27 )
      INTEGER I_RAN2
      PARAMETER ( I_RAN2 = 28 )
      INTEGER I_CH4
      PARAMETER ( I_CH4 = 29 )
      INTEGER I_ALKA
      PARAMETER ( I_ALKA = 30 )
      INTEGER I_HNO4
      PARAMETER ( I_HNO4 = 31 )
      INTEGER I_PAN
      PARAMETER ( I_PAN = 32 )
      INTEGER I_ACO2
      PARAMETER ( I_ACO2 = 33 )
      INTEGER I_DIAL
      PARAMETER ( I_DIAL = 34 )
      INTEGER I_GLYX
      PARAMETER ( I_GLYX = 35 )
      INTEGER I_CRES
      PARAMETER ( I_CRES = 36 )
      INTEGER I_AHO2
      PARAMETER ( I_AHO2 = 37 )
      INTEGER I_RAN1
      PARAMETER ( I_RAN1 = 38 )
      INTEGER I_ZO2
      PARAMETER ( I_ZO2 = 39 )
      INTEGER I_ETHE
      PARAMETER ( I_ETHE = 40 )
      INTEGER I_CO
      PARAMETER ( I_CO = 41 )
      INTEGER I_MGLY
      PARAMETER ( I_MGLY = 42 )
      INTEGER I_MAN2
      PARAMETER ( I_MAN2 = 43 )
      INTEGER I_TO2
      PARAMETER ( I_TO2 = 44 )
      INTEGER I_HAC
      PARAMETER ( I_HAC = 45 )
      INTEGER I_R3O2
      PARAMETER ( I_R3O2 = 46 )
      INTEGER I_EO2
      PARAMETER ( I_EO2 = 47 )
      INTEGER I_PO2
      PARAMETER ( I_PO2 = 48 )
      INTEGER I_MRO2
      PARAMETER ( I_MRO2 = 49 )
      INTEGER I_MVN2
      PARAMETER ( I_MVN2 = 50 )
      INTEGER I_ETO2
      PARAMETER ( I_ETO2 = 51 )
      INTEGER I_PRN1
      PARAMETER ( I_PRN1 = 52 )
      INTEGER I_RIO2
      PARAMETER ( I_RIO2 = 53 )
      INTEGER I_TCO3
      PARAMETER ( I_TCO3 = 54 )
      INTEGER I_INO2
      PARAMETER ( I_INO2 = 55 )
      INTEGER I_HACO
      PARAMETER ( I_HACO = 56 )
      INTEGER I_HNO3
      PARAMETER ( I_HNO3 = 57 )
      INTEGER I_MGGY
      PARAMETER ( I_MGGY = 58 )
      INTEGER I_VRO2
      PARAMETER ( I_VRO2 = 59 )
      INTEGER I_ALKE
      PARAMETER ( I_ALKE = 60 )
      INTEGER I_RAO2
      PARAMETER ( I_RAO2 = 61 )
      INTEGER I_KET
      PARAMETER ( I_KET = 62 )
      INTEGER I_KO2
      PARAMETER ( I_KO2 = 63 )
      INTEGER I_ISOP
      PARAMETER ( I_ISOP = 64 )
      INTEGER I_MO2
      PARAMETER ( I_MO2 = 65 )
      INTEGER I_MAO3
      PARAMETER ( I_MAO3 = 66 )
      INTEGER I_CRO2
      PARAMETER ( I_CRO2 = 67 )
      INTEGER I_MCRG
      PARAMETER ( I_MCRG = 68 )
      INTEGER I_MVKO
      PARAMETER ( I_MVKO = 69 )
      INTEGER I_MAOO
      PARAMETER ( I_MAOO = 70 )
      INTEGER I_ROOH
      PARAMETER ( I_ROOH = 71 )
      INTEGER I_MCO3
      PARAMETER ( I_MCO3 = 72 )
      INTEGER I_MACR
      PARAMETER ( I_MACR = 73 )
      INTEGER I_O3
      PARAMETER ( I_O3 = 74 )
      INTEGER I_MVK
      PARAMETER ( I_MVK = 75 )
      INTEGER I_ALD2
      PARAMETER ( I_ALD2 = 76 )
      INTEGER I_NO2
      PARAMETER ( I_NO2 = 77 )
      INTEGER I_NO3
      PARAMETER ( I_NO3 = 78 )
      INTEGER I_SO2
      PARAMETER ( I_SO2 = 79 )
      INTEGER I_NO
      PARAMETER ( I_NO = 80 )
      INTEGER I_HO2
      PARAMETER ( I_HO2 = 81 )
      INTEGER I_OH
      PARAMETER ( I_OH = 82 )
      INTEGER I_CHO2
      PARAMETER ( I_CHO2 = 83 )
      INTEGER I_HCHO
      PARAMETER ( I_HCHO = 84 )

C Indexes declaration for radical species                          


C Indexes declaration for fixed species                            

      INTEGER I_H2O
      PARAMETER ( I_H2O = 1 )
      INTEGER I_O2
      PARAMETER ( I_O2 = 2 )
      INTEGER I_CO2
      PARAMETER ( I_CO2 = 3 )
      INTEGER I_H2
      PARAMETER ( I_H2 = 4 )

C User defined variables                                           

C End user defined variables                                       

