C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C -- STEM INTEGRATION WITH VODE.F --
        PROGRAM STEM
      INCLUDE 'agg.h'
C --- PARAMETERS (FULL JACOBIAN)
        PARAMETER (ND=NVAR,LRW=6*ND*ND+9*ND+25,LIW=ND+35)
        PARAMETER (LRCONT=4*ND+4+10)
        COMMON /CONT/ICONT(4),RCONT(LRCONT)
C --- DECLARATIONS
        DIMENSION V(ND),RWORK(LRW),IWORK(LIW)
        COMMON/STAT/NFCN,NJAC,NSTEP,NACCPT,NREJCT,NDEC,NSOL
        EXTERNAL FUN,FUN2,JAC,JAC2
        DATA V / 1.36e-09, 1e-20, 4.2e+11, 3.8e-09,
     *  2.1e+08, 3572.54,
     *  12546.7,  2.479e+07,  266393.0,  8.64e-05,  34.7, 898.1,
     *  4.7D+06,  3.6D-06,  1.5D-16, 
     *  51452.5, 284747.0, 3.0e-08,
     *  6.0D+06,  0.874,  6520.93,  2.3D+07,  
     *  0.000432642, 5532.57,
     *  1942.71,  1.73475D+08,  1.2D+07,  
     *  1.55712D+06, 16.2282, 4524.26,
     *  12149.3,  33458.6,  366435.0,  7142.3 /

        write(6,*) 'VODE. rtol=, dt='
        read(5,*) rtols, dt
        
        idir = 0
        MF = 21
        N=NVAR

C ==== initial values ====
      TEMP = 241.42
      CFACTOR = 8.12D+16
      CM = 1./CFACTOR
      CALL INITVAL()
      write(6,95) 0.,Var(I_O)*CM


C --- ENDPOINT OF INTEGRATION
       NDAYS = 5
       TSTART = 12.D0*3600.D0
       TEND = TSTART + 24.D0*3600.D0*NDAYS
C --- REQUIRED TOLERANCE, scalar ATOL (itol = 2), vector ATOL (itol = 2)
        do i=1,nd
          ATOL(i) = dmax1(1.d-3, 0.01*rtols*V(i))
          RTOL(i) = rtols
        end do  
        ITOL=4
C ---- NORMAL COMPUTATION ---
        itask=1
        istate=1
        iopt=0

C  --- Some restrictions may be required ---        
        iopt=1
        iwork(6) = 5000   ! # internal steps
C        rwork(6)=1000.   ! maximal step-size
C        iwork(5)=2       ! maximal order
C  ------------- Output file ---------------

C --- OUTPUT FILE ----
      OPEN(UNIT=10,FILE='Vode.m')

       TIME=TSTART
C --- PRINT  INITIAL CONDITIONS

        write(10,99) 0., 
     *     Var(I_O) ,     Var(I_O1D) , 
     *     Var(I_O3) ,    Var(I_NO) ,
     *     Var(I_NO2) ,   Var(I_NO3) , 
     *     Var(I_N2O5) ,  Var(I_HNO3) ,
     *     Var(I_HNO4) ,
     *     Var(I_H) ,     Var(I_OH) ,
     *     Var(I_HO2) ,   Var(I_H2O2) , 
     *     Var(I_CH3) ,   Var(I_CH3O) , 
     *     Var(I_CH3O2) , Var(I_CH3OOH) ,
     *     Var(I_HCO) ,   Var(I_CH2O) , 
     *     Var(I_Cl) ,
     *     Var(I_Cl2) ,   Var(I_ClO) , 
     *     Var(I_ClOO) ,  Var(I_OClO) ,
     *     Var(I_Cl2O2) , Var(I_HCl) , 
     *     Var(I_HOCl) ,  Var(I_ClONO2) ,
     *     Var(I_Br) ,    Var(I_BrCl) , 
     *     Var(I_BrO) ,   Var(I_HBr) ,
     *     Var(I_HOBr) ,  Var(I_BrONO2) 

        DO WHILE (TIME.LE.TEND)

C --- CALL OF THE SUBROUTINE VODE
       
C       if (idir.eq.0) istate=1
       istate=1
       CALL dvode (FUN, N, Var, TIME, TIME+DT, itol, rtol, atol,
     1             itask, istate, iopt, rwork, lrw, 
     2             iwork, liw, JAC, mf,rpar,ipar)

       IF (ISTATE.LT.0) THEN
          WRITE(6,*) 'VODE WARNING: ISTATE = ',ISTATE
       END IF   
C --- PRINT  SOLUTION
       if (time.le.tend) then
       HOURS = (TIME-tstart)/3600.D0
       IF ( abs(int(HOURS)-HOURS) .LT. 0.01 ) THEN
         write(10,99) (TIME-Tstart)/3600.D0, 
     *     Var(I_O) ,     Var(I_O1D) , 
     *     Var(I_O3) ,    Var(I_NO) ,
     *     Var(I_NO2) ,   Var(I_NO3) , 
     *     Var(I_N2O5) ,  Var(I_HNO3) ,
     *     Var(I_HNO4) ,
     *     Var(I_H) ,     Var(I_OH) ,
     *     Var(I_HO2) ,   Var(I_H2O2) , 
     *     Var(I_CH3) ,   Var(I_CH3O) , 
     *     Var(I_CH3O2) , Var(I_CH3OOH) ,
     *     Var(I_HCO) ,   Var(I_CH2O) , 
     *     Var(I_Cl) ,
     *     Var(I_Cl2) ,   Var(I_ClO) , 
     *     Var(I_ClOO) ,  Var(I_OClO) ,
     *     Var(I_Cl2O2) , Var(I_HCl) , 
     *     Var(I_HOCl) ,  Var(I_ClONO2) ,
     *     Var(I_Br) ,    Var(I_BrCl) , 
     *     Var(I_BrO) ,   Var(I_HBr) ,
     *     Var(I_HOBr) ,  Var(I_BrONO2) 
       END IF


        percent=100.D0*(time-tstart)/(tend-tstart)
        write(6,95) percent,Var(I_O)*CM

        end if
 95     format(F7.2,' % DONE, O=',E24.16)       
 99     FORMAT(100(X,E24.16))
 101    format(E24.16,E24.16,x,I4,x,E24.16)
         END DO
 

C --- PRINT STATISTICS
        WRITE (6,90) real(iwork(21))/iwork(11)*100.,
     *              real(iwork(22))/iwork(11)*100.
 90     FORMAT(F9.3,' % conv, ',F9.3,'% err failures')
        CLOSE(10)
        STOP
        END
C
C

        SUBROUTINE FUN (N, T, V, FCT, rpar, ipar)
      INCLUDE 'agg.h'
        DIMENSION V(NVAR), FCT(NVAR), rpar(*)
        integer ipar(*)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        CALL F_VAR(V, Rad, FCT) 
        RETURN
        END

        SUBROUTINE JAC (N, T, V, ML, MU, JV, NROWPD, RPAR, IPAR)
      INCLUDE 'agg.h'
        REAL*8 V(NVAR), JV(NVAR,NVAR), rpar(*)
        integer ipar(*)
        TOLD = TIME
        TIME = T
        CALL update_sun()
        CALL update_rconst()
        TIME = TOLD
        DO i=1,nvar
           DO j=1,nvar
              JV(i,j) = 0.
           END DO
        END DO      
        CALL JACVAR(V, Rad, JV) 
        RETURN
        END
        
C End of MAIN function                                             
C ****************************************************************

      INCLUDE 'agg.f' 
