% MIN SDA, AVERAGE SDA, TIME (sec) for NOISE = 1


% Twostep Jacobi

tj=[ 0.00  0.00  0.20
     0.00  0.10  0.20
     0.00  0.51  0.35
     0.00  0.45  0.44
     0.33  0.83  0.63
     0.68  1.15  0.80
     1.32  1.76  1.58
     2.17  2.61  2.93
     2.99  3.46  5.15];

% Twostep Seidel

ts=[ 0.33  0.85  0.17
     0.03  0.51  0.20
     0.21  0.73  0.37
     0.24  0.73  0.48
     0.73  1.17  0.91
     1.02  1.44  1.23
     1.75  2.14  2.60
     2.76  3.19  5.49
     3.78  4.27  10.35];

% Atmvode, adjusted tolerances

atv=[0.22  1.20  0.37
     0.50  1.55  0.40
     1.18  2.09  0.43
     1.66  2.37  0.48
     1.89  2.72  0.55
     2.04  3.00  0.58
     2.58  3.62  0.65
     3.45  4.55  0.74];

% Sdirk

sd =[0.00  0.55  0.42
     0.72  2.14  0.43
     1.75  2.85  0.47
     2.41  3.18  0.52
     3.20  4.04  0.74
     3.66  4.30  0.91
     4.65  5.15  1.86
     5.48  6.02  2.74];
     
% Rodas, norm infinity

rody=[0.00  0.88  0.35
      0.10  1.55  0.42
      2.13  3.44  0.58
      2.61  3.86  0.66
      3.42  4.53  0.85
      3.78  4.78  1.20
      4.58  5.51  1.71
      5.58  6.43  2.83];

% Plain qssa; rows correspond to rtol = 5E-2 ... 1E-6

q=[  0.00  0.20  0.50
     0.01  0.68  1.52
     0.22  0.83  2.43
     0.76  1.28  6.27
     0.87  1.41  8.70
     0.99  1.59  15.21];

% Extrapolated qssa; rows correspond to rtol = 1E-3 ... 1E-6

ex=[ 0.00  0.68  2.
     0.22  0.85  2.65
     0.75  1.29  7.
     0.97  1.48  11.
     1.34  1.86  25.
     1.65  2.17  68.];

% Symmetric Qssa
sym=[0.00  0.63  4.30
     0.16  0.80  7.02
     0.67  1.22  16.7
     0.80  1.34  23.0
     1.10  1.68  35.8];

     
% Young and Boris, eps2 = 5e-2, 1e-1, 1, 10, 100

yb=[ 2.34  2.87  336.
     2.18  2.70  236.
     1.51  2.02   75.
     0.85  1.40   25.
     0.31  0.95    8.
     0.00  0.56    4.];
     

for k=1:2
semilogx( atv(:,3),atv(:,k),'--', atv(:,3),atv(:,k), 'o', ...
          sd(:,3), sd(:,k), '--', sd(:,3), sd(:,k), 'x', ...
          rody(:,3), rody(:,k), '--', rody(:,3), rody(:,k), '*', ...
         tj(:,3), tj(:,k),  tj(:,3), tj(:,k), 'x', ...
         ts(:,3), ts(:,k),  ts(:,3), ts(:,k), 'o', ...
         q(:,3), q(:,k),'-.', q(:,3), q(:,k), 'x' , ...
         ex(:,3), ex(:,k),'-.', ex(:,3), ex(:,k), 'o' , ...
         yb(:,3), yb(:,k),'-.', yb(:,3), yb(:,k), '*' );
xlabel('CPU time [ seconds ]');
ylabel('SDA');
if (k==1)
  title('STRATO model: minimum SDA, noise = 1');
%  axis()
  print stratoresult.ps;
  disp('Pausing ...'); pause
else
  title('STRATO model: mean SDA, noise = 1');
  print -append  stratoresult.ps;
end  

end   