      PROGRAM driver

      INCLUDE 'split.h'
      REAL*8 Tstart, Tend, DT
      INTEGER i


      print *, 'ET for STRATO. Rtols=, H='  
      read(5,*) Rtols, H

      DT = 600.d0
      Tstart = 3600.*12.
      Tend = Tstart + 3600.*24.*5.

      TEMP = 241.42
      CALL INITVAL()
      
      open(10, file='Donald.m')
       
      STEPMIN = 0.1d0
      STEPMAX = DT
      

      TIME = Tstart
         write(10,992) (time-tstart)/3600.,
     *     Var(I_O) ,     Var(I_O1D) ,
     *     Var(I_O3)  ,   Var(I_NO) ,
     *     Var(I_NO2) ,   Var(I_NO3) ,
     *     Var(I_N2O5) ,  Var(I_HNO3) , Var(I_HNO4) ,
     *     Var(I_H) ,     Var(I_OH) ,
     *     Var(I_HO2) ,   Var(I_H2O2) ,
     *     Var(I_CH3) ,   Var(I_CH3O) ,
     *     Var(I_CH3O2) , Var(I_CH3OOH) ,
     *     Var(I_HCO) ,   Var(I_CH2O) , Var(I_Cl) ,
     *     Var(I_Cl2) ,   Var(I_ClO) ,
     *     Var(I_ClOO) ,  Var(I_OClO) ,
     *     Var(I_Cl2O2) , Var(I_HCl) ,
     *     Var(I_HOCl) ,  Var(I_ClONO2) ,
     *     Var(I_Br) ,    Var(I_BrCl) ,
     *     Var(I_BrO) ,   Var(I_HBr) ,
     *     Var(I_HOBr) ,  Var(I_BrONO2) 
      


C ********** TIME LOOP *************************
      do while (TIME .lt. Tend)


        call DONALD( TIME, DT, Var, H, Rtols)

      HOURS = (TIME-Tstart)/3600.D0
      IF ( DABS(HOURS-INT(HOURS) ) .LT. 1.d-4 ) THEN

         write(10,992) HOURS,
     *     Var(I_O) ,     Var(I_O1D) ,
     *     Var(I_O3)  ,   Var(I_NO) ,
     *     Var(I_NO2) ,   Var(I_NO3) ,
     *     Var(I_N2O5) ,  Var(I_HNO3) , Var(I_HNO4) ,
     *     Var(I_H) ,     Var(I_OH) ,
     *     Var(I_HO2) ,   Var(I_H2O2) ,
     *     Var(I_CH3) ,   Var(I_CH3O) ,
     *     Var(I_CH3O2) , Var(I_CH3OOH) ,
     *     Var(I_HCO) ,   Var(I_CH2O) , Var(I_Cl) ,
     *     Var(I_Cl2) ,   Var(I_ClO) ,
     *     Var(I_ClOO) ,  Var(I_OClO) ,
     *     Var(I_Cl2O2) , Var(I_HCl) ,
     *     Var(I_HOCl) ,  Var(I_ClONO2) ,
     *     Var(I_Br) ,    Var(I_BrCl) ,
     *     Var(I_BrO) ,   Var(I_HBr) ,
     *     Var(I_HOBr) ,  Var(I_BrONO2) 

         print *,(TIME-Tstart)/3600.D0, 'h. O3=',Var(I_O3)/CFACTOR
         
       END IF 
      end do
C *********** END TIME LOOP ********

      close(10)
      STOP

991   FORMAT(10(X,E12.6))
992   FORMAT(100(X,E24.16))
      END

C End of MAIN function                                             
C **************************************************************** 



C --- This is an interface that "translates" --- 
C --- the derivative function from the KPP   --- 
C --- standard form to EXTRAP form           --- 
      SUBROUTINE DIFF(N,V,TIN,A,B,FUN)
      INCLUDE 'split.h'
      REAL*8 A(nvar), B(nvar), V(nvar), FUN(nvar)
      INTEGER N,i
      REAL*8 TIN
      TOLD = TIME
      TIME = TIN
      call update_sun()     ! Update sunlight intensity
      call update_rconst()  ! Update rate constants
      call fsplit_var(V,Rad,A,B)
      do i=1,nvar
        FUN(i) = A(i)-B(i)*V(i)
      end do
      TIME = TOLD
      RETURN
      END

c ======================================================================
      SUBROUTINE DONALD(T,DT,V,H,Eps)
      INCLUDE 'split.h'
      REAL*8 V(NVAR), T, DT, H, H20, eps

      REAL*8 csh(NVAR),cbh(NVAR),cex(NVAR),xmm(NVAR)
      
      N = NVAR


   10 tout=t+dt

	call errctrl(t,tout,dt,v,h,cbh,csh,Eps)
        H20 = H/20.d0

      iff=0.
      xmult=.5
      do 11 ijij = 1, n
         if(cbh(ijij).gt.(1+xmult)*V(ijij) .or. 
     & cbh(ijij).lt.(1-xmult)*V(ijij)) then
         iff=1.
         end if
   11 continue

      if((t/100*100).eq.(int(t)/100*100).or.(iff.eq.1.))
     &      call EXTRAP(n,V,t,tout,H20,cex)

      do 888 ihj=1,n

        if(t/100*100.eq.int(t)/100*100.or.(iff.eq.1.)) then

           if((cbh(ihj).eq.0).and.(cex(ihj).eq.0)) then
              xmmk=0.
           else   
              xmmk=(csh(ihj)-cex(ihj))/(cbh(ihj)-cex(ihj))
           end if 

           if(xmmk.gt.0.) then
             xmm(ihj)=log(xmmk)/(-0.6931471825)
           else
             xmm(ihj)=0.
           end if

           if(cex(ihj).eq.cbh(ihj)) xmm(ihj)=-99.
           if(cex(ihj).eq.csh(ihj)) xmm(ihj)=0.
        end if

        if(xmm(ihj).gt.0.) V(ihj)=((
     &    .5**xmm(ihj))*cbh(ihj)-csh(ihj))/((.5**xmm(ihj))-1.)
         if(xmm(ihj).eq.0.) V(ihj)=csh(ihj)
         if(xmm(ihj).lt.0.) V(ihj)=cbh(ihj)
         if(V(ihj).lt.0.) V(ihj)=0.
  888 continue
       
       t=tout
       
      return
      end

c ======================================================================
      SUBROUTINE EXTRAP(N,CIN,TIN,TOUT,DT,V)
C
C    Program: EXTRAP integrates system of stiff ODE's using extrapolation
C             techniques.  It is equivalent to the INTEGR2 
C             routine of the CIT model.
C
C  Reference: Extrapolation techniques used in the solution of stiff ODEs
C             associated with chemical kinetics of air quality models
C             D. Dabdub  &  J. H. Seinfeld.   (submitted)
C
C     Author: Donald Dabdub
C             210-41 Chemical Engr.
C             California Institute of Technology
C             Pasadena, CA  91125
C
C     E-mail: dabdub@aeolus.che.caltech.edu
C
C       Date: Oct, 1993
C
      include 'split.h' 
      DIMENSION V(NVAR), A(NVAR), B(NVAR), F1(NVAR)
      DIMENSION A2(NVAR), B2(NVAR), F2(NVAR)
      DIMENSION C2(NVAR), C3(NVAR), IS(NVAR), CIN(NVAR)
      N = NVAR
      E6=.05
      do 1 i=1,n
	V(i)=CIN(i)
   1  continue
C
C     GET THE A AND B ARRAYS VALUES
C
      CALL DIFF(N,V,TIN,A,B,F1)
      TNOW=TIN
C
C     PREDICT THE CONCENTRATION AT T+DT
C
 24   TNOW=TNOW+DT
      IF(TNOW.LT.TOUT) GO TO 27
      TNOW=TNOW-DT
      DT=TOUT-TNOW
      TNOW=TNOW+DT
 27   do 30 i=1,n 
      bt=b(i)*dt
      is(i)=0
      if(bt.gt.10.) is(i)=1
      if(bt.lt.0.01) is(i)=2
 30   continue

      DO 50 I=1,N
      IF(is(i).eq.1) THEN
        C2(I)=a(i)/b(i)
      ELSE IF(is(i).eq.2) THEN
        C2(I)=V(I)+F1(I)*DT
      ELSE
        aabb=a(i)/b(i)
        C2(I)=aabb +(V(i) - aabb)*exp(-b(i)*dt)
      END IF
      IF(C2(I).LT.0.) C2(I)=0.
 50   CONTINUE
C
C     COMPUTE A, B AND F USING THE LATEST VALUE AT T+DT AND 
C     CORRECT THE PREDICTION FOR T+DT
C
      CALL DIFF(N,C2,TNOW,A2,B2,F2)

      do 31 i=1,n 
      bt=b2(i)*dt
      is(i)=0
      if(bt.gt.10.) is(i)=1
      if(bt.lt.0.01) is(i)=2
 31   continue

      DO 80 I=1,N
      IF(is(i).eq.1) THEN
        C3(I)=((a(i) + a2(i))/2.)*(1./b(i) + 1./b2(i))/2.  
      ELSE IF(is(i).eq.2) THEN
        C3(I)=V(I)+(F1(I)+F2(I))*DT/2.
      ELSE 
        aabb=(1./b(i) + 1./b2(i))/2. * (a(i) + a2(i))/2.
        C3(I)=aabb + (V(i) - aabb)*exp(-2.*dt/(1./b(i) + 1./b2(i)))
      END IF
      IF(C3(I).LT.0.) C3(I)=0.
 80   CONTINUE 

C
C     PLACE THE VALUES FOR T+DT IN THE C ARRAY,
C     ALSO ASSIGN THE A,B, AND F VALUES TO BE USED IN THE NEXT
C     PREDICTION STEP

  125 DO 130 I=1,N
      V(I) = C3(I)
      a(i) = a2(i)
      b(i) = b2(i)
      f1(i) = f2(i)
 130  CONTINUE
C
C     CHECK THE TIME AND RETURN IF FINISHED
C
      IF(TNOW.LT.TOUT) goto 24
      RETURN
      END

c ======================================================================
c This routine performs error control using the EXTRAP subroutine. The
c method is step doubling with some additional constraints.

	subroutine errctrl(t,tout,dt,v,h,cbh,csh,eps)
	include 'split.h'
	real*8 t, dt, h,h1,h2,tout
	real*8 csh(nvar),cbh(nvar)
	real*8 eps,errmax,onidec,oniinc,cmin,hfactor,errmax1,errmax2
	real*8 hmax

	onidec = -.25d0	! approximate Order, Negative Inverse, decrease
	oniinc = -.25d0	! approximate Order, Negative Inverse, increase
C	eps = .15d0	! error tol. betw h and h/2 time steps at dt
	cmin = 1.d0	! cut-off on denom. for error calc.
	errmax1 = 1.d0	! ceiling on adjustment to h
	errmax2 = .7d0	! floor on adjustment to h
	hmax=0.25d0*dt	! ceiling on h
	sf = .9		! safety factor

1	h1 = h
	call extrap(nvar,v,t,tout,h1,cbh)
	h2 = h/2.0d0
	call extrap(nvar,v,t,tout,h2,csh)	

c find max relative error
	errmax = 0.d0
	do i = 1,nvar
	  if (csh(i).lt.cmin) then
	    errmax = max(errmax,abs((cbh(i)-csh(i))/cmin))
	  else
	    errmax = max(errmax,abs((cbh(i)-csh(i))/csh(i)))
	  endif
	enddo
	errmax = errmax/eps

c reduce step size
	if (errmax.gt.errmax1) then
	  h = h*sf*errmax**onidec
	  do i = 1,nvar		! save the old csh as the new cbh
	    cbh(i) = csh(i)
	  enddo
	  goto 1
	else if (errmax.lt.errmax2) then
c calculate the next h
	  hfactor = errmax**oniinc
	  h = h*sf*hfactor
	  if (h.gt.hmax) h = hmax	! ceiling on h
	endif

	return
	end
