C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : tm_chemie.h                               
C Time                 : Thu May 30 13:43:18 1996                  
C Working directory    : /usr/people/edwins/Dentener/kpp_vode      
C Equation file        : tm_chemie.k                               
C Output root filename : tm_chemie                                 
C                                                                  
C **************************************************************** 


      IMPLICIT REAL*8 ( A-H, K, O-Z )

C NSPEC - The number of species involved                           
      INTEGER NSPEC
      PARAMETER ( NSPEC = 20 )
C NVAR - The number of Variable species                            
      INTEGER NVAR
      PARAMETER ( NVAR = 16 )
C NVARACT - The number of Active species                           
      INTEGER NVARACT
      PARAMETER ( NVARACT = 15 )
C NRAD - The number of Radical species                             
      INTEGER NRAD
      PARAMETER ( NRAD = 1 )
C NFIX - The number of Fixed species                               
      INTEGER NFIX
      PARAMETER ( NFIX = 4 )
C NREACT - The number of reactions                                 
      INTEGER NREACT
      PARAMETER ( NREACT = 36 )
C NVARST - Starting of variables in conc. vect.                    
      INTEGER NVARST
      PARAMETER ( NVARST = 0 )
C NRADST - Starting of radicals in conc. vect.                     
      INTEGER NRADST
      PARAMETER ( NRADST = 16 )
C NFIXST - Starting of fixed in conc. vect.                        
      INTEGER NFIXST
      PARAMETER ( NFIXST = 16 )
C NONZERO_V - Number of nonzero variable elements                  
      INTEGER NONZERO_V
      PARAMETER ( NONZERO_V = 90 )
C LU_NONZERO_V - Number of nonzero variable LU elements            
      INTEGER LU_NONZERO_V
      PARAMETER ( LU_NONZERO_V = 93 )
C NONZERO_R - Number of nonzero radical elements                   
      INTEGER NONZERO_R
      PARAMETER ( NONZERO_R = 0 )
C CNVAR - (NVAR+1) The number of elements in compressed row format 
      INTEGER CNVAR
      PARAMETER ( CNVAR = NVAR + 1 )
C CNRAD - (NRAD+1) The number of elements in compressed row format 
      INTEGER CNRAD
      PARAMETER ( CNRAD = NRAD + 1 )
C NLOOKAT - number of species to look at                           
      INTEGER NLOOKAT
      PARAMETER ( NLOOKAT = 0 )
C NMONITOR - number of species to monitor                          
      INTEGER NMONITOR
      PARAMETER ( NMONITOR = 0 )
C NMASS - number of atoms to check mass balance                    
      INTEGER NMASS
      PARAMETER ( NMASS = 0 )
C NX - X grid dimension                                            
      INTEGER NX
      PARAMETER ( NX = 0 )
C NY - Y grid dimension                                            
      INTEGER NY
      PARAMETER ( NY = 0 )
C NZ - Z grid dimension                                            
      INTEGER NZ
      PARAMETER ( NZ = 0 )
C MAX_XYZ - maximum grid dimension                                 
      INTEGER MAX_XYZ
      PARAMETER ( MAX_XYZ = 0 )
C NS - number of species to transport                              
      INTEGER NS
      PARAMETER ( NS = 0 )
C PI - Value of pi                                                 
      real*8 PI
      PARAMETER ( PI = 3.1415926535 )

C Declaration for global variables                                 

C C_DEFAULT - Default concentration for all species                
      real*8 C_DEFAULT(NSPEC)
      COMMON /GDATA/ C_DEFAULT
C C - Concentration for all species                                
      real*8 C(NSPEC)
      COMMON /GDATA/ C
C VAR - Concentration of variable species (global)                 
      real*8 VAR(NVAR)
C RAD - Concentration of radicals (global)                         
      real*8 RAD(NRAD)
C FIX - Concentration of fix species (global)                      
      real*8 FIX(NFIX)
C F - Concentration of fix species (global)                        
      real*8 F(NFIX)
      EQUIVALENCE( C(1+NVARST),VAR(1) )
      EQUIVALENCE( C(1+NRADST),RAD(1) )
      EQUIVALENCE( C(1+NFIXST),FIX(1) )
      EQUIVALENCE( C(1+NFIXST),F(1) )
C RCONST - Rate constants                                          
      real*8 RCONST(NREACT)
      COMMON /GDATA/ RCONST
C TIME - current integration time                                  
      real*8 TIME
      COMMON /GDATA/ TIME
C SUN - light intensity                                            
      real*8 SUN
      COMMON /GDATA/ SUN
C TEMP - temperature                                               
      real*8 TEMP
      COMMON /GDATA/ TEMP
C DENS - density                                                   
      real*8 DENS
      COMMON /GDATA/ DENS
C PRESS - pressure                                                 
      real*8 PRESS
      COMMON /GDATA/ PRESS
C RTOLS - (scalar) relative tolerance                              
      real*8 RTOLS
      COMMON /GDATA/ RTOLS
C TSTART - integration start time                                  
      real*8 TSTART
      COMMON /GDATA/ TSTART
C TEND - integration end time                                      
      real*8 TEND
      COMMON /GDATA/ TEND
C DT - integration step                                            
      real*8 DT
      COMMON /GDATA/ DT
C ATOL - Absolute tolerance                                        
      real*8 ATOL(NSPEC)
      COMMON /GDATA/ ATOL
C RTOL - Relative tolerance                                        
      real*8 RTOL(NSPEC)
      COMMON /GDATA/ RTOL
C STEPMIN - minimum allowed intergation step                       
      real*8 STEPMIN
      COMMON /GDATA/ STEPMIN
C STEPMAX - maximum allowed integration step                       
      real*8 STEPMAX
      COMMON /GDATA/ STEPMAX
C CFACTOR - Conversion factor                                      
      real*8 CFACTOR
      COMMON /GDATA/ CFACTOR
C LOOKAT - indexes of species to look at                           
      INTEGER LOOKAT(1)
      COMMON /GDATA/ LOOKAT
C SLOOKAT - names of species to look at                            
      CHARACTER*8 SLOOKAT(1)
      COMMON /GDATA/ SLOOKAT
C MONITOR - indexes of species to monitor                          
      INTEGER MONITOR(1)
      COMMON /GDATA/ MONITOR
C SMONITOR - names of species to monitor                           
      CHARACTER*8 SMONITOR(1)
      COMMON /GDATA/ SMONITOR
C TRANS - indexes of species to transport                          
      INTEGER TRANS(1)
      COMMON /GDATA/ TRANS
C STRANS - names of species to transport                           
      CHARACTER*8 STRANS(1)
      COMMON /GDATA/ STRANS
C SMASS - names of atoms for mass balance                          
      CHARACTER*8 SMASS(1)
      COMMON /GDATA/ SMASS

C Indexes declaration for variable species                         

      INTEGER I_CO2
      PARAMETER ( I_CO2 = 1 )
      INTEGER I_CH4
      PARAMETER ( I_CH4 = 2 )
      INTEGER I_H2O2
      PARAMETER ( I_H2O2 = 3 )
      INTEGER I_CO
      PARAMETER ( I_CO = 4 )
      INTEGER I_N2O5
      PARAMETER ( I_N2O5 = 5 )
      INTEGER I_HCHO
      PARAMETER ( I_HCHO = 6 )
      INTEGER I_PNA
      PARAMETER ( I_PNA = 7 )
      INTEGER I_MEP
      PARAMETER ( I_MEP = 8 )
      INTEGER I_HNO3
      PARAMETER ( I_HNO3 = 9 )
      INTEGER I_CH3O2
      PARAMETER ( I_CH3O2 = 10 )
      INTEGER I_HO2
      PARAMETER ( I_HO2 = 11 )
      INTEGER I_OH
      PARAMETER ( I_OH = 12 )
      INTEGER I_NO2
      PARAMETER ( I_NO2 = 13 )
      INTEGER I_NO3
      PARAMETER ( I_NO3 = 14 )
      INTEGER I_NO
      PARAMETER ( I_NO = 15 )
      INTEGER I_O3
      PARAMETER ( I_O3 = 16 )

C Indexes declaration for radical species                          


C Indexes declaration for fixed species                            

      INTEGER I_H2O
      PARAMETER ( I_H2O = 1 )
      INTEGER I_O2
      PARAMETER ( I_O2 = 2 )
      INTEGER I_M
      PARAMETER ( I_M = 3 )
      INTEGER I_SOURCE
      PARAMETER ( I_SOURCE = 4 )

C User defined variables                                           

C End user defined variables                                       

