C **************************************************************** 
C                                                                  
C Generated by KPP - symbolic chemistry Kinetics PreProcessor      
C     KPP is developed at CGRER labs University of Iowa by         
C     Valeriu Damian & Adrian Sandu                                
C                                                                  
C File                 : tm_chemie.f                               
C Time                 : Thu May 30 17:25:38 1996                  
C Working directory    : /usr/people/edwins/Dentener/kpp_twostep   
C Equation file        : tm_chemie.k                               
C Output root filename : tm_chemie                                 
C                                                                  
C **************************************************************** 


      BLOCK DATA GLOBAL_DATA

      INCLUDE 'tm_twostep.h'


      data CFACTOR / 1.09e+10 / 









C User defined global variables                                    

C End user defined global variables                                

      END


C **************************************************************** 
C                                                                  
C UTIL - Utility functions                                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

C ****************************************************************
C                            
C InitSaveData - Opens the data file for writing
C   Parameters :                                                  
C
C ****************************************************************

      SUBROUTINE InitSaveData ()

      INCLUDE 'tm_twostep.h'

      open(10, file='tm_chemie.dat')

      RETURN
      END

C End of InitSaveData function
C ****************************************************************

C ****************************************************************
C                            
C SaveData - Write LOOKAT species in the data file 
C   Parameters :                                                  
C
C ****************************************************************

      SUBROUTINE SaveData ()

      INCLUDE 'tm_twostep.h'
      integer i

      WRITE(10,999) (TIME-TSTART)/3600.D0,
     *              (C(LOOKAT(i))/CFACTOR, i=1,NLOOKAT)
999   FORMAT(F6.1,100(X,D24.16))

      RETURN
      END

C End of SaveData function
C ****************************************************************

C ****************************************************************
C                            
C CloseSaveData - Close the data file 
C   Parameters :                                                  
C
C ****************************************************************

      SUBROUTINE CloseSaveData ()

      INCLUDE 'tm_twostep.h'

      CLOSE(10)

      RETURN
      END

C End of CloseSaveData function
C ****************************************************************

C ****************************************************************
C                            
C GenerateMatlab - Generates MATLAB file to load the data file 
C   Parameters : 
C                It will have a character string to prefix each 
C                species name with.                                                 
C
C ****************************************************************

      SUBROUTINE GenerateMatlab ( PREFIX )

      INCLUDE 'tm_twostep.h'
      
      CHARACTER*8 PREFIX 
      INTEGER i

      open(20, file='tm_chemie.m')
      write(20,*) 'load tm_chemie.dat;'
      write(20,990) PREFIX
990   FORMAT(A1,'c = tm_chemie;')
      write(20,*) 'clear tm_chemie;'
      write(20,991) PREFIX, PREFIX
991   FORMAT(A1,'t=',A1,'c(:,1);')
      write(20,992) PREFIX
992   FORMAT(A1,'c(:,1)=[];')

      do i=1,NLOOKAT
        write(20,993) PREFIX, SLOOKAT(i), PREFIX, i
993     FORMAT(A1,A6,' = ',A1,'c(:,',I2,');')
      end do
      
      CLOSE(20)

      RETURN
      END

C End of GenerateMatlab function
C ****************************************************************

C End of UTIL function                                             
C **************************************************************** 


C **************************************************************** 
C                                                                  
C FSPLIT_VAR - function for the derivatives of variables - Split form
C   Parameters :                                                   
C      V         - Concentration of variable species               
C      R         - Concentration of radicals                       
C      P_VAR     - Production term                                 
C      D_VAR     - Destruction term                                
C                                                                  
C **************************************************************** 

      SUBROUTINE FSPLIT_VAR ( V, R, P_VAR, D_VAR )

      INCLUDE 'tm_twostep.h'

C V - Concentration of variable species                            
      real*8 V(NVAR)
C R - Concentration of radicals                                    
      real*8 R(NRAD)
C P_VAR - Production term                                          
      real*8 P_VAR(NVAR)
C D_VAR - Destruction term                                         
      real*8 D_VAR(NVAR)


C Local variables                                                  
C A - rate for each equation                                       
      real*8 A(NREACT)

C Computation of equation rates                                    
      A(1) = RCONST(1)*V(13)
      A(2) = RCONST(2)*V(9)
      A(3) = RCONST(3)*V(16)
      A(4) = RCONST(4)*V(3)
      A(5) = RCONST(5)*V(8)
      A(6) = RCONST(6)*V(6)
      A(7) = RCONST(7)*V(6)
      A(8) = RCONST(8)*V(5)
      A(9) = RCONST(9)*V(14)
      A(10) = RCONST(10)*V(14)
      A(11) = RCONST(11)*V(7)
      A(12) = RCONST(12)*V(15)*V(16)
      A(13) = RCONST(13)*V(11)*V(15)
      A(14) = RCONST(14)*V(10)*V(15)
      A(15) = RCONST(15)*V(12)*V(13)
      A(16) = RCONST(16)*V(9)*V(12)
      A(17) = RCONST(17)*V(13)*V(16)
      A(18) = RCONST(18)*V(14)*V(15)
      A(19) = RCONST(19)*V(13)*V(14)
      A(20) = RCONST(20)*V(5)
      A(21) = RCONST(21)*V(7)*V(12)
      A(22) = RCONST(22)*V(11)*V(13)
      A(23) = RCONST(23)*V(7)
      A(24) = RCONST(24)*V(11)*V(16)
      A(25) = RCONST(25)*V(12)*V(16)
      A(26) = RCONST(26)*V(4)*V(12)
      A(27) = 1e-11*V(6)*V(12)
      A(28) = 5e-05*V(5)
      A(29) = RCONST(29)*V(2)*V(12)
      A(30) = RCONST(30)*V(11)*V(11)
      A(31) = RCONST(31)*V(3)*V(12)
      A(32) = RCONST(32)*V(8)*V(12)
      A(33) = RCONST(33)*V(8)*V(12)
      A(34) = RCONST(34)*V(10)*V(11)
      A(36) = RCONST(36)*F(4)

C Production function                                              
      P_VAR(1) = A(26)
      P_VAR(2) = 0
      P_VAR(3) = A(30)
      P_VAR(4) = A(6)+A(7)+A(27)
      P_VAR(5) = A(19)
      P_VAR(6) = A(5)+A(14)+A(33)
      P_VAR(7) = A(22)
      P_VAR(8) = A(34)
      P_VAR(9) = A(15)+2*A(28)
      P_VAR(10) = A(29)+A(32)
      P_VAR(11) = A(5)+2*A(6)+A(11)+A(14)+A(23)+A(25)+A(26)+A(27)
     *           +A(31)
      P_VAR(12) = A(2)+2*A(3)+2*A(4)+A(5)+A(13)+A(24)+A(33)+A(34)
      P_VAR(13) = A(2)+A(8)+A(9)+A(11)+A(12)+A(13)+A(14)+2*A(18)+A(20)
     *           +A(21)+A(23)
      P_VAR(14) = A(8)+A(16)+A(17)+A(20)
      P_VAR(15) = A(1)+A(10)+A(36)
      P_VAR(16) = A(1)+A(9)

C Destruction function                                             
      D_VAR(1) = 0
      D_VAR(2) = RCONST(29)*V(12)
      D_VAR(3) = RCONST(4)+RCONST(31)*V(12)
      D_VAR(4) = RCONST(26)*V(12)
      D_VAR(5) = RCONST(8)+RCONST(20)+5e-05
      D_VAR(6) = RCONST(6)+RCONST(7)+1e-11*V(12)
      D_VAR(7) = RCONST(11)+RCONST(21)*V(12)+RCONST(23)
      D_VAR(8) = RCONST(5)+RCONST(32)*V(12)+RCONST(33)*V(12)
      D_VAR(9) = RCONST(2)+RCONST(16)*V(12)
      D_VAR(10) = RCONST(14)*V(15)+RCONST(34)*V(11)
      D_VAR(11) = RCONST(13)*V(15)+RCONST(22)*V(13)+RCONST(24)*V(16)
     *           +RCONST(30)*2*V(11)+RCONST(34)*V(10)+RCONST(35)*V(12)
      D_VAR(12) = RCONST(15)*V(13)+RCONST(16)*V(9)+RCONST(21)*V(7)
     *           +RCONST(25)*V(16)+RCONST(26)*V(4)+1e-11*V(6)
     *           +RCONST(29)*V(2)+RCONST(31)*V(3)+RCONST(32)*V(8)
     *           +RCONST(33)*V(8)+RCONST(35)*V(11)
      D_VAR(13) = RCONST(1)+RCONST(15)*V(12)+RCONST(17)*V(16)
     *           +RCONST(19)*V(14)+RCONST(22)*V(11)
      D_VAR(14) = RCONST(9)+RCONST(10)+RCONST(18)*V(15)+RCONST(19)
     *           *V(13)
      D_VAR(15) = RCONST(12)*V(16)+RCONST(13)*V(11)+RCONST(14)*V(10)
     *           +RCONST(18)*V(14)
      D_VAR(16) = RCONST(3)+RCONST(12)*V(15)+RCONST(17)*V(13)
     *           +RCONST(24)*V(11)+RCONST(25)*V(12)
      RETURN
      END

C End of FSPLIT_VAR function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INITVAL - function to update initial concentrations              
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE INITVAL ( )

      INCLUDE 'tm_twostep.h'


      INTEGER i
      real*8 x

      x = (1.E-8)*CFACTOR
      do i = 1, NVAR
        VAR(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NRAD
        RAD(i) = x
      end do

      x = (1.E-8)*CFACTOR
      do i = 1, NFIX
        FIX(i) = x
      end do


      do i = 1, NSPEC
        C_DEFAULT(i) = C(i)
      end do

C User defined initialisations                                     

C End user defined initialisations                                 

      RETURN
      END

C End of INITVAL function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_SUN - update SUN light using TIME                         
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_SUN()

      INCLUDE 'tm_twostep.h'

      real*8 SunRise, SunSet
      real*8 Thour, Tlocal, Ttmp 
   
      SunRise = 4.5
      SunSet  = 19.5
      Thour = TIME/3600.
      Tlocal = Thour - (int(Thour)/24)*24

      IF ((Tlocal.GE.SunRise).AND.(Tlocal.LE.SunSet)) THEN
        Ttmp = (2.0*Tlocal-SunRise-SunSet)/(SunSet-SunRise)
        IF (Ttmp.GT.0) THEN
          Ttmp =  Ttmp*Ttmp
        ELSE
          Ttmp = -Ttmp*Ttmp
        END IF
        SUN = ( 1.0 + COS(PI*Ttmp) )/2.0 
      ELSE
        SUN=0.0
      END IF

      RETURN
      END

C End of UPDATE_SUN function                                       
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_RCONST - function to update rate constants                
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_RCONST ( )

      INCLUDE 'tm_twostep.h'


      real*8 ARR, A, B
c--- cut here ---
      real*8 fnoxemi,rjf(36,11)
      common /foto_file/ rjf,fnoxemi
      real*8 RT,ZTREC,ZT3REC,RX1_15,RX2_15,RX1_16,RX3_16,RX4_16,
     +RX1_19,RX2_19,RX1_20,RX1_22,RX2_22,RX1_23,RX1_26,RX1_30,rodm,j3,
     +ZF3BOD,ZFARR
      integer ISTEP
C THIS IS THE FUNCTION FOR THE 3-BODY REACTIONS
      ZF3BOD(A,B)=A/(1.0+A/B)*
     + 0.6**(1.0/(1.0+LOG10(A/B)**2))
c also used:
      ARR(A,B) = A * EXP(B/TEMP)
      ZFARR(A,B,RT)=A*EXP(B*RT)
C needed airdensity M [molec/cm3] H2O [molec/cm3] temp in degree celcius
      ZTREC=1./TEMP
      ZT3REC=300./TEMP
      RX1_15=2.6E-30*ZT3REC**3.2*Fix(I_M)
      RX2_15=2.4E-11*ZT3REC**1.3
      RX1_16=ARR(7.2E-15,785.0)
      RX3_16=ZFARR(1.9E-33,725.0,ZTREC)
      RX4_16=ZFARR(4.1E-16,1440.0,ZTREC)
      RX1_16=RX1_16+RX3_16*Fix(I_M)/(1.0+RX3_16*Fix(I_M)/RX4_16)
      RX1_19=2.2E-30*ZT3REC**3.9*Fix(I_M)
      RX2_19=1.5E-12*ZT3REC**0.7
      RX1_20=ZF3BOD(RX1_19,RX2_19)/(4.E-27*EXP(10930.0*ZTREC))
      RX1_22=1.8E-31*ZT3REC**3.2*Fix(I_M)
      RX2_22=4.7E-12*ZT3REC**1.4
      RX1_23= ZF3BOD(RX1_22,RX2_22)/(2.1E-27*EXP(10900.0*ZTREC))
      RX1_26=1.5E-13*(1.0+0.6*PRESS/101325.0) ! (PRESSURE IN Pa)
      RX1_30=(ARR(2.3E-13,600.0)+ARR(1.7E-33*Fix(I_M),1000.0))
     +*(1.0+Fix(I_H2O)*ARR(1.4E-21,2200.0))
      ISTEP = MOD(int(TIME/2400.0),36)+1
c note j3 is an effective photolysis rate for ozone given by the real
c photolysis to O1D (j3) 
      rodm=0.2094*ARR(3.2E-11,70.0)+.7808*ARR(1.8E-11,110.0)
      j3= RJF(ISTEP,3)*2.2E-10*Fix(I_H2O)/
     +(rodm*Fix(I_M)+2.2E-10*Fix(I_H2O))
c--- end ---

      RCONST(1) = (RJF(ISTEP,1))
      RCONST(2) = (RJF(ISTEP,2))
      RCONST(3) = (j3)
      RCONST(4) = (RJF(ISTEP,4))
      RCONST(5) = (RJF(ISTEP,5))
      RCONST(6) = (RJF(ISTEP,6))
      RCONST(7) = (RJF(ISTEP,7))
      RCONST(8) = (RJF(ISTEP,8))
      RCONST(9) = (RJF(ISTEP,9))
      RCONST(10) = (RJF(ISTEP,10))
      RCONST(11) = (RJF(ISTEP,11))
      RCONST(12) = (ARR(2.E-12,-1400.0))
      RCONST(13) = (ARR(3.7E-12,250.0))
      RCONST(14) = (ARR(4.2E-12,180.0))
      RCONST(15) = (ZF3BOD(RX1_15,RX2_15))
      RCONST(16) = (RX1_16)
      RCONST(17) = (ARR(1.2E-13,-2450.0))
      RCONST(18) = (ARR(1.5E-11,170.0))
      RCONST(19) = (ZF3BOD(RX1_19,RX2_19))
      RCONST(20) = (RX1_20)
      RCONST(21) = (ARR(1.3E-12,380.0))
      RCONST(22) = (ZF3BOD(RX1_22,RX2_22))
      RCONST(23) = (RX1_23)
      RCONST(24) = (ARR(1.1E-14,-500.0))
      RCONST(25) = (ARR(1.6E-12,-940.0))
      RCONST(26) = (RX1_26)
      RCONST(29) = (ARR(2.9E-12,-1820.0))
      RCONST(30) = (RX1_30)
      RCONST(31) = (ARR(2.9E-12,-160.0))
      RCONST(32) = (0.7*ARR(3.8E-12,200.0))
      RCONST(33) = (0.3*ARR(3.8E-12,200.0))
      RCONST(34) = (ARR(3.8E-13,800.0))
      RCONST(35) = (ARR(4.8E-11,250.0))
      RCONST(36) = (fnoxemi)
      RETURN
      END

C End of UPDATE_RCONST function                                    
C **************************************************************** 


C **************************************************************** 
C                                                                  
C UPDATE_C - update concentrations for transport                   
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      SUBROUTINE UPDATE_C ( )

      INCLUDE 'tm_twostep.h'


      RETURN
      END

C End of UPDATE_C function                                         
C **************************************************************** 


C **************************************************************** 
C                                                                  
C GETMASS - function that compute total mass of selected atoms     
C   Parameters :                                                   
C      MASS      - value of mass balance                           
C                                                                  
C **************************************************************** 

      SUBROUTINE GETMASS ( MASS )

      INCLUDE 'tm_twostep.h'

C MASS - value of mass balance                                     
      real*8 MASS(1)

      RETURN
      END

C End of GETMASS function                                          
C **************************************************************** 


C **************************************************************** 
C                                                                  
C INTEGRATE - Integrator routine                                   
C   Parameters :                                                   
C      DT        - Integration interval                            
C                                                                  
C **************************************************************** 

      subroutine CNT_INTEGRATE(pdt,dtstart,paccept,preject,pfcn,pjac)
      external iter
      INCLUDE 'tm_twostep.h'
      integer NUMIT,naccpt,nrejec,nfcn,paccept,preject,pfcn,pjac
     +,method,nstart
      real*8 VOLD(NVAR),VNEW(NVAR),yp(NVAR),yl(NVAR),sum(NVAR)
     +,dtstart,pdt

      method = 0
      NUMIT = 2 
      call TWOSTEP(NVAR,Time,Time+pdt,dtstart,STEPMIN,STEPMAX,
     +                   VOLD,Var,VNEW,yp,yl,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart)

      paccept = paccept + naccpt
      preject = preject + nrejec
      pfcn    = pfcn    + nfcn

      end

      subroutine TWOSTEP(n,t,te,startdt,dtmin,dtmax,
     +                   yold,y,ynew,yp,yl,sum,
     +                   atol,rtol,method,numit,
     +                   nfcn,naccpt,nrejec,nstart)
      integer	 n,method,numit,nfcn,naccpt,nrejec,nstart,i,j
      real*8	 t,te,dt,dtmin,dtmax,startdt,ytol,
     +           ratio,dtold,a1,a2,c,cp1,dtg,errlte
      real*8     yold(n),y(n),ynew(n),yp(n),yl(n),
     +           sum(n),atol(n),rtol(n)
      logical 	 accept,failer,restart

c======================================================================
c
c     AUTHOR: Jan Verwer, Centre for Mathematics and Computer Science 
c(CWI), Kruislaan 413, 1098 SJ Amsterdam, The Netherlands
c
c     EMAIL ADDRESS: janv@cwi.nl
c
c----------------------------------------------------------------------
c
c     VERSION: November 1994 / 2
c
c----------------------------------------------------------------------
c
c     PURPOSE: TWOSTEP is designed for the numerical solution of
c     stiff ODE systems
c
c	dy(t)/dt = yp(t,y) - yl(y,t)*y(t)
c
c     originating from atmospheric chemistry. Its underlying integration
c     method is the implicit, 2-nd order, 2-step BDF formula. A simple 
c     explicit Gauss-Seidel technique is used for approximating the 
c     implicitly defined BDF solutions, rather than the usual modified 
c     Newton method [1,2]. By this approach TWOSTEP is explicit, whereas
c     the excellent stability of the BDF method is maintained. Also the
c     Jacobi technique may be appropriate. In general, however, its use
c     generally decreases the stability of TWOSTEP and hence also the
c     efficiency.
c
c     While in the prototype solver discussed in [1] the number of 
c     iterations is determined by a convergence criterion, TWOSTEP 
c     works with a fixed, a priori given number of iterations. This
c     leads to a somewhat simpler code and in various experiments
c     this more simple strategy has turned out to be as efficient as 
c     the iteration strategy [2]. In fact, TWOSTEP may work well with
c     only a few iterations per integration step. In this situation
c     TWOSTEP has a workload comparable to explicit solvers based
c     on the quasi-steady-state-approach(QSSA) [3]. Note that when
c     a few Gauss-Seidel iterations are used, the order of the components
c     generally will influence the accuracy. To our experience this
c     influence is minor.
c 
c     [1] J.G. Verwer, Gauss-Seidel iteration for stiff ODEs from
c     chemical kinetics, SIAM Journal on Scientific Computing 15,
c     1243 - 1250, 1994.
c
c     [2] J.G. Verwer & D. Simpson, A comparison between two explicit
c     methods for stiff ODEs from atmospheric chemistry. Report
c     NM-R9414, CWI, Amsterdam, 1994(to appear in Appl. Numer. Math.).
c
c     [3] J.G. Verwer & M. van Loon,  An evaluation of explicit pseudo-
c     steady-state approximation schemes for stiff ODE systems from
c     chemical kinetics, J. Comput. Phys. 113, 347 - 352, 1994.
c
c----------------------------------------------------------------------
c
c     MEANING OF PARAMETERS:
c
c     n       - Integer. Number of components.
c     t	      - Real. The independent variable time.
c     te      - Real. The endpoint of time.
c     dt      - Real. The stepsize.
c     dtmin   - Real. A minimum for dt.
c     dtmax   - Real. A maximum for dt.
c     yold    - Real array(n). Solution at previous time point.
c     y       - Real array(n). Solution at current time point.
c     ynew    - Real array(n). Solution at forward time point.
c     yp      - Real array(n). Storage for the production term.
c     yl      - Real array(n). Storage for the loss term.
c     sum     - Real array(n). Workarray for the BDF2 method.
c     atol    - Real array(n). Absolute tolerances.
c     rtol    - Real array(n). Relative tolerances.
c     method  - Integer. Determines whether Gauss-Seidel or Jacobi
c               iteration is used; method only occurs as parameter
c               of subroutine ITER.
c     numit   - Integer. Number of Gauss-Seidel or Jacobi iterations.
c     nfcn    - Integer. The total number of(function) calls of ITER.
c     naccpt  - Integer. The number of accepted integration steps.
c     nrejec  - Integer. The number of rejected integration steps.
c     nstart  - Integer. The number of restarts + 1.
c     startdt - Real. The last computed starting stepsize.
c
c----------------------------------------------------------------------
c
c     STORAGE: 9 REAL arrays of dimension n.
c
c----------------------------------------------------------------------
c
c     INPUT:      
c
c     n	      - Number of components.
c     t       - Initial time; t is changed.
c     te      - The endpoint of time.
c     dtmin   - The minimal stepsize that TWOSTEP is allowed to use. 
c     dtmax   - The maximal stepsize that TWOSTEP is allowed to use. 
c
c               If on input dtmin = dtmax, then dt:=dtmin and dt is kept
c               fixed throughout the integration, possibly except for
c               the final step where dt may be adjusted to precisely hit
c               the end point te. So, the length of the interval need not be
c               an integer multiple of the selected stepsize.
c
c               If dtmin = dtmax, the stepsize control is switched off.
c               The user thus should ascertain that the integration
c               process remains stable for the selected stepsize. 
c
c               If dtmax > dtmin, then stepsize control is carried out
c               and TWOSTEP determines an initial stepsize itself. However,
c               the control and the initial stepsize selection can be
c               overruled to satisfy the constraint dtmin <= dt <= dtmax.
c
c     y       - Initial solution vector; y is changed.
c     atol    - Absolute tolerances.
c     rtol    - Relative tolerances.
c     method  - method = 0 for the Gauss-Seidel technique.
c               method = 1 for the Jacobi technique.
c
c               The Gauss-Seidel technique is recommended. The user 
c               must program the selected technique in his own
c               subroutine ITER which defines also the ODE system
c           (see below for an example).
c
c     numit   - The number of Gauss-Seidel(or Jacobi iterations) used
c               per time step. This number thus is a priori described
c               for the whole integration. A low number is recommended
c               for Gauss-Seidel iteration [1,2].
c
c               Note that for the Gauss-Seidel technique the order of 
c               the components within ITER will play a role. It is
c               recommended to order the components in decreasing
c               of the loss rates for the very short living species
c               like the radicals. 
c
c----------------------------------------------------------------------
c
c     OUTPUT:      
c
c     t       - t = te.
c     dtold   - The last stepsize value used when working with
c		variable stepsizes.
c     dt      - The last stepsize used to hit the endpoint te
c               when working with constant stepsizes.
c     y       - The computed solution at t = te.
c     nfcn, naccpt, nrejec, nstart, startdt - See MEANING of parameters.
c
c----------------------------------------------------------------------
c
c     SUBROUTINES:
c
c     TWOSTEP calls three subroutines, viz. NEWDT, FIT and ITER. Only
c     subroutine ITER is to be defined by the user.
c
c     NEWDT  - Computes the new stepsize. NEWDT itself calls FIT.
c     FIT    - May adjust dt to guarantee that the remainder
c              of the integration interval is an integer multiple of
c              the current stepsize. The adjustment is carried as soon 
c              as(te-t)/dt <= 10.0. Hence the adjustment may lead to
c              a stepsize smaller than dtmin for approximately
c              ten integration steps.
c     ITER   - A user defined routine for the ODE system. Within ITER
c              also the Gauss-Seidel or Jacobi technique is to be 
c              implemented by the user, as exemplified below:
c
c              subroutine ITER(t,method,n,y,sum,gdt,yp,yl)
c              integer    method,n,i,
c              REAL       t,y(n),sum(n),gdt,yp(n),yl(n)
c
c              if(method.eq.0) then
c              --------------------------------------------------
c              The following statements show how to program the
c              Gauss-Seidel technique. Note that array y is
c              changed. The ispec integers define the order
c              in which the components are processed.       
c              -------------------------------------------------
c              i=ispec1
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              i=ispe 
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c
c              etcetera
c           
c              else if(method.eq.1) then
c              ------------------------------------------------
c              This shows how to implement the Jacobi technique.
c              Now the order of the components is irrelevant.
c              Note that again y is changed, but only in the
c              second do-loop.
c              ------------------------------------------------
c              for i=1,n
c              yp(i)= USER DEFINED(t,y)
c              yl(i)= USER DEFINED(t,y)
c              enddo
c
c              for i=1,n
c              y(i)=(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i))
c              enddo
c              endif
c              end of ITER
c
c----------------------------------------------------------------------
c
c     EXAMPLE PROGRAM:
c
c     Example program for a 4-species problem based on the three 
c     basic reactions
c
c     	NO2 + hv  ->(k1)  NO + O,  
c       O   + O2  ->(k2)  O3,
c       O3  + NO  ->(k3)  O2 + NO2.
c
c     Here, O = O(3P). Because the first reaction is photochemical
c     k1 depends on the time of the day. Sunrise is at 04.00 hours
c     and sunset at 20.00 hours. NO is emitted. Unit is mol./cm3.
c     Time is in sec. The reaction constants are defined in ITER,
c     like the components yp(i) of the production term and the
c     components yl(i) of the loss term. The integration interval
c     is [14400,417600]. Time=14400 sec. coincides with sunrise at day
c     one and time=417600 sec. coincides with sunset at day five.
c     Below, y(1)=O, y(2)=NO, y(3)=NO2 and y(4)=O3. Output is given
c     in hours at every 2 hours of the last 24 hours. 
c    
c      program    small chemistry
c      integer	  n,numit,nfcn,naccpt,nrejec,nstart,method,
c     +           i,itimeh,i24hrs,inhr
c      REAL  	  time,te,dt,dtmin,dtmax,startdt,timeh,timeod
c      parameter(n=4)
c      REAL       yold(n),y(n),ynew(n),yp(n),yl(n),atol(n),rtol(n),
c     +  	  sum(n)
c      external   ITER
c      time=14400.0
c      method=0
c      y(1)=0.0
c      y(2)=1.3e+08
c      y(3)=5.0e+11
c      y(4)=8.0e+11
c      numit=2
c      dtmin=1.0
c      dtmax=900.0
c      do 10 i=1,4
c       atol(i)=1.0
c       rtol(i)=1.0e-3
c   10 continue
c
cc     begin two hourly calculations 
c      do 40 inhr = 1,56
c       te = time + 7200.
c       call TWOSTEP(n,time,te,dt,dtmin,dtmax,
c    +              yold,y,ynew,yp,yl,sum,
c     +              atol,rtol,method,numit,
c     +              nfcn,naccpt,nrejec,nstart,startdt)
c       if(inhr.gt.43) then
c        timeh=time/3600
c        itimeh=timeh
c        i24hrs=itimeh/24+1
c        timeod=timeh-(i24hrs-1)*24
c        write(6,30) timeod,y(1),y(2),y(3),y(4)
c   30   format('      Hour = 'f5.2,'   Solution = '4(e9.4,'  '))
c       endif
c   40 continue
c      end
c
c      subroutine ITER(time,method,n,y,sum,gdt,yp,yl,v)
c      integer    method,n
c      REAL	  time,gdt,y(n),sum(n),yp(n),yl(n),v(n)
c      integer    i,itimeh,i24hrs
c      REAL       timeh,timeod,pi,k1,k2,k3,a,b,source,sec
c      logical    night
c
c      timeh=time/3600.0    
c      itimeh=timeh   
c      i24hrs=itimeh/24+1   
c      timeod=timeh-(i24hrs-1)*24.0  
c      pi=4.0*atan(1.0)   
c      sec=(sin((pi/16.0)*(timeod-4.0)))**0.2
c      a=.00001
c      b=-7.0
c      k2=1.0e+05
c      k3=1.0e-16
c      source=1.0e+06
c      night=(timeod.le.4.0.or.timeod.gt.20.0)
c      if(night) then
c       k1=1.0e-40
c      else
c       k1=a*exp(-b*sec)
c      endif
c
c      yp(1)=k1*y(3)
c      yl(1)=k2
c      i=1
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(2)=k1*y(3)+source
c      yl(2)=k3*y(4)
c      i=2
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(3)=k3*y(2)*y(4)
c      yl(3)=k1
c      i=3
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      yp(4)=k2*y(1)
c      yl(4)=k3*y(2)
c      i=4
c      y(i)=max(0.0,(sum(i)+gdt*yp(i))/(1.0+gdt*yl(i)))
c      end
c
c      The output of this example program reads:
c
c      Hour = 20.00   Solution = .1503E+02  .6666E+12  .1503E+12  .1150E+13  
c      Hour = 22.00   Solution = .4837E-33  .3404E+12  .4837E+12  .8162E+12  
c      Hour =  0.00   Solution = .6255E-33  .2058E+12  .6255E+12  .6744E+12  
c      Hour =  2.00   Solution = .7022E-33  .1363E+12  .7022E+12  .5977E+12  
c      Hour =  4.00   Solution = .7495E-33  .9618E+11  .7495E+12  .5504E+12  
c      Hour =  6.00   Solution = .1090E+04  .8191E+12  .3378E+11  .1266E+13  
c      Hour =  8.00   Solution = .1095E+04  .8442E+12  .1596E+11  .1284E+13  
c      Hour = 10.00   Solution = .1106E+04  .8561E+12  .1126E+11  .1289E+13  
c      Hour = 12.00   Solution = .1115E+04  .8644E+12  .1016E+11  .1290E+13  
c      Hour = 14.00   Solution = .1118E+04  .8703E+12  .1138E+11  .1288E+13  
c      Hour = 16.00   Solution = .1109E+04  .8728E+12  .1616E+11  .1284E+13  
c      Hour = 18.00   Solution = .1051E+04  .8636E+12  .3256E+11  .1267E+13  
c      Hour = 20.00   Solution = .1650E+02  .7383E+12  .1650E+12  .1135E+13  
c
c--------------------------------------------------------------------------
c
c     Initialization of counters, etc.

      naccpt=0
      nrejec=0
      nfcn=0
      nstart=0
      failer=.false.
      restart=.false.
      accept=.true.

c     Initial stepsize computation. 
    
      if(dtmin.eq.dtmax) then
       nstart=1
       dt=min(dtmin,(te-t)/2)
       goto 28
      endif
   25 nstart=nstart+1
      if (restart) then
         dt=max(dtmin,dt/10.0)
         call FIT(t,te,dt)
         dt=min(dt,(te-t)/2)
      else
	 dt=startdt
      endif
      restart=.true.

c     The starting step is carried out, using the implicit Euler method.

   28 do 30 i=1,n
       ynew(i)=y(i)
       yold(i)=y(i)
       sum(i)=y(i)
   30 continue
      do 40 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dt,yp,yl)
       nfcn=nfcn+1
   40 continue
      naccpt=naccpt+1
      t=t+dt
      do 50 j=1,n
       y(j)=ynew(j)
   50 continue

c     Subsequent steps are carried out with the two-step BDF method.

      dtold=dt
      ratio=1.0
   60 continue
      c=1.0/ratio
      cp1=c+1.0
      a1=((c+1.0)**2)/(c*c+2.0*c)
      a2=-1.0/(c*c+2.0*c)
      dtg=dt*(1.0+c)/(2.0+c)
      do 70 j=1,n
       sum(j)=a1*y(j)+a2*yold(j)
       ynew(j)=max(0.0,y(j)+ratio*(y(j)-yold(j)))
   70 continue
      do 80 i=1,numit
       call ITER(t+dt,method,n,ynew,sum,dtg,yp,yl)
       nfcn=nfcn+1
   80 continue

c     If stepsizes should remain equal, stepsize control is omitted.

      if(dtmin.eq.dtmax) then
       t=t+dtold
       naccpt=naccpt+1
       do 85 j=1,n
        yold(j)=y(j)
        y(j)=ynew(j)
   85  continue
       if(dt.ne.dtold) then
	t=t-dtold+dt
	goto 120
       endif
       dt=min(dtold,te-t)
       ratio=dt/dtold
       if(t.ge.te) goto 120
       goto 60
      endif

c     Otherwise stepsize control is carried out.

      errlte=0.0
      do 90 i=1,n
       ytol=atol(i)+rtol(i)*abs(y(i))
       errlte=max(errlte,abs(c*ynew(i)-cp1*y(i)+yold(i))/ytol)
   90 continue
      errlte=2.0*errlte/(c+c*c)
      call NEWDT(t,te,dt,dtold,ratio,errlte,accept,
     +           dtmin,dtmax)

c     Here the step has been accepted. 

      if(accept) then
       failer=.false.
       restart=.false.
       t=t+dtold
       naccpt=naccpt+1
       do 100 j=1,n
	yold(j)=y(j)
	y(j)=ynew(j)
  100  continue
       if(t.ge.te) goto 120
       goto 60
      endif

c     A restart check is carried out.
      
      if(failer) then
       nrejec=nrejec+1
       failer=.false.
       naccpt=naccpt-1
       t=t-dtold
       do 110 j=1,n
        y(j)=yold(j)
  110  continue
       goto 25
      endif

c     Here the step has been rejected.

      nrejec=nrejec+1
      failer=.true.
      goto 60
      
c     End of TWOSTEP.
  120 end
c=====================================================================

      subroutine NEWDT(t,te,dt,dtold,ratio,errlte,
     +                 accept,dtmin,dtmax)
      real*8    t,te,dt,dtold,ratio,errlte,ts,dtmin,dtmax
      logical accept
      if(errlte.gt.1.0.and.dt.gt.dtmin) then
       accept=.false.
       ts=t
      else
       accept=.true.
       dtold=dt
       ts=t+dtold
      endif
      dt=max(0.5,min(2.0,0.8/sqrt(errlte)))*dt
      dt=max(dtmin,min(dt,dtmax))
      call FIT(ts,te,dt)
      ratio=dt/dtold
      end

      subroutine FIT(t,te,dt)
      real*8 	t,te,dt,rns
      integer 	ns
      rns=(te-t)/dt
      if(rns.gt.10.0) goto 10
      ns=int(rns)+1
      dt=(te-t)/ns
      dt=(dt+t)-t
   10 return
      end
C End of INTEGRATE function                                        
C **************************************************************** 


C **************************************************************** 
C                                                                  
C MAIN - Main program - driver routine                             
C   Parameters :                                                   
C                                                                  
C **************************************************************** 

      program TMchemie
c__________________________________________________________________
c     *airchem* - routine for day- and nighttime chemistry
c
c     interface: *airchem* is called from *prechem*
c__________________________________________________________________
c
c written by:
C Frank Dentener, LU Wageningen
c email dentener@WS2.LUVO.WAU.NL
c translation to KPP by:
c Edwin Spee, CWI, Amsterdam
c email Edwin.Spee@cwi.nl
c last update: 1996 may 29.
      include 'tm_twostep.h'
      integer pcspec,nrx,inpx,iinpx,idum,i3,ist,nstep,isp,i1
     +,i,Naccept,Nreject,Nfcn,Njac
      parameter (nrx=11,pcspec=6)
      real*8 fnoxemi,pc(pcspec),rjf(36,nrx),timeold,dtstart
      common /foto_file/ rjf,fnoxemi
      character*10 chdum
c
      character*40 case(15)
      data case/
     &'1  summer / 45 degrees / 1000 mbar / polluted',
     &'2  summer / 45 degrees /  500 mbar / polluted',
     &'3  summer / 45 degrees /  250 mbar',
     &'4  summer / 45 degrees / 1000 mbar / background',
     &'5  summer / 45 degrees /  500 mbar / background',
     &'6  winter / 45 degrees / 1000 mbar / polluted',
     &'7  winter / 45 degrees /  500 mbar',
     &'8  winter / 45 degrees /  250 mbar',
     &'9  winter / 45 degrees / 1000 mbar / background',
     &'10  tropics / 1000 mbar / polluted',
     &'11  tropics /  500 mbar / polluted',
     &'12  tropics /  250 mbar / polluted',
     &'13  tropics / 1000 mbar / background',
     &'14  tropics /  500 mbar / background',
     &'15  tropics /  250 mbar / background'/
    
      open (unit=2,file='fx.nd')
      open (unit=3,file='solution.out')
c
c    initial
c
      nstep=180
      write (3,*) nstep
      inpx = 1
      write(3,*)  'case',case(inpx)
      DT = 2400.0
      fnoxemi = 1.0E6
      write(*,'(1x,a17,1pe9.3,1x,a10)')
     &     'nox emission is: ',fnoxemi,' molec/cm3'
      print *,'timestep= ',DT,' s'
   23 continue
      inpx=inpx-1
      do 22 iinpx=1,inpx
c loop to put pointer in unit 2 on right position
         read (2,*) idum
         read (2,*) (pc(isp),isp=1,pcspec)
         read (2,*) TEMP,DENS,FIX(I_M),FIX(I_H2O),PRESS
         do 21 i1=1,36
            read (2,'(a)') chdum
            read (2,*) (rjf(i1,i3),i3=1,nrx)
   21    continue
   22 continue
      read (2,*) idum
      read (2,*) (pc(isp),isp=1,pcspec)
c
c - - -
c      set concentrations for time 0
c
      do 101 i = 1,NVAR
	 VAR(i)=0.0
  101 continue
      VAR(i_ch4)=pc(1)
      VAR(i_co)=pc(2)
      VAR(i_hno3)=pc(3)
      VAR(i_h2o2)=pc(4)
      VAR(i_no2)=pc(5)
      VAR(i_o3)=pc(6)

      read (2,*) TEMP,DENS,FIX(I_M),FIX(I_H2O),PRESS
      do 210 i1=1,36
         read (2,'(a)') chdum
         read (2,*) (rjf(i1,i3),i3=1,nrx)
  210 continue
      close(unit=2)
      FIX(I_O2) = 0.209476*FIX(I_M)
      FIX(I_SOURCE) = 1.0 ! tricky.
    
      write (3,*) 'fortran output     time(s)'
      write (3,*) 'ch4 ch3o ch3o2 ch3o2h ch2o co'
      write (3,*) 'oh  ho2  h2o2  no     no2  hno3'
      write (3,*) 'o3   o1d no3   n2o5 hno4'
      TIME=0.0
      CALL to_file(time)
      print *, 'give integrator parameters:'
      print *, 'dtmin,dtstart,dtmax,atol,rtol = '
   20 read *, STEPMIN,dtstart,STEPMAX,ATOL(1),RTOL(1)
      if (STEPMIN.lt.0.0) goto 20
      if (STEPMAX.lt.STEPMIN) goto 20
      if (ATOL(1).lt.1e-11) goto 20
      if (RTOL(1).lt.1e-11) goto 20
      STEPMAX=min(DT,STEPMAX)
      do 102 i=2,NSPEC
         ATOL(i)=ATOL(1)
         RTOL(i)=RTOL(1)
  102 continue
c
c     1. start loop
c
      Naccept = 0
      Nreject = 0
      Nfcn = 0
      Njac = 0
      do 61 ist=1,nstep   
	 timeold = TIME
	 TIME = TIME + 0.5 * DT
	 CALL UPDATE_RCONST()
	 TIME = timeold
	 CALL CNT_INTEGRATE(DT,dtstart,Naccept,Nreject,Nfcn,Njac)
	 CALL to_file(TIME)
   61 continue
     
      close(unit=3)
      print *, 'Naccept = ',Naccept
      print *, 'Nreject = ',Nreject
      print *, 'Nfcn    = ',Nfcn
      print *, 'Njac    = ',Njac
      end

      subroutine to_file(t)
      include 'tm_twostep.h'
      real*8 t,pm1,pm2,totn,totc
   73 format(f10.1)
      write (3,73) t
c pm1 and pm2 for reasons of compatibility
      pm1=VAR(i_no)+VAR(i_no2)+VAR(i_no3)+VAR(i_pna)+2*VAR(i_n2o5)
      pm2=VAR(i_no2)+2.*VAR(i_no3)+3.*VAR(i_n2o5)+VAR(i_o3)
      totn=pm1+VAR(i_hno3)
      totc=VAR(i_ch4)+ VAR(i_co)+VAR(i_ch3o2)+VAR(i_mep)+VAR(i_hcho)
     ++VAR(i_co2)
      call to_file6(VAR(i_ch4),0.0,VAR(i_ch3o2),VAR(i_mep),
     &            VAR(i_hcho),VAR(i_co))
      call to_file6(VAR(i_oh),VAR(i_ho2),VAR(i_h2o2),VAR(i_no),
     &            VAR(i_no2),VAR(i_hno3))
      call to_file6(VAR(i_o3),0.0,VAR(i_no3),VAR(i_n2o5),VAR(i_pna),
     &pm1)
      call to_file4(pm2,totn,totc,VAR(i_co2))
      end
c
      subroutine to_file6(a1,a2,a3,a4,a5,a6)
   72 format (6(e16.10,' '))
      real*8 a1,a2,a3,a4,a5,a6,a(6)
      integer i
      a(1)=a1
      a(2)=a2
      a(3)=a3
      a(4)=a4
      a(5)=a5
      a(6)=a6
      do 100 i = 1,6
	if (a(i).lt.1.1e-99) a(i) = 0.0
  100 continue
      write(3,72) a(1),a(2),a(3),a(4),a(5),a(6)
      end

      subroutine to_file4(a1,a2,a3,a4)
   72 format (4(e16.10,' '))
      real*8 a1,a2,a3,a4,a(6)
      integer i
      a(1)=a1
      a(2)=a2
      a(3)=a3
      a(4)=a4
      do 100 i = 1,4
	if (a(i).lt.1.1e-99) a(i) = 0.0
  100 continue
      write(3,72) a(1),a(2),a(3),a(4)
      end
C End of MAIN function                                             
C **************************************************************** 


      SUBROUTINE ITER(t,method,n,V,sum,gdt,P_VAR,D_VAR)

      INCLUDE 'tm_twostep.h'
      integer n,method
      real*8  t,sum(nvar),gdt

C V - Concentration of variable species                            
      real*8 V(NVAR)
C P_VAR - Production term                                          
      real*8 P_VAR(NVAR)
C D_VAR - Destruction term                                         
      real*8 D_VAR(NVAR)

c valid for:
C  1 = CO2 (n)     7 = PNA (r)    13 = NO2 (r)   
C  2 = CH4 (r)     8 = MEP (r)    14 = NO3 (r)   
C  3 = H2O2 (r)    9 = HNO3 (r)   15 = NO (r)    
C  4 = CO (r)     10 = CH3O2 (r)  16 = O3 (r)    
C  5 = N2O5 (r)   11 = HO2 (r)   
C  6 = HCHO (r)   12 = OH (r)    

C Computation of equation rates                                    
C Production function                                              
C Gauss-Seidel iteration:
      P_VAR(1) = RCONST(26)*V(4)*V(12)
      V(1)=max(0.d0,(sum(1)+gdt*P_VAR(1)))
      D_VAR(2) = RCONST(29)*V(12)
      V(2)=max(0.d0,sum(2)/(1.0+gdt*D_VAR(2)))
      P_VAR(3) = RCONST(30)*V(11)*V(11)
      D_VAR(3) = RCONST(4)+RCONST(31)*V(12)
      V(3)=max(0.d0,(sum(3)+gdt*P_VAR(3))/(1.0+gdt*D_VAR(3)))
      D_VAR(4) = RCONST(26)*V(12)
      P_VAR(4) = RCONST(6)*V(6)+RCONST(7)*V(6)+1e-11*V(6)*V(12)
      V(4)=max(0.d0,(sum(4)+gdt*P_VAR(4))/(1.0+gdt*D_VAR(4)))
      P_VAR(5) = RCONST(19)*V(13)*V(14)
      D_VAR(5) = RCONST(8)+RCONST(20)+5e-05
      V(5)=max(0.d0,(sum(5)+gdt*P_VAR(5))/(1.0+gdt*D_VAR(5)))
      P_VAR(6) = RCONST(5)*V(8)+RCONST(14)*V(10)*V(15)
     ++RCONST(33)*V(8)*V(12)
      D_VAR(6) = RCONST(6)+RCONST(7)+1e-11*V(12)
      V(6)=max(0.d0,(sum(6)+gdt*P_VAR(6))/(1.0+gdt*D_VAR(6)))
      P_VAR(7) = RCONST(22)*V(11)*V(13)
      D_VAR(7) = RCONST(11)+RCONST(21)*V(12)+RCONST(23)
      V(7)=max(0.d0,(sum(7)+gdt*P_VAR(7))/(1.0+gdt*D_VAR(7)))
      P_VAR(8) = RCONST(34)*V(10)*V(11)
      D_VAR(8) = RCONST(5)+RCONST(32)*V(12)+RCONST(33)*V(12)
      V(8)=max(0.d0,(sum(8)+gdt*P_VAR(8))/(1.0+gdt*D_VAR(8)))
      P_VAR(9) = RCONST(15)*V(12)*V(13)+2*5e-05*V(5)
      D_VAR(9) = RCONST(2)+RCONST(16)*V(12)
      V(9)=max(0.d0,(sum(9)+gdt*P_VAR(9))/(1.0+gdt*D_VAR(9)))
      P_VAR(10) = RCONST(29)*V(2)*V(12)+RCONST(32)*V(8)*V(12)
      D_VAR(10) = RCONST(14)*V(15)+RCONST(34)*V(11)
      V(10)=max(0.d0,(sum(10)+gdt*P_VAR(10))/(1.0+gdt*D_VAR(10)))
      D_VAR(11) = RCONST(13)*V(15)+RCONST(22)*V(13)+RCONST(24)*V(16)
     *           +RCONST(30)*2*V(11)+RCONST(34)*V(10)+RCONST(35)*V(12)
      P_VAR(11) = RCONST(5)*V(8)+2*RCONST(6)*V(6)+RCONST(11)*V(7)
     ++RCONST(14)*V(10)*V(15)+RCONST(23)*V(7)+RCONST(25)*V(12)*V(16)
     ++RCONST(26)*V(4)*V(12)+1e-11*V(6)*V(12)+RCONST(31)*V(3)*V(12)
      V(11)=max(0.d0,(sum(11)+gdt*P_VAR(11))/(1.0+gdt*D_VAR(11)))
      P_VAR(12) = RCONST(2)*V(9)+2*RCONST(3)*V(16)+2*RCONST(4)*V(3)
     ++RCONST(5)*V(8)+RCONST(13)*V(11)*V(15)+RCONST(24)*V(11)*V(16)
     ++RCONST(33)*V(8)*V(12)+RCONST(34)*V(10)*V(11)
      D_VAR(12) = RCONST(15)*V(13)+RCONST(16)*V(9)+RCONST(21)*V(7)
     *           +RCONST(25)*V(16)+RCONST(26)*V(4)+1e-11*V(6)
     *           +RCONST(29)*V(2)+RCONST(31)*V(3)+RCONST(32)*V(8)
     *           +RCONST(33)*V(8)+RCONST(35)*V(11)
      V(12)=max(0.d0,(sum(12)+gdt*P_VAR(12))/(1.0+gdt*D_VAR(12)))
      P_VAR(13) = RCONST(2)*V(9)+RCONST(8)*V(5)+RCONST(9)*V(14)
     ++RCONST(11)*V(7)+RCONST(12)*V(15)*V(16)+RCONST(13)*V(11)*V(15)
     ++RCONST(14)*V(10)*V(15)+2*RCONST(18)*V(14)*V(15)+RCONST(20)*V(5)
     *+RCONST(21)*V(7)*V(12)+RCONST(23)*V(7)
      D_VAR(13) = RCONST(1)+RCONST(15)*V(12)+RCONST(17)*V(16)
     *           +RCONST(19)*V(14)+RCONST(22)*V(11)
      V(13)=max(0.d0,(sum(13)+gdt*P_VAR(13))/(1.0+gdt*D_VAR(13)))
      P_VAR(14) = RCONST(8)*V(5)+RCONST(16)*V(9)*V(12)
     ++RCONST(17)*V(13)*V(16)+RCONST(20)*V(5)
      D_VAR(14) = RCONST(9)+RCONST(10)+RCONST(18)*V(15)+RCONST(19)
     *           *V(13)
      V(14)=max(0.d0,(sum(14)+gdt*P_VAR(14))/(1.0+gdt*D_VAR(14)))
      P_VAR(15) = RCONST(1)*V(13)+RCONST(10)*V(14)+RCONST(36)*F(4)
      D_VAR(15) = RCONST(12)*V(16)+RCONST(13)*V(11)+RCONST(14)*V(10)
     *           +RCONST(18)*V(14)
      V(15)=max(0.d0,(sum(15)+gdt*P_VAR(15))/(1.0+gdt*D_VAR(15)))
      P_VAR(16) = RCONST(1)*V(13)+RCONST(9)*V(14)
      D_VAR(16) = RCONST(3)+RCONST(12)*V(15)+RCONST(17)*V(13)
     *           +RCONST(24)*V(11)+RCONST(25)*V(12)
      V(16)=max(0.d0,(sum(16)+gdt*P_VAR(16))/(1.0+gdt*D_VAR(16)))

      RETURN
      END
